package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class AddPropertyDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextField tf;
	JTextArea ta;
	String separator;
	String prop_value;
	DefaultMutableTreeNode dmtn;
	String prop_name;

	JButton selButton;
	KnowledgeBase kb;
    NCIEditTab tab;

    Collection c = null;

    public AddPropertyDialog(NCIEditTab tab, KnowledgeBase kb, DefaultMutableTreeNode dmtn)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add Property", true);
		this.dmtn = dmtn;
		this.kb = kb;
		this.tab = tab;
		this.prop_name = "";
		this.prop_value = "";
	}

    public AddPropertyDialog(NCIEditTab tab, KnowledgeBase kb, DefaultMutableTreeNode dmtn,
           Collection c)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add Property", true);
		this.dmtn = dmtn;
		this.kb = kb;
		this.tab = tab;
		this.prop_name = "";
		this.prop_value = "";
		this.c = c;
	}

    public AddPropertyDialog(NCIEditTab tab, KnowledgeBase kb, DefaultMutableTreeNode dmtn,
           String propertyname)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add Property", true);
		this.dmtn = dmtn;
		this.kb = kb;
		this.tab = tab;
		this.prop_name = propertyname;
		this.prop_value = "";
		this.c = c;
	}


	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new GridBagLayout());

		JPanel topPanel = new JPanel();
		topPanel.setLayout(new BorderLayout());
		selButton = new JButton("Property");
		selButton.addActionListener(this);

		tf = new JTextField("");

		if (prop_name.compareTo("") != 0)
		{
			selButton.setEnabled(false);
			tf.setText(prop_name);
		}

		tf.setEditable(false);

		tf.setPreferredSize(new Dimension (160, 20));

		topPanel.add(selButton, BorderLayout.WEST);
        topPanel.add(tf, BorderLayout.EAST);

		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(topPanel, gridbagconstraints1);

        JPanel midPanel = new JPanel();
        midPanel.setLayout(new BorderLayout());

		JLabel label2 = new JLabel("Value: ");

		ta = new JTextArea("");
		boolean wrap = true;
		ta.setLineWrap(wrap);
		JScrollPane valuePane = new JScrollPane(ta);
		valuePane.setPreferredSize(new Dimension (200, 100));
		midPanel.add(label2, BorderLayout.NORTH);
		midPanel.add(valuePane, BorderLayout.CENTER);
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(midPanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints2 = new GridBagConstraints();
		gridbagconstraints2.gridx = 0;
		gridbagconstraints2.gridy = 2;
		contain.add(buttonPanel, gridbagconstraints2);

		pack();
		this.setVisible(true);
   	}

    public String getPropertyName()
    {
		return prop_name;
	}

    public String getPropertyValue()
    {
		return prop_value;
	}

	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			String s = tf.getText().trim();
			if (!s.equals("")){
				//dmtn.setUserObject((Object) prop_name + ": " + s);
				prop_name = tf.getText();
				prop_value = ta.getText();

				dispose();
			}
		} else if (action == selButton)	{
            Collection allowedSlots = c;
            if (allowedSlots == null)
            {
 				allowedSlots = new ArrayList(kb.getSlots());
		    }

			Slot slot = DisplayUtilities.pickSlot(selButton, allowedSlots, "Select Property");

			if (slot == null)
			{
				System.out.println("slot == null");
			}
			else
			{
				tf.setText(slot.getName());
			}

		} else if (action == cancelButton)
			dispose();
	}

}

