package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protege.widget.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.ui.*;


import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.InstanceDisplay;
import edu.stanford.smi.protege.util.*;
import edu.stanford.smi.protege.widget.ClsWidget;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.cls.*;
import edu.stanford.smi.protegex.owl.ui.clsdesc.DisjointClassesWidget;
import edu.stanford.smi.protegex.owl.ui.conditions.ConditionsWidget;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourceDisplay;
import edu.stanford.smi.protegex.owl.ui.subsumption.InferredSubsumptionTreePanel;
import edu.stanford.smi.protegex.owl.ui.widget.WidgetUtilities;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protege.resource.*;

import java.io.*;
import java.sql.Connection;
import java.util.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import edu.stanford.smi.protegex.owl.model.RDFSClass;

import edu.stanford.smi.protegex.owl.model.OWLProperty;

////////
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.*;
import edu.stanford.smi.protegex.owl.ui.components.annotations.*;
import edu.stanford.smi.protegex.owl.ui.conditions.*;
import edu.stanford.smi.protegex.owl.ui.icons.*;
import edu.stanford.smi.protegex.owl.ui.owltable.*;
import edu.stanford.smi.protegex.owl.ui.restrictions.*;
import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;


import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.components.triples.*;
import javax.swing.border.*;


import javax.swing.table.DefaultTableModel;
import edu.stanford.smi.protegex.owl.ui.actions.*;

import edu.stanford.smi.protegex.owl.ui.actions.DeletePropertyAction;

import edu.stanford.smi.protegex.owl.ui.actions.ResourceAction;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;

//053006
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditorManager;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protegex.owl.ui.metadata.AnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditor;

import edu.stanford.smi.protegex.owl.ui.metadata.DateAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.DateTimeAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.TimeAnnotationsWidgetPlugin;


import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class EditPanel extends JPanel implements ActionListener
{


	EditTypeFormAction editTypeFormAction = null;//new EditTypeFormAction(resource);

	// 012707
	//EditTypeAction editTypeAction = null;//new EditTypeAction(resource);

	private static Set plugins = new HashSet();

	//060106
	JTextArea desc_ta;
	JComboBox syn_group_combo, source_combo, def_group_combo;

	JPanel qualifier_panel;

    private static final String SUBCLASSOF = "rdfs:subClassOf";

    static final int TYPE_UNKNOWN = -1;
	static final int TYPE_SPLIT = 0;
	static final int TYPE_PREMERGE = 1;
	static final int TYPE_MERGE = 2;
	static final int TYPE_PRERETIRE = 3;
	static final int TYPE_RETIRE = 4;

	static final int TYPE_CLONE = 5;

    Vector associationNames = null;

	Instance selectedInstance;

	protected JPopupMenu m_popup;
	protected Action m_action;
	protected TreePath m_clickedPath;

    protected JTree edit_tree;
    JScrollPane treeView;
    int selected_tab;

    DropTarget dt;

    DefaultTreeModel model;

    public Cls droppedCls = null;

    //Rename
    JDialog renamePopUpDialogBox;
    JButton renameCancelButton;

    EditPanel thisTree;
    OWLModel kb;

    Vector initialState = null;
    Vector finalState = null;

    NCIEditTab tab;

    String code = null;
    String name = null;

    String newname = null;

    private boolean canDrop;

    public int type;

    HashSet hset;

    private OWLWrapper wrapper;

    QuickSortVecStrings sort = null;

    Vector nonEditableProperties;

    private Vector inboundRoles;
    private Vector oldSubclasses;

    private Vector old_child_vec = null;
    private Vector old_source_role_vec = null;


    public boolean isNew;
    private Instance instance = null;

    private InstanceNameComponent name_panel = null;

    JButton reviewButton_Modify = null;
	JButton saveButton_Modify = null;
	JButton cancelButton_Modify = null;
	JButton newButton_Modify = null;
	JButton deleteButton_Modify = null;

	private JLabel codeLabel = null;

	JTabbedPane tabbedPane_Modify = null;

	//NCIAnnotationsTableModel model_1 = null;  // full_syn
	//NCIAnnotationsTable anno_table_1 = null;

	NCIFULLSYNTableModel model_1 = null;  // full_syn
	NCIFULLSYNTable anno_table_1 = null;


	NCIAnnotationsTableModel model_2 = null;  // definition
	NCIAnnotationsTable anno_table_2 = null;

	NCIAnnotationsTableModel model_3 = null;  // simple property
	NCIAnnotationsTable anno_table_3 = null;

    NCIAnnotationsTableModel model_4 = null;  // association (object-valued properties)
	NCIAnnotationsTable anno_table_4 = null;

    NCIAnnotationsTableModel model_5 = null;  // complex property
	NCIAnnotationsTable anno_table_5 = null;

///////////////////////////////////////////////////

    NCIConditionsTableModel cond_model_1 = null;  // restriction
	NCIConditionsTable cond_table_1 = null;

    NCIConditionsTableModel cond_model_2 = null;  // superconcepts
	NCIConditionsTable cond_table_2 = null;

    JPanel modify_panel = null;
    boolean newBtn = true;

    boolean isModified = false;

    NCIQualifierTableModel qualifier_model_1 = null;
	NCIQualifierTable qualifier_table_1 = null;


    NCIQualifierTableModel qualifier_model = null;
	NCIQualifierTable qualifier_table = null;

	JLabel ptLabel;
	JTextField ptTextField;

	int qualifier_model_id = -1;

    // 6: restriction
    // 7: named superclass
	JButton hb_add_1, hb_add_2, hb_add_3, hb_add_4, hb_add_5, hb_add_6, hb_add_7;
	JButton hb_delete_1, hb_delete_2, hb_delete_3, hb_delete_4, hb_delete_5, hb_delete_6, hb_delete_7;
	JButton hb_edit_1, hb_edit_2, hb_edit_3, hb_edit_4, hb_edit_5, hb_edit_6, hb_edit_7;


    OWLNamedClass focusCls = null;

    String initial_preferred_name = null;

    boolean hasDEFINITION = true;

    LabeledComponent topComponent = null;

    boolean canDelete = true;

    String AdvancedQuery;

//int my_test_selection;

    public EditPanel(NCIEditTab tab,
                      Instance selectedInstance,
                      OWLModel kb)
    {
		super();
		this.newBtn = true;
        this.tab = tab;
        this.wrapper = tab.getWrapper();

        this.kb = kb;
        this.instance = selectedInstance;

        AdvancedQuery="";

        if (selectedInstance != null && selectedInstance instanceof OWLNamedClass)
        {
			focusCls = (OWLNamedClass) selectedInstance;
		}

		//053006
		addPlugin(new DateAnnotationsWidgetPlugin());
		addPlugin(new DateTimeAnnotationsWidgetPlugin());
		addPlugin(new TimeAnnotationsWidgetPlugin());

        initialize();
    }


	//120606
    public EditPanel(NCIEditTab tab,
                      Instance selectedInstance,
                      OWLModel kb,
                      String AdvancedQuery)
    {
		super();
		this.newBtn = true;
        this.tab = tab;
        this.wrapper = tab.getWrapper();

        this.kb = kb;
        this.AdvancedQuery = AdvancedQuery;
        this.instance = selectedInstance;
        if (selectedInstance != null && selectedInstance instanceof OWLNamedClass)
        {
			focusCls = (OWLNamedClass) selectedInstance;
		}

		//053006
		addPlugin(new DateAnnotationsWidgetPlugin());
		addPlugin(new DateTimeAnnotationsWidgetPlugin());
		addPlugin(new TimeAnnotationsWidgetPlugin());

        initialize();
    }

    public OWLNamedClass getFocusClass()
    {
		return focusCls;
	}

    public void setFocusClass(OWLNamedClass cls)
    {
		focusCls = cls;
	}


    public EditPanel(NCIEditTab tab,
                     Instance selectedInstance,
                     OWLModel kb,
                     boolean newBtn)
    {
		super();
		this.newBtn = newBtn;
        this.tab = tab;
        this.wrapper = tab.getWrapper();

        this.kb = kb;
        this.instance = selectedInstance;

        AdvancedQuery="";

        if (selectedInstance != null)
        {
			focusCls = (OWLNamedClass) selectedInstance;
		}
		//053006
		addPlugin(new DateAnnotationsWidgetPlugin());
		addPlugin(new DateTimeAnnotationsWidgetPlugin());
		addPlugin(new TimeAnnotationsWidgetPlugin());

        initialize();
    }


    public NCIEditTab getNCIEditTab()
    {
	    return tab;
	}

	public OWLWrapper getOWLWrapper()
	{
		return wrapper;
	}

	public void setAdvancedQuery(String AdvancedQuery)
	{
		this.AdvancedQuery = AdvancedQuery;
	}

    public void updateAll()
    {
		updateAll(false);
	}

    public void updateAll(boolean no_focus)
    {
		if (wrapper == null)
		{
			System.out.println("WARNING: wrapper == null");
			return;
		}
        code = "";

        Instance selectedInstance = getSelectedInstance();
        if (selectedInstance == null)
        {
			selectedInstance = focusCls;
		}

		//120606
		if (AdvancedQuery.equals("AdvancedQuery"))
		{
			selectedInstance = focusCls;
		}

        String preferred_name = "";
		if (selectedInstance != null && selectedInstance instanceof OWLNamedClass)
		{
			try {
				instance = selectedInstance;
				focusCls = (OWLNamedClass) selectedInstance;
		    } catch (Exception ex) {
			}

			name_panel.setInstance(selectedInstance);
			code = wrapper.getCode((Cls) selectedInstance);

			preferred_name = getObjectValue(wrapper.getSlotValue((Cls) selectedInstance,
			    getSlotName(NCIEditTab.PREFERRED_NAME)));

/*
			if (tab.getCurrentTab() == 0)
			{
				//if (tab.getEventListener() != null )
				if (tab.getEventListener() != null && !AdvancedQuery.equals("AdvancedQuery"))
				{
					tab.addToListenedToClses((OWLNamedClass) selectedInstance);
			    }
			}
*/

			if (code != null)
			{
				code = OWLWrapper.getPlainString(code);
				if (code.compareTo("0") != 0)
				{
					codeLabel.setText("   code: " + code + "   ");
			    }
			    else
			    {
					codeLabel.setText("");
				}
		    }
		    else
		    {
				codeLabel.setText("");
			}

			// 091406
			Cls cls = (Cls) selectedInstance;
			if (topComponent != null && cls != null)
			{
				String id = wrapper.getInternalName(cls);
				topComponent.setHeaderLabel("Class:  " + id);
		    }

		    if (no_focus)
		    {
				topComponent.setHeaderLabel("Class:  ");
			}

			if (preferred_name != null)
			{
				String pt = getObjectValue(preferred_name);
				ptTextField.setText(getObjectValue(preferred_name));
				initial_preferred_name = preferred_name;
		    }
		    else
		    {
				ptTextField.setText("");
				initial_preferred_name = null;
			}

			ptTextField.setEditable(true);
			if (!wrapper.isEditable(focusCls))
			{
				ptTextField.setEditable(false);
			}

		    Slot ptSlot = wrapper.getSlot(getSlotName(NCIEditTab.PREFERRED_NAME));
			if (ptSlot == null)
			{
				ptTextField.setEnabled(false);
				ptTextField.setEditable(false);
			}

			qualifier_model_1.initialize();
			qualifier_model.initialize();

			model_1.setSubject((RDFResource) instance);

            // 080506
            if (hasDEFINITION)
            {
				model_2.setSubject((RDFResource) instance);

				if (model_2.getRowCount() > 0)
				{
					anno_table_2.setRowSelectionInterval(0, 0);
					updateQualifierTable(model_2.get_qualifier_tblmodel_id());
				}
		    }

			model_3.setSubject((RDFResource) instance);
			model_4.setSubject((RDFResource) instance);
			model_5.setSubject((RDFResource) instance);

			cond_model_1.setCls((OWLNamedClass) instance);
			cond_model_2.setCls((OWLNamedClass) instance);

            newButton_Modify.setEnabled(true);
            reviewButton_Modify.setEnabled(true);
			saveButton_Modify.setEnabled(false);

            deleteButton_Modify.setEnabled(false);
			//101306
			if ((tab.isActionAllowed(NCIEditTab.EDIT_RETIRED_CLASS_ACTION) ||
				tab.isActionAllowed(NCIEditTab.DELETE_ACTION)) &&
				!isSystemCls())
			{
				canDelete = true;
				deleteButton_Modify.setEnabled(true);
			}

			cancelButton_Modify.setEnabled(false);
		}
		else
		{
			//System.out.println("selectedInstance == null");
			codeLabel.setText("");
		}
	}

    public OWLModel getOWLModel()
    {
		return kb;
	}

	private Project getProject()
	{
		return getOWLModel().getProject();
	}

	private Instance getSelectedInstance()
	{
		return tab.getSelectedInstance();
	}


	public RDFProperty getObjectProperty(String name)
	{
		if (name.compareTo(RDFSNames.Slot.IS_DEFINED_BY) == 0)
		{
			return (RDFProperty) kb.getSlot(RDFSNames.Slot.IS_DEFINED_BY);
		}
		else if (name.compareTo(OWLNames.Slot.SAME_AS) == 0)
		{
			return (RDFProperty) kb.getSlot(OWLNames.Slot.SAME_AS);
		}
		else if (name.compareTo(RDFSNames.Slot.SEE_ALSO) == 0)
		{
			return (RDFProperty) kb.getSlot(RDFSNames.Slot.SEE_ALSO);
		}
		else if (name.compareTo(kb.getOWLDifferentFromProperty().getBrowserText()) == 0
		      || name.compareTo(kb.getOWLEquivalentPropertyProperty().getBrowserText()) == 0
		      || name.compareTo(kb.getOWLDisjointWithProperty().getBrowserText()) == 0)

		{
			RDFProperty slot = (RDFProperty) kb.getRDFProperty(name);
			return slot;
	    }

		else
		{
			Collection allProperties = kb.getVisibleUserDefinedRDFProperties();
			Collection selectableProperties = new ArrayList();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (property.isAnnotationProperty()
				    && property.hasObjectRange()
				    && property instanceof DefaultOWLObjectProperty)
				{
					//if (property.getBrowserText().compareTo(name) == 0)
					if (property.getName().compareTo(name) == 0)
					{
						return property;
					}
				}
			}
		}
		return null;

	}


	private void modifyProperty(NCIAnnotationsTable table, NCIAnnotationsTableModel model) {

		int selIndex = table.getSelectedRow();
		if (selIndex == -1)
		{
			 if (model.getRowCount() > 0)
			 {
		     	 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
			 }
		     return;
	    }

		if (selIndex >= 0 && selIndex < model.getRowCount()) {

			String propertyname = model.getPropertyName(selIndex);
			//String propertyvalue = model.getPropertyValue(selIndex);

            if (!wrapper.canModify(propertyname))
            {
				 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, propertyname + " is read only.");
				 return;
			}

			table.setRowSelectionInterval(selIndex, selIndex);
			viewValue(table, model);

			table.setRowSelectionInterval(selIndex, selIndex);
			updateQualifierTable(model.get_qualifier_tblmodel_id());

		}
	}


	private void modifyProperty(NCIAnnotationsTable table, NCIAnnotationsTableModel model,
	    NCIQualifierTableModel qualifier_tblmodel) {
		int selIndex = table.getSelectedRow();

		if (selIndex == -1)
		{
			 if (model.getRowCount() > 0)
			 {
		     	 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
			 }
			 return;
	    }

		if (selIndex >= 0 && selIndex < model.getRowCount()) {

			table.setRowSelectionInterval(selIndex, selIndex);
			viewValue(table, model);

			table.setRowSelectionInterval(selIndex, selIndex);
			updateQualifierTable(model.get_qualifier_tblmodel_id());

		}
	}


    public void updateQualifierTable(int model_id)
    {
		if (model_id == 1)
		{
			updateQualifierTable(anno_table_2, model_2, qualifier_model_1);
		}
		else if (model_id == 2)
		{
			updateQualifierTable(anno_table_5, model_5, qualifier_model);
		}
	}





    public void dumpQualifierData(HashMap hmap) // key: qualifier name; value: qualifier value
    {
		 Set set = hmap.keySet();
		 Iterator it = set.iterator();
		 while (it.hasNext())
		 {
			 String key = (String) it.next();
			 String value = (String) hmap.get(key);

			 System.out.println("Qualifier: " + key);
			 System.out.println("Value: " + value);
		 }
	}

/*
	public void updateQualifierTable(NCIAnnotationsTable table, NCIAnnotationsTableModel model,
	                                  NCIQualifierTableModel qualifier_tblmodel) {
		int row = table.getSelectedRow();
		updateQualifierTable(table, model, qualifier_tblmodel, row);
	}
*/


	public void updateQualifierTable(NCIAnnotationsTable table, NCIAnnotationsTableModel model,
	                                  NCIQualifierTableModel qualifier_tblmodel) {

        if (table == null || model == null || qualifier_tblmodel == null) return;

		int row = table.getSelectedRow();
		if (model.getRowCount() > 0 && row == -1)
		{
			table.setRowSelectionInterval(0, 0);
			row = 0;
		}

		if (row >= 0 && row < model.getRowCount()) {
			Object value = model.getValue(row);
			if (model.isComplex())
			{
				value = model.get_Value(row);
			}

			if (value instanceof RDFResource) {
				//ProtegeUI.show((RDFResource) value);
			}
			else{
				RDFProperty property = model.getPredicate(row);
				RDFResource subject = model.getSubject();

				//String name = property.getBrowserText();
				String name = property.getName();

                if (name.equals(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.ALT_DEFINITION)))
                {
					HashMap hmap = null;
					if (value instanceof RDFSLiteral)
					{
						RDFSLiteral literal = (RDFSLiteral) value;
						hmap = ComplexPropertyParser.parseXML((String) literal.getString());
					}
					else
					{
						hmap = ComplexPropertyParser.parseXML((String) value);
					}
                    qualifier_tblmodel.setData(hmap);
                    qualifier_tblmodel.fireTableDataChanged();
			    }
			}
		}
	}

	/*
	public void updateQualifierTable(NCIAnnotationsTable table, NCIAnnotationsTableModel model,
	                                  NCIQualifierTableModel qualifier_tblmodel, int row) {

        if (table == null || model == null || qualifier_tblmodel == null) return;

		//int row = table.getSelectedRow();

		if (model.getRowCount() > 0 && row == -1)
		{
			table.setRowSelectionInterval(0, 0);
			row = 0;
		}

		if (row >= 0 && row < model.getRowCount()) {
			Object value = model.getValue(row);
			if (model.isComplex())
			{
				value = model.get_Value(row);
			}

			if (value instanceof RDFResource) {
				//ProtegeUI.show((RDFResource) value);
			}
			else{
				RDFProperty property = model.getPredicate(row);
				RDFResource subject = model.getSubject();

				//String name = property.getBrowserText();
				String name = property.getName();
                if (name.equals(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.DEFINITION)) ||
                    name.equals(tab.getSlotName(NCIEditTab.ALT_DEFINITION)))
                {
					HashMap hmap = null;
					if (value instanceof RDFSLiteral)
					{
						RDFSLiteral literal = (RDFSLiteral) value;
						hmap = ComplexPropertyParser.parseXML((String) literal.getString());
					}
					else
					{
						hmap = ComplexPropertyParser.parseXML((String) value);
					}
                    qualifier_tblmodel.setData(hmap);

			    }
			}
		}

		//qualifier_model_1.fireTableDataChanged();
		qualifier_tblmodel.fireTableDataChanged();

	}
    */

	private void modifyRestriction(NCIConditionsTable table, NCIConditionsTableModel model) {
		int selIndex = table.getSelectedRow();

		if (selIndex < 0)
		{
			 if (model.getRowCount() > 0)
			 {
		     	 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
			 }
			 return;
		}

		if (selIndex >= 0 && selIndex < model.getRowCount()) {

			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) model.getItem(selIndex);

			if (tableItem.isSeparator()) return;

			boolean defining = tableItem.isDefinition();

			if (tableItem.isInherited())
			{
				try {
					Object[] options = {"OK"};
					int ans = JOptionPane.showOptionDialog(tab, "Cannot modify inherited restriction.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}
			OWLClass aClass_old = (OWLClass) tableItem.getCls();

            boolean cancelBtnPressed = false;
            boolean dataEntryComplete = false;

			while (!cancelBtnPressed || !dataEntryComplete)
			{
			    final NCIRoleGroupEditorPanel rolegroupPanel = new NCIRoleGroupEditorPanel(tab, kb, model, focusCls, selIndex, aClass_old, defining);
                String label = "Roles (Simple Restrictions)";
				LabeledComponent lc = new LabeledComponent(label, rolegroupPanel);

				Action createRestrictionAction_1 =
						new AbstractAction("Create a Role (simple restriction)...",
								OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION)) {

					public void actionPerformed(ActionEvent e)
					{
						NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
							kb.getCls(OWLNames.Cls.SOME_VALUES_FROM_RESTRICTION),
							null, null, null);

						int ans = ModalDialog.showDialog(null, dlg, "Create a Role (simple restriction)", ModalDialog.MODE_OK_CANCEL);
						if (ans == ModalDialog.OPTION_OK)
						{
							OWLRestriction r = dlg.getResult();
							if (r != null)
							{
								if (itemExists(r.getBrowserText(), TreeItem.TYPE_RESTRICTION))
								{
									Component warning_label = new JLabel("Restriction already exists.");
									LabeledComponent lc2 = new LabeledComponent("", warning_label);
									int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
									return;
								}
								else
								{
									rolegroupPanel.getRoleGroupTableModel().addRow(r);
							    }
							}
						}
					}
				};

				//lc.addHeaderSeparator();
				JButton hb_add_6 = lc.addHeaderButton(createRestrictionAction_1);
				//////////////////////////////////////////////////////////////////////////////////////////////////

			    final String modify_label = "Modify a Restriction";
				Action modifyRestrictionAction_1 =
						new AbstractAction("Modify a role (simple restriction)...",
								NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e)
					{
						OWLRestriction r = null;
						boolean completed = false;

						int selIndex = rolegroupPanel.getRoleGroupTable().getSelectedRow();
						if (selIndex == -1) return;
                        r = rolegroupPanel.getRoleGroupTableModel().getRole(selIndex);

						RDFProperty p = r.getOnProperty();
						String prop_name = p.getName();
						String fillerText = r.getFillerText();
						String prop_modifier = wrapper.getRestrictionType(r);

						String label = wrapper.restrictionType2Label(prop_modifier);
						edu.stanford.smi.protege.model.Cls metaCls = wrapper.getMetaClsByName(label);

                        int group_number = rolegroupPanel.getRoleGroupTableModel().getRoleGroupNumber(selIndex);

						while (!completed)
						{
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
							NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
								metaCls, p, fillerText, null, r);

							int ans = ModalDialog.showDialog(null, dlg, modify_label, ModalDialog.MODE_OK_CANCEL);
							if (ans == ModalDialog.OPTION_OK)
							{
								r = dlg.getResult();
								if (r != null)
								{
									rolegroupPanel.getRoleGroupTableModel().updateRestriction(r, selIndex);

									completed = true;
									break;
								}
								else
								{
									try {
										Object[] options = {"OK"};
										int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
										JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
										null, options, options[0]);
										completed = false;
									}
									catch(Exception ex){
										Log.getLogger().log(Level.WARNING, "Exception caught", ex);
									}
								}
							}
							else
							{
								completed = true;
							}
						}
					}
				};

				lc.addHeaderSeparator();
				JButton hb_modify_6 = lc.addHeaderButton(modifyRestrictionAction_1);

//////////////////////////////////////////////////////////////////////////////////////////////////


				JButton hb_delete_6 = lc.addHeaderButton(new NCIDeleteRoleAction(rolegroupPanel, tab, rolegroupPanel.getRoleGroupTable()));

				int result = ModalDialog.showDialog(this, lc, "Edit a Restriction", ModalDialog.MODE_OK_CANCEL);

				if (result == ModalDialog.OPTION_OK)
				{
					RDFSClass restriction = rolegroupPanel.getRolegroups();
					if (restriction == null)
					{
						try {
							Object[] options = {"OK"};
							int ans = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
							JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
							null, options, options[0]);
							dataEntryComplete = false;
						}
						catch(Exception ex){
							Log.getLogger().log(Level.WARNING, "Exception caught", ex);
						}
					}
					else
					{
						// Process data
						HashMap hmap = rolegroupPanel.getRoleGroupTableModel().getRolegroups();
						//this seems to be the same as the restriction. Why do it again?
						//RDFSClass aClass = rolegroupPanel.roleGroupHash2RDFSClass(hmap);
						RDFSClass aClass = restriction.createClone();
						model.modifyRow(selIndex, (RDFSClass) aClass, rolegroupPanel.getIsDefining());
						enableSaveButton(true);
						break;
					}
				}
				else
				{
					break;
				}
			}

		}
	}

	private void modifySuperclass(NCIConditionsTable table, NCIConditionsTableModel model) {
		int selIndex = table.getSelectedRow();

        int num_rows = model.getRowCount();
		if (selIndex < 0)
		{
			 if (num_rows > 0)
			 {
		     	 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
			 }
			 return;
		}

		if (selIndex >= 0 && selIndex < model.getRowCount()) {
			String clsname = model.getTableItemName(selIndex);
            if (clsname != null && !wrapper.isEditable(clsname))
            {
				 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, clsname + " is read only.");
				 return;
			}


			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) model.getItem(selIndex);

			if (tableItem.isInherited())
			{
				try {
					Object[] options = {"OK"};
					int ans = JOptionPane.showOptionDialog(tab, "Cannot modify inherited restriction.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}

            //String name = tableItem.getCls().getBrowserText();
            String name = wrapper.getInternalName(tableItem.getCls());//.getBrowserText();

            String oldClsName = name;

			boolean defining = tableItem.getIsDefining();

            boolean definingEditable = true;

            //boolean definingEditable = true;
            //if (num_rows <= 3) definingEditable = false; // two separators plus a superclass
			ModifySuperclassDialog dlg
			   = new ModifySuperclassDialog(tab, name, tableItem.getCls(), defining, definingEditable);
			if (!dlg.cancelBtnPressed)
			{
				defining = false;
				if (dlg.definingCheckBox.isSelected())
				{
					defining = true;
				}

				//Boolean defining_obj = new Boolean(defining);

				if (dlg.getCls() != null)
				{
                    String clsName = wrapper.getInternalName(dlg.getCls());
					if (clsName.compareTo(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS)) == 0 ||
						clsName.compareTo(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS)) == 0 ||
						clsName.compareTo(tab.getClsName(NCIEditTab.PREMERGED_CONCEPTS)) == 0)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select " +  clsName + ".");
						return;
					}


					RDFSClass aClass = (RDFSClass) dlg.getCls();

					//model.modifyRow2(selIndex, aClass, dlg.getIsDefining());
					model.modifyRow(selIndex, aClass, dlg.getIsDefining());

					saveButton_Modify.setEnabled(true);
					cancelButton_Modify.setEnabled(true);
					//model.refresh();

				}
				else
				{
					try {
						Object[] options = {"OK"};
						int ans = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
						JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
						null, options, options[0]);
						return;
					}
					catch(Exception ex){
						Log.getLogger().log(Level.WARNING, "Exception caught", ex);
					}

				}
			}
		}
	}



	private void viewValue(NCIAnnotationsTable table, NCIAnnotationsTableModel model) {
		final int row = table.getSelectedRow();
		viewValue(row, table, model);
	}


    private String[] getAllowableValues(RDFProperty property)
    {
		try {
			boolean rangeDefined = property.isRangeDefined();
			if (!rangeDefined) return null;
			boolean includingSuperproperties = false;
			Vector v = new Vector();
			Collection c = property.getRanges(includingSuperproperties);
			for(Iterator iterator = c.iterator(); iterator.hasNext();){
				Object value = (Object) iterator.next();
				Collection values = ((OWLDataRange) value).getOneOf().getValues();
				if (values.size() > 0)
				{
					for(Iterator iterator2 = values.iterator(); iterator2.hasNext();){
						Object value2 = (Object) iterator2.next();
						v.add(value2.toString());
					}
				}
			}
			Object[] objs = v.toArray();
			String[] allowedvalues = new String[objs.length];

			for (int i=0; i<objs.length; i++)
			{
				allowedvalues[i] = (String) objs[i];
			}
			return allowedvalues;
	    } catch (Exception e) {
			return null;
		}
	}


	private void viewValue(final int row, NCIAnnotationsTable table, NCIAnnotationsTableModel model) {

		Object value = model.getValue(row);
		if (model.isComplex())
		{
			value = model.get_Value(row);
		}

		if (value instanceof RDFResource) {
			ProtegeUI.show((RDFResource) value);
		}

		else{

			RDFProperty property = model.getPredicate(row);
			RDFResource subject = model.getSubject();
			String name = property.getName();



			if (name.equals(tab.getSlotName(NCIEditTab.DEFINITION)) ||
				name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) ||
				name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION2)) ||
				name.equals(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) ||
				name.equals(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) ||
				name.equals(tab.getSlotName(NCIEditTab.ALT_DEFINITION)))
			{

				CustomizedAnnotationDialog dialog
					= new CustomizedAnnotationDialog(this, name, value, row, model);


			}else{
				LabeledComponent lc = null;
				JTextArea textArea = null;
				JList valueList = null;
				String[] allowedvalues = getAllowableValues(property);
				if (allowedvalues != null)
				{
					valueList = ComponentFactory.createList(null);
					valueList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

					Arrays.sort(allowedvalues);
					java.util.List list = Arrays.asList(allowedvalues);
					valueList.setListData(list.toArray());

					//valueList.setSelectedIndex(0);
					String propertyvalue = model.getPropertyValue(row);
					boolean shouldScroll = true;
					valueList.setSelectedValue((Object) propertyvalue, shouldScroll);
					int selIndex = valueList.getSelectedIndex();
					valueList.ensureIndexIsVisible(selIndex);
					boolean isAdjusting = true;
					valueList.setSelectedIndex(selIndex);

					JScrollPane comp = new JScrollPane(valueList);

					String label = property.getBrowserText();
					lc = new LabeledComponent(label, comp);

					lc.setPreferredSize(new Dimension(400, 120));
				}
				else
				{
					textArea = new JTextArea(value.toString());
					textArea.setLineWrap(true);
					textArea.setWrapStyleWord(true);

					Component comp = new JScrollPane(textArea);
					lc = new LabeledComponent(property.getBrowserText(), comp);
			    }

				lc.setPreferredSize(new Dimension(400, 120));
				int r = ProtegeUI.getModalDialogFactory().showDialog(this, lc, "Edit Annotation", ModalDialogFactory.MODE_OK_CANCEL);
				if (r == ModalDialogFactory.OPTION_OK) {
					String newValue = null;
					if (allowedvalues != null)
					{
						newValue = (String) valueList.getSelectedValue();
					}
					else
					{
						newValue = textArea.getText();
					}

					if (newValue.compareTo("") == 0)
					{
						Component warning_label = new JLabel("Property value is mandatory.");
						LabeledComponent lc2 = new LabeledComponent("", warning_label);
						int k = ProtegeUI.getModalDialogFactory().showDialog(this, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
					}
					else
					{
						table.getSelectionModel().setSelectionInterval(row, row);
						model.resetValue(name, value, newValue);
						//model.setValue(newValue, row);
						enableSaveButton(true);
					}
				}
			}
		}
	}


	private void editFULLSYNTable(NCIFULLSYNTable table, NCIFULLSYNTableModel model) {
		int selIndex = table.getSelectedRow();
		if (selIndex < 0)
		{
			 if (model.getRowCount() > 0)
			 {
		     	 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
			 }
			 return;
		}

		if (selIndex >= 0 && selIndex < model.getRowCount()) {
			editFULLSYN(selIndex, model);
		}
	}


	private void editFULLSYN(final int row, NCIFULLSYNTableModel model) {

		Object value = model.getValue(row);
		if (value instanceof RDFResource) {
			ProtegeUI.show((RDFResource) value);
		}
		else{
			RDFProperty property = model.getPredicate(row);
			RDFResource subject = model.getSubject();

			//String name = property.getBrowserText();
			String name = property.getName();
			//name = Character.toUpperCase(name.charAt(0)) + name.substring(1);

			CustomizedAnnotationDialog dialog =
				new CustomizedAnnotationDialog(this, name,
				   value, row, model);
		}
	}


	public static void addPlugin(AnnotationsWidgetPlugin plugin) {
		for (Iterator it = plugins.iterator(); it.hasNext();) {
			AnnotationsWidgetPlugin p = (AnnotationsWidgetPlugin) it.next();
			if (p.getClass() == plugin.getClass()) {
				return;
			}
		}
		plugins.add(plugin);
	}



	private JPanel createClassTabbedPane() {
		JPanel panel = new JPanel(false);
		ImageIcon icon = new ImageIcon("images/middle.gif");

		tabbedPane_Modify = new JTabbedPane();
        JPanel panel_1 = new JPanel();
        panel_1.setLayout(new BorderLayout());

		tabbedPane_Modify.addTab("Basic Data", icon, panel_1, "");

//----------------------------------------------- FULL_SYN

        RDFResource subject = (RDFResource) getSelectedInstance();

		//120606
		if (AdvancedQuery.equals("AdvancedQuery"))
		{
			subject = (RDFResource) focusCls;
		}


		Vector userDefinedRelevantProperties = new Vector();

        Collection allowed_properties = new ArrayList();
        Slot full_syn_slot = tab.getPropertySlot(NCIEditTab.FULL_SYN);
        if (full_syn_slot != null)
        {
			allowed_properties.add(full_syn_slot);
			//userDefinedRelevantProperties.add(full_syn_slot.getBrowserText());
			userDefinedRelevantProperties.add(full_syn_slot.getName());
		}
		else
		{
System.out.println("WARNING: Cannot find FULL_SYN property -- allowed_properties is empty");

		}



		model_1 = new NCIFULLSYNTableModel(this, subject, userDefinedRelevantProperties);
		anno_table_1 = new NCIFULLSYNTable(getProject(), model_1, "");

		LabeledComponent lc1_1
		   = new LabeledComponent("FULL SYNs", new JScrollPane(anno_table_1));


		Action modifyFULLSYNAction =
				new AbstractAction("Modify selected annotation",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						editFULLSYNTable(anno_table_1, model_1);
					}
				};

		hb_add_1 = lc1_1.addHeaderButton(new NCICreateFULLSYNAction(tab, model_1, allowed_properties));
		hb_edit_1 = lc1_1.addHeaderButton(modifyFULLSYNAction);
		hb_delete_1 = lc1_1.addHeaderButton(new NCIDeletePropertyAction(tab, anno_table_1));

//----------------------------------------------- DEFINITION

        String[] columnNames = new String[2];
        columnNames[0] = "Name";
        columnNames[1] = "Value";

		qualifier_model_1 = new NCIQualifierTableModel(columnNames);
		qualifier_table_1 = new NCIQualifierTable(qualifier_model_1);


		userDefinedRelevantProperties = new Vector();

		allowed_properties = new ArrayList();

        hasDEFINITION = false;
		Slot definitionSlot = tab.getPropertySlot(NCIEditTab.DEFINITION);
		if (definitionSlot != null)
		{
			userDefinedRelevantProperties.add(tab.getSlotName(NCIEditTab.DEFINITION));
			hasDEFINITION = true;
			allowed_properties.add(definitionSlot);

		}
		else
		{
System.out.println("WARNING: Cannot find definition Slot.");

		}


		model_2 = new NCIAnnotationsTableModel(kb, this, subject, userDefinedRelevantProperties,
		   1, 2);
		model_2.setModelType(NCIAnnotationsTableModel.COMPLEX_PROPERTY_MODEL);
        model_2.setHasPropertyColumn(false);

		anno_table_2 = new NCIAnnotationsTable(getProject(), model_2, "");
		model_2.setTable(anno_table_2);

		LabeledComponent lc7
		   = new LabeledComponent("Qualifiers", new JScrollPane(qualifier_table_1));

		anno_table_2.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 1) {
					updateQualifierTable(anno_table_2, model_2, qualifier_model_1);
				}

			}
		});

        anno_table_2.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                updateQualifierTable(anno_table_2, model_2, qualifier_model_1);
            }
        });

        /*
        anno_table_2.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
				if (!e.getValueIsAdjusting() && e.getFirstIndex()==e.getLastIndex()){
				//if (!e.getValueIsAdjusting())
            	    updateQualifierTable(anno_table_2, model_2, qualifier_model_1, e.getFirstIndex());
				}

            }
        });
        */

		LabeledComponent lc1_2
		   = new LabeledComponent("Definitions", new JScrollPane(anno_table_2));

		Action modifyDEFINITIONAction =
				new AbstractAction("Modify selected annotation",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						modifyProperty(anno_table_2, model_2, qualifier_model_1);
					}
				};


        hb_add_2 = lc1_2.addHeaderButton(new NCICreateDEFINITIONAction(tab, model_2, allowed_properties, 2));


        hb_edit_2 = lc1_2.addHeaderButton(modifyDEFINITIONAction);
        hb_delete_2 = lc1_2.addHeaderButton(new NCIDeletePropertyAction(tab, anno_table_2, qualifier_model_1, 2));


		JSplitPane splitPane_7 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,lc1_2,lc7);
 		splitPane_7.setDividerLocation(200); //150
 		splitPane_7.setOneTouchExpandable(true);


 		JSplitPane splitPane_1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,lc1_1,splitPane_7);
 		splitPane_1.setOneTouchExpandable(true);
 		splitPane_1.setDividerLocation(180);

 		panel_1.add(splitPane_1,BorderLayout.CENTER);


////////////////////////////////////////////////////////////////////////////////////////////
// relations
////////////////////////////////////////////////////////////////////////////////////////////

        JPanel panel_2 = new JPanel();
        panel_2.setLayout(new BorderLayout());
		tabbedPane_Modify.addTab("Relations", icon, panel_2, "");

		Slot slot = kb.getSlot(Model.Slot.DIRECT_SUPERCLASSES);

///////////////
// Restrictions
///////////////

		cond_model_1 = new NCIConditionsTableModel((OWLNamedClass) subject, slot,
		                   NCIConditionsTableModel.SET_RESTRICTION, this);
		cond_table_1 = new NCIConditionsTable(getOWLModel(), cond_model_1);

		Action createRestrictionAction_1 =
				new AbstractAction("Create a restriction ...",
						OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION)) {

					String role_name = "";
					String role_value = "";
					String role_modifier = "";
					boolean isDefining = false;
					OWLRestriction restriction = null;

					public void actionPerformed(ActionEvent e)
					{
						boolean cancelBtnPressed = false;
						boolean dataEntryComplete = false;

						while (!cancelBtnPressed || !dataEntryComplete)
						{
						    final NCIRoleGroupEditorPanel rolegroupPanel = new NCIRoleGroupEditorPanel
						 	   (tab, kb, cond_model_1, -1, null);
						 	String label = "Roles (Simple Restrictions)";
						 	LabeledComponent lc = new LabeledComponent(label, rolegroupPanel);

                            final String create_label = "Create a Restriction";
							Action createRestrictionAction_1 =
									new AbstractAction("Create a role (simple restriction)...",
											OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION)) {

								public void actionPerformed(ActionEvent e)
								{
									OWLRestriction r = null;
									boolean completed = false;

									while (!completed)
									{
										NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
											kb.getCls(OWLNames.Cls.SOME_VALUES_FROM_RESTRICTION),
											null, null, null);

										int ans = ModalDialog.showDialog(null, dlg, create_label, ModalDialog.MODE_OK_CANCEL);
										if (ans == ModalDialog.OPTION_OK)
										{
											r = dlg.getResult();
											if (r != null)
											{
                                                if (itemExists(r.getBrowserText(), TreeItem.TYPE_RESTRICTION))
												{
													Component warning_label = new JLabel("Restriction already exists.");
													LabeledComponent lc2 = new LabeledComponent("", warning_label);
													int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
													completed = false;
												}
												else
												{
													rolegroupPanel.getRoleGroupTableModel().addRow(r);
													completed = true;
												}
												break;
											}
											else
											{
												try {
													Object[] options = {"OK"};
													int ans2 = JOptionPane.showOptionDialog(tab, "Invalid filler value or incomplete data entry.", "Confirmation",
													JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
													null, options, options[0]);
													completed = false;
												}
												catch(Exception ex){
													Log.getLogger().log(Level.WARNING, "Exception caught", ex);
												}
											}
										}
										else
										{
											completed = true;
										}
								    }
								}
							};

							//lc.addHeaderSeparator();
							JButton hb_add_6 = lc.addHeaderButton(createRestrictionAction_1);


							//////////////////////////////////////////////////////////////////////////////////////////////////

						   final String modify_label = "Modify a Restriction";
							Action modifyRestrictionAction_1 =
									new AbstractAction("Modify a role (simple restriction)...",
											NCIOWLIcons.getImageIcon("edit")) {

								public void actionPerformed(ActionEvent e)
								{
									OWLRestriction r = null;
									boolean completed = false;


									int selIndex = rolegroupPanel.getRoleGroupTable().getSelectedRow();
									if (selIndex == -1) return;

									r = rolegroupPanel.getRoleGroupTableModel().getRole(selIndex);

									RDFProperty p = r.getOnProperty();
									String prop_name = p.getName();

									String fillerText = r.getFillerText();
									String prop_modifier = wrapper.getRestrictionType(r);

									String label = wrapper.restrictionType2Label(prop_modifier);
									edu.stanford.smi.protege.model.Cls metaCls = wrapper.getMetaClsByName(label);

									int group_number = rolegroupPanel.getRoleGroupTableModel().getRoleGroupNumber(selIndex);

									while (!completed)
									{
										NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
											metaCls,
											p, fillerText, null);


										int ans = ModalDialog.showDialog(null, dlg, modify_label, ModalDialog.MODE_OK_CANCEL);
										if (ans == ModalDialog.OPTION_OK)
										{
											r = dlg.getResult();
											if (r != null)
											{
												System.out.println(r.getBrowserText());
												//rolegroupPanel.getRoleGroupTableModel().addRow(r);

												rolegroupPanel.getRoleGroupTableModel().updateRestriction(r, selIndex);

												completed = true;
												break;
											}
											else
											{
												try {
													Object[] options = {"OK"};
													int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
													JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
													null, options, options[0]);
													completed = false;
												}
												catch(Exception ex){
													Log.getLogger().log(Level.WARNING, "Exception caught", ex);
												}
											}
										}
										else
										{
											completed = true;
										}
									}
								}
							};

							lc.addHeaderSeparator();
							JButton hb_modify_6 = lc.addHeaderButton(modifyRestrictionAction_1);

			                //////////////////////////////////////////////////////////////////////////////////////////////////



/*
//////////////////////////////////////////////////////////////////////////////////////////////////

                           final String modify_label = "Modify a Restriction";
							Action modifyRestrictionAction_1 =
									new AbstractAction("Modify a role (simple restriction)...",
											NCIOWLIcons.getImageIcon("edit")) {

								public void actionPerformed(ActionEvent e)
								{
									OWLRestriction r = null;
									boolean completed = false;

									while (!completed)
									{
										NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
											kb.getCls(OWLNames.Cls.SOME_VALUES_FROM_RESTRICTION),
											null, null, null);

										int ans = ModalDialog.showDialog(null, dlg, modify_label, ModalDialog.MODE_OK_CANCEL);
										if (ans == ModalDialog.OPTION_OK)
										{
											r = dlg.getResult();
											if (r != null)
											{
												rolegroupPanel.getRoleGroupTableModel().addRow(r);
												completed = true;
												break;
											}
											else
											{
												try {
													Object[] options = {"OK"};
													int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
													JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
													null, options, options[0]);
													completed = false;
												}
												catch(Exception ex){
													Log.getLogger().log(Level.WARNING, "Exception caught", ex);
												}
											}
										}
										else
										{
											completed = true;
										}
								    }
								}
							};

							lc.addHeaderSeparator();
							JButton hb_modify_6 = lc.addHeaderButton(modifyRestrictionAction_1);

							//////////////////////////////////////////////////////////////////////////////////////////////////
*/
                            lc.addHeaderSeparator();
							JButton hb_delete_6 = lc.addHeaderButton(new NCIDeleteRoleAction(rolegroupPanel, tab, rolegroupPanel.getRoleGroupTable()));
                            //String label = "Create Restriction";

                            int result = ModalDialog.showDialog(null, lc, create_label, ModalDialog.MODE_OK_CANCEL);

                            if (result == ModalDialog.OPTION_OK)
                            {
                                RDFSClass restriction = rolegroupPanel.getRolegroups();
								if (restriction == null)
								{
									try {
										Object[] options = {"OK"};
										int ans = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
										JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
										null, options, options[0]);
										dataEntryComplete = false;
									}
									catch(Exception ex){
										Log.getLogger().log(Level.WARNING, "Exception caught", ex);
									}
								}
								else
								{
									// Process data
									HashMap hmap = rolegroupPanel.getRoleGroupTableModel().getRolegroups();
									RDFSClass aClass = rolegroupPanel.roleGroupHash2RDFSClass(hmap);

									//int row = cond_model_1.getRestrictionCount();


									int row = -1;
									boolean isDedefining = rolegroupPanel.getIsDefining();

									if (isDedefining)
									{
										row = 1;
									}
									else
									{
										row = cond_model_1.findFirstRowInNecessaryBlock();
									}

									//boolean added = cond_model_1.addRow(aClass, row);

									boolean added = cond_model_1.addRow(aClass, row, isDedefining);
									enableSaveButton(true);
									break;
								}
							}
							else
							{
								break;
							}
						}
				    }
				};


		Action modifyRestrictionAction_1 =
				new AbstractAction("Modify a restriction ...",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						modifyRestriction(cond_table_1, cond_model_1);
					}
				};

        DeleteRowAction deleteAction_1 = new DeleteRowAction(cond_table_1) {
            public void actionPerformed(ActionEvent e) {

                int rowIndex = cond_table_1.getSelectedRow();
				if (rowIndex == -1)
				{
					 if (cond_model_1.getRowCount() > 0)
					 {
						 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
					 }
					 return;
				}

				if (cond_model_1.isSeparator(rowIndex)) return;

				boolean bool_val = confirmDeleteAction("restriction");
				if (!bool_val) return;

        		cond_model_1.deleteRow(rowIndex);
        		enableSaveButton(true);

        		 //062906
				if (cond_model_1.getRowCount()==2)
					enableDelEditHB(6, false);
            }
        };


		LabeledComponent lc2_1
		   = new LabeledComponent("Restrictions (Role Groups or Roles)", new JScrollPane(cond_table_1));
        lc2_1.addHeaderSeparator();
        //lc2_1.addHeaderButton(createExpressionAction_1);
        hb_add_6 = lc2_1.addHeaderButton(createRestrictionAction_1);
        hb_edit_6 = lc2_1.addHeaderButton(modifyRestrictionAction_1);
        hb_delete_6 = lc2_1.addHeaderButton(deleteAction_1);

        //cond_table_1.registerAction(deleteAction);
        //cond_table_1.registerActionSeparator();
        //cond_table_1.registerAction(addNamedClassAction);
        //cond_table_1.registerAction(negateAnonymousClsAction);

////////////////
// Superconcepts
////////////////

		cond_model_2 = new NCIConditionsTableModel((OWLNamedClass) subject, slot,
		                          NCIConditionsTableModel.SET_SUPERCLASS, this);
		cond_table_2 = new NCIConditionsTable(getOWLModel(), cond_model_2);

 		Action addNamedClassAction_2 =
 				new AbstractAction("Add named class...", OWLIcons.getAddIcon("PrimitiveClass")) {

 					public void actionPerformed(ActionEvent e)
 					{
						java.awt.TextField textfield = new TextField();
						String label = "Select a class.";
						Collection clses = kb.getRootClses();
						Collection c;
						final NCISelectSuperClsPanel p = new NCISelectSuperClsPanel(kb, clses);
						int result = ModalDialog.showDialog(textfield, p, label, ModalDialog.MODE_OK_CANCEL);
						boolean isDefining = false;

							if (result == ModalDialog.OPTION_OK) {
								c = p.getSelection();
								isDefining = p.isDefining();
							} else {
								//c = Collections.EMPTY_LIST;
								return;
							}

							Cls cls = (Cls) CollectionUtilities.getFirstItem(c);
							if (cls == null || wrapper.getInternalName(cls).compareTo("owl:Thing") == 0)
							{
								try {
									Object[] options = {"OK"};
									int ans = JOptionPane.showOptionDialog(tab, "No class is selected.", "Confirmation",
									JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
									null, options, options[0]);
									return;
								}
								catch(Exception ex){
									Log.getLogger().log(Level.WARNING, "Exception caught", ex);
								}
							}
							else
							{

								//String prop_value = cls.getBrowserText();
								String prop_value = wrapper.getInternalName(cls);//.getBrowserText();

								//013107
								boolean invaldSelection = wrapper.isPremerged((OWLNamedClass) cls);
								if (invaldSelection)
								{
									ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-merged concept.");
									return;
								}
								invaldSelection = wrapper.isPreretired((OWLNamedClass) cls);
								if (invaldSelection)
								{
									ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-retired concept.");
									return;
								}
								invaldSelection = wrapper.isRetired((OWLNamedClass) cls);
								if (invaldSelection)
								{
									ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a retired concept.");
									return;
								}
/*

								if (prop_value.compareTo(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS)) == 0 ||
									prop_value.compareTo(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS)) == 0 ||
									prop_value.compareTo(tab.getClsName(NCIEditTab.PREMERGED_CONCEPTS)) == 0)
								{
									ProtegeUI.getModalDialogFactory().showErrorMessageDialog(cond_table_2, "Cannot select " +  prop_value + ".");
									return;
								}
*/

								else
								{
									RDFSClass value = (RDFSClass) cls;
									OWLNamedClass owl_cls = (OWLNamedClass) cls;

	//								if (prop_value.compareTo(focusCls.getBrowserText()) == 0)
									if (prop_value.compareTo(wrapper.getInternalName(focusCls)) == 0)

									{
										ProtegeUI.getModalDialogFactory().showErrorMessageDialog(cond_table_2, "Cannot select " +  prop_value + ".");
										return;
									}
									else if (owl_cls.hasSuperclass(focusCls))
									{
										ProtegeUI.getModalDialogFactory().showErrorMessageDialog(cond_table_2, "Cannot select " +  prop_value + ".");
										return;
									}
									int row = 1;


									//081706
									String key = SUBCLASSOF + ": " + wrapper.getInternalName(owl_cls);
									//System.out.println("owl_cls "+owl_cls.getBrowserText());
									//System.out.println("key "+key);
									if (itemExists(key, TreeItem.TYPE_PARENT))
									{
										Component warning_label = new JLabel("Superclass already exists.");
										LabeledComponent lc2 = new LabeledComponent("", warning_label);
										int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
										//dlg.cancelBtnPressed = true;
										return;
									}

									if (isDefining)
									{
										boolean canAdd = cond_model_2.addRow(owl_cls, row, isDefining);
										if (canAdd)
										{
											enableDelEditHB(7, true);
											enableSaveButton(true);
										}
									}
									else
									{
										row = cond_model_2.getNamedSuperClassCount();
										boolean canAdd = cond_model_2.addRow(value, row);
										if (canAdd)
										{
											cond_table_2.getSelectionModel().setSelectionInterval(row, row);
											cond_table_2.scrollRectToVisible(cond_table_2.getCellRect(row, 0, true));
											enableDelEditHB(7, true);
											enableSaveButton(true);
										}
									}

						    }
 						}
  					}
 				};


		Action modifySuperclassAction_1 =
				new AbstractAction("Modify superclass",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						//cond_table_1.selectNecessaryIfNothingSelected();
						//cond_table_1.createAndEditRow();
						int rowIndex = cond_table_2.getSelectedRow();
						if (rowIndex == -1)
						{
							 if (cond_model_2.getRowCount() > 0)
							 {
								 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
							 }
							 return;
						}
						if (cond_model_2.isSeparator(rowIndex))
						{
							return;
						}

						modifySuperclass(cond_table_2, cond_model_2);
					}
				};


         DeleteRowAction deleteAction_2 = new DeleteRowAction(cond_table_2) {
             public void actionPerformed(ActionEvent e) {
                int rowIndex = cond_table_2.getSelectedRow();
				if (rowIndex == -1)
				{
					 if (cond_model_2.getRowCount() > 0)
					 {
						 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
					 }
					 return;
				}

				if (cond_model_2.isSeparator(rowIndex))
				{
					return;
				}

				String clsname = cond_model_2.getTableItemName(rowIndex);
				if (clsname != null && !wrapper.isEditable(clsname))
				{
					 ProtegeUI.getModalDialogFactory().showMessageDialog(kb, clsname + " is read only.");
					 return;
				}
				else
				{
					String owlThing = kb.getOWLThingClass().getBrowserText();

					if (clsname.compareTo(owlThing) == 0)
					{
						ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "Cannot delete " + clsname + ".");
						return;
					}
				}

                int knt = cond_model_2.getStrictNamedSuperClassCount();
                if (knt == 1)
                {
					ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "Cannot delete the last superclass " + clsname + ".");
					return;
				}

				boolean bool_val = confirmDeleteAction("superclass");
				if (!bool_val) return;

 				 // KLO
        		 //cond_model_2.deleteRow(rowIndex, true);
        		cond_model_2.deleteRow(rowIndex);
				enableSaveButton(true);
				if (cond_model_2.getRowCount() == 0)
				{
					enableDelEditHB(7, false);
				}
             }
         };

 		 LabeledComponent lc2_2
 		   = new LabeledComponent("Named Superclasses", new JScrollPane(cond_table_2));
         lc2_2.addHeaderSeparator();
         hb_add_7 = lc2_2.addHeaderButton(addNamedClassAction_2);
         hb_edit_7 = lc2_2.addHeaderButton(modifySuperclassAction_1);
         hb_delete_7 = lc2_2.addHeaderButton(deleteAction_2);

         //cond_table_1.registerAction(deleteAction);
         //cond_table_1.registerActionSeparator();
         //cond_table_1.registerAction(addNamedClassAction);
         //cond_table_1.registerAction(negateAnonymousClsAction);

///////////////////////////////
// Associations
///////////////////////////////

        Vector exclusion = new Vector();
        exclusion.add("ID");
        model_4 = new NCIAnnotationsTableModel(kb, this, (OWLNamedClass) subject, exclusion,
        	true, 4);
        model_4.setModelType(NCIAnnotationsTableModel.OBJECT_PROPERTY_MODEL);
		anno_table_4 = new NCIAnnotationsTable(getProject(), model_4, "");


		Action addNamedClassAction_3 =
				new AbstractAction( "Add existing resource as value...",
				                    OWLIcons.getCreatePropertyIcon(OWLIcons.OWL_OBJECT_ANNOTATION_PROPERTY))

        {
			public void actionPerformed(ActionEvent e)
			{
				String title = "Add an Object-Valued Property";
                CreateObjPropertyDialog dlg = new CreateObjPropertyDialog(tab, title, null, null);
                if (!dlg.cancelBtnPressed)
                {
					String association_name = dlg.getPropertyName();
					String association_value = dlg.getPropertyValue();

					Slot slot = dlg.getSelectedSlot();
					Cls cls = dlg.getSelectedCls();

					if (association_name.compareTo("") != 0 &&
					    association_value.compareTo("") != 0)
					{
						RDFProperty property = (RDFProperty) slot;

						OWLNamedClass value = (OWLNamedClass) cls;//kb.getCls(association_value);
						int num = model_4.addRow(property, value);

						enableSaveButton(true);
						enableDelEditHB(4, true);
				    }
				}
			}
		};


		Action modifyAssociationAction =
				new AbstractAction( "Modify existing object valued property...",
				                    NCIOWLIcons.getImageIcon("edit"))

        {
			public void actionPerformed(ActionEvent e)
			{
				int rowIndex = anno_table_4.getSelectedRow();
				if (rowIndex < 0)
				{
					if (model_4.getRowCount() > 0)
					{
					    ProtegeUI.getModalDialogFactory().showMessageDialog(kb, "No item is selected.");
					}
			        return;
				}

				Object selected_value = model_4.getValue(rowIndex);
				OWLNamedClass owl_cls = (OWLNamedClass) selected_value;
  			    RDFProperty selected_property = model_4.getPredicate(rowIndex);

//				String association_name = selected_property.getBrowserText();
//				String association_value = owl_cls.getBrowserText();

				String association_name = selected_property.getName();//BrowserText();
				String association_value = wrapper.getInternalName(owl_cls);//.getBrowserText();


                String title = "Edit an Object-Valued Property";
                CreateObjPropertyDialog dlg = new CreateObjPropertyDialog(tab, title, association_name,
                   association_value);

                if (!dlg.cancelBtnPressed)
                {
					association_name = dlg.getPropertyName();
					association_value = dlg.getPropertyValue();
					if (association_name.compareTo("") != 0 &&
					    association_value.compareTo("") != 0)
					{
				//			System.out.println("Add association: " +  association_name
				//   + " " + association_value );

						RDFProperty property = getObjectProperty(association_name);
						OWLNamedClass value = (OWLNamedClass) kb.getCls(association_value);
						model_4.deleteRow(rowIndex);

						int num = model_4.addRow(property, value);
						enableSaveButton(true);
				    }
				}
			}
		};



		LabeledComponent lc2_3
		   = new LabeledComponent("Associations", new JScrollPane(anno_table_4));
        lc2_3.addHeaderSeparator();
        hb_add_4 = lc2_3.addHeaderButton(addNamedClassAction_3);
        hb_edit_4 = lc2_3.addHeaderButton(modifyAssociationAction);
        hb_delete_4 = lc2_3.addHeaderButton(new NCIDeletePropertyAction(tab, anno_table_4, 4));


 		JSplitPane splitPane_3_1 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,lc2_1,lc2_2);
 		splitPane_3_1.setOneTouchExpandable(true);
  		splitPane_3_1.setDividerLocation(150);

  		JSplitPane splitPane_3_2 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,splitPane_3_1,lc2_3);
   		splitPane_3_2.setDividerLocation(300);
   		splitPane_3_2.setOneTouchExpandable(true);

 		panel_2.add(splitPane_3_2,BorderLayout.CENTER);



/////////////////////////////////////////////////////////////////////////////////////////////
// Property Tab

// Simple properties

        JPanel panel_3 = new JPanel();
        panel_3.setLayout(new BorderLayout());
		tabbedPane_Modify.addTab("Properties", icon, panel_3, "");

//----------------------------------------------- Properties
		userDefinedRelevantProperties = new Vector();

		Vector excludedProperties = new Vector();
		excludedProperties.add(getSlotName(NCIEditTab.PREFERRED_NAME));
		excludedProperties.add(getSlotName(NCIEditTab.FULL_SYN));
		excludedProperties.add(getSlotName(NCIEditTab.DEFINITION));
		excludedProperties.add(getSlotName(NCIEditTab.ALT_DEFINITION));
		excludedProperties.add(getSlotName(NCIEditTab.LONG_DEFINITION));
		excludedProperties.add(getSlotName(NCIEditTab.ALT_LONG_DEFINITION));
		excludedProperties.add(getSlotName(NCIEditTab.GO_ANNOTATION));
		excludedProperties.add(getSlotName(NCIEditTab.GO_ANNOTATION2));

		excludedProperties.add(getSlotName(NCIEditTab.CODE));
		excludedProperties.add("Model.Slot.DIRECT_SUBCLASSES");
		excludedProperties.add("Model.Slot.DIRECT_INSTANCES");
		excludedProperties.add("rdfs:subClassOf");
		excludedProperties.add("ID");

        Collection c = getExcludedProperties();

        for (Iterator it = c.iterator(); it.hasNext();) {
            RDFProperty property = (RDFProperty) it.next();
            //excludedProperties.add(property.getBrowserText());
            excludedProperties.add(property.getName());//BrowserText());
        }

		model_3 = new NCIAnnotationsTableModel(kb, this, subject,
			userDefinedRelevantProperties, excludedProperties, 3);

		model_3.setModelType(NCIAnnotationsTableModel.SIMPLE_PROPERTY_MODEL);

		anno_table_3 = new NCIAnnotationsTable(getProject(), model_3, "");


		Action modifySimplePropertyAction =
				new AbstractAction("Modify Simple Property",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						modifyProperty(anno_table_3, model_3);
					}
				};


		LabeledComponent lc3
		   = new LabeledComponent("Simple Properties", new JScrollPane(anno_table_3));
        hb_add_3 = lc3.addHeaderButton(new NCICreateValueAction(tab, model_3, null, excludedProperties, 3));
        hb_edit_3 = lc3.addHeaderButton(modifySimplePropertyAction);
        hb_delete_3 = lc3.addHeaderButton(new NCIDeletePropertyAction(tab, anno_table_3, 3));

/////////////////////////////////////////////////////////////////////

// Complex properties

 		userDefinedRelevantProperties = new Vector();
		userDefinedRelevantProperties.add(getSlotName(NCIEditTab.ALT_DEFINITION));
		userDefinedRelevantProperties.add(getSlotName(NCIEditTab.LONG_DEFINITION));
		userDefinedRelevantProperties.add(getSlotName(NCIEditTab.ALT_LONG_DEFINITION));
		userDefinedRelevantProperties.add(getSlotName(NCIEditTab.GO_ANNOTATION));

		excludedProperties = new Vector();
		model_5 = new NCIAnnotationsTableModel(kb, this, subject,
			userDefinedRelevantProperties, excludedProperties, 2, 5);
		model_5.setModelType(NCIAnnotationsTableModel.COMPLEX_PROPERTY_MODEL);

		anno_table_5 = new NCIAnnotationsTable(getProject(), model_5, "");
		model_5.setTable(anno_table_5);

		qualifier_model = new NCIQualifierTableModel(columnNames);
		qualifier_table = new NCIQualifierTable(qualifier_model);


		anno_table_5.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 1) {
					updateQualifierTable(anno_table_5, model_5, qualifier_model);
				}
			}
		});

        anno_table_5.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                updateQualifierTable(anno_table_5, model_5, qualifier_model);
            }
        });

        //071906 qualifier scroll bar fix
		LabeledComponent lc4 = new LabeledComponent("Complex Properties", new JScrollPane(anno_table_5));

        allowed_properties = new ArrayList();
        Slot allowed_slot = kb.getSlot(getSlotName(NCIEditTab.ALT_DEFINITION));
        if (allowed_slot != null)
        {
        	allowed_properties.add(allowed_slot);
	    }
        allowed_properties = new ArrayList();
        allowed_slot = kb.getSlot(getSlotName(NCIEditTab.GO_ANNOTATION));
        if (allowed_slot != null)
        {
        	allowed_properties.add(allowed_slot);
	    }
        allowed_slot = kb.getSlot(getSlotName(NCIEditTab.LONG_DEFINITION));
        if (allowed_slot != null)
        {
        	allowed_properties.add(allowed_slot);
	    }
        allowed_slot = kb.getSlot(getSlotName(NCIEditTab.ALT_DEFINITION));
        if (allowed_slot != null)
        {
        	allowed_properties.add(allowed_slot);
	    }
        allowed_slot = kb.getSlot(getSlotName(NCIEditTab.ALT_LONG_DEFINITION));
        if (allowed_slot != null)
        {
        	allowed_properties.add(allowed_slot);
	    }
		Action modifyComplexPropertyAction =
				new AbstractAction("Modify Complex Property",
						NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e) {
						modifyProperty(anno_table_5, model_5);
					}
				};

        hb_add_5 = lc4.addHeaderButton(new NCICreateValueAction(tab, model_5, allowed_properties, 5));
        hb_edit_5 = lc4.addHeaderButton(modifyComplexPropertyAction);
        hb_delete_5 = lc4.addHeaderButton(new NCIDeletePropertyAction(tab, anno_table_5, qualifier_model, 5));

		LabeledComponent lc5 = new LabeledComponent("Qualifiers", new JScrollPane(qualifier_table));

 		JSplitPane splitPane_6 = new JSplitPane(JSplitPane.VERTICAL_SPLIT, lc4, lc5);
   		splitPane_6.setDividerLocation(150);
   		splitPane_6.setOneTouchExpandable(true);


		JSplitPane splitPane_5 = new JSplitPane(JSplitPane.VERTICAL_SPLIT,lc3,splitPane_6);

 		splitPane_5.setDividerLocation(200); //150
 		splitPane_5.setOneTouchExpandable(true);

 		panel_3.add(splitPane_5,BorderLayout.CENTER);

		tabbedPane_Modify.addTab("Properties", icon, panel_3, "");

		panel.setLayout(new GridLayout(1, 1));
		panel.add(tabbedPane_Modify);

		tabbedPane_Modify.setSelectedIndex(0);

		return panel;

	}



    public InstanceNameComponent getNamePanel()
    {
		return name_panel;
	}


	public void setInstance(Instance instance)
	{
		name_panel.setInstance(instance);
	}


	private void initialize()
	{
		/*
		Action editTypeAction = new AbstractAction( "View class...", OWLIcons.getImageIcon("EditType"))
		{
			public void actionPerformed(ActionEvent e)
			{
				EditDialog dlg = new EditDialog(tab, tab.getSelectedCls());
			}
		};
		*/

		this.setLayout(new BorderLayout());
		this.setPreferredSize(new Dimension(500, 500));

        JPanel labelPanel = new JPanel(false);
        labelPanel.setLayout(new BorderLayout());

		name_panel = new InstanceNameComponent();

		name_panel.setEditable(false);

		saveButton_Modify = new JButton("Save");
		deleteButton_Modify = new JButton("Delete");
		cancelButton_Modify = new JButton("Cancel");

		ptTextField = new JTextField();
		ptTextField.setPreferredSize(new Dimension(300, 22));

		//090606
		ptTextField.getDocument().addDocumentListener(new DocumentListener() {

		   public void changedUpdate(DocumentEvent e) {
			 saveButton_Modify.setEnabled(true);
			 cancelButton_Modify.setEnabled(true);
		   }
		   public void insertUpdate(DocumentEvent e) {
			 saveButton_Modify.setEnabled(true);
			 cancelButton_Modify.setEnabled(true);
		   }
		   public void removeUpdate(DocumentEvent e) {
			 saveButton_Modify.setEnabled(true);
			 cancelButton_Modify.setEnabled(true);
		   }

       });

		/*ptTextField.addFocusListener(new FocusListener() {
            public void focusLost(FocusEvent e) {
				//saveButton_Modify.setEnabled(true);
			}
            public void focusGained(FocusEvent e) {
				saveButton_Modify.setEnabled(true);
			}
		});*/

        codeLabel = new JLabel("");
        selectedInstance = getSelectedInstance();
		//120606
		if (AdvancedQuery.equals("AdvancedQuery"))
		{
			selectedInstance = focusCls;
		}

        code = null;
        String preferred_name = null;
		if (selectedInstance != null && selectedInstance instanceof OWLNamedClass)
		{
			//editTypeAction = new EditTypeAction((RDFResource) selectedInstance);
			name_panel.setInstance(selectedInstance);

			code = wrapper.getCode((Cls) selectedInstance);
			Cls cls = (Cls) selectedInstance;
			String cls_name = wrapper.getInternalName(cls);

			//if (code != null && code.compareTo(selectedInstance.getBrowserText()) != 0)
			if (code != null && code.compareTo(cls_name) != 0)
			{
				codeLabel.setText("   code: " + code + "   ");
		    }
		    else
		    {
                codeLabel.setText("   code: " + "   ");
			}
            // 080306

			try {
			    preferred_name = getObjectValue(wrapper.getSlotValue((Cls) selectedInstance,
			         getSlotName(NCIEditTab.PREFERRED_NAME)));


			} catch (Exception e) {

			}

			if (preferred_name != null)
			{
				ptTextField.setText(getObjectValue(preferred_name));
		    }
		    else
		    {

				preferred_name = "";
				ptTextField.setText("");

			}

			ptTextField.setEditable(true);
			if (!wrapper.isEditable(focusCls))
			{
				ptTextField.setEditable(false);
			}

			String internalName = wrapper.getInternalName((Cls) selectedInstance);

            if (!AdvancedQuery.equals("AdvancedQuery"))
            {
				tab.addToListenedToClses((OWLNamedClass) selectedInstance);
		    }
		}
		else
		{
			RDFResource resource = (RDFResource) wrapper.getCls("owl:Thing");
			//editTypeAction = new EditTypeAction(resource);
			editTypeFormAction = new EditTypeFormAction(resource);
		}

        //labelPanel.add(name_panel, BorderLayout.CENTER);

        JPanel ptPanel = new JPanel();
        ptPanel.setLayout(new BorderLayout());
        ptLabel = new JLabel("  Preferred Name: ");
        ptTextField.setPreferredSize(new Dimension(300, 22));
        //ptTextField.setText(preferred_name);
        ptPanel.add(ptLabel, BorderLayout.WEST);
        ptPanel.add(ptTextField, BorderLayout.CENTER);

        Slot ptSlot = wrapper.getSlot(getSlotName(NCIEditTab.PREFERRED_NAME));
        if (ptSlot == null)
        {
			ptTextField.setEnabled(false);
			ptTextField.setEditable(false);
		}


        //Slot codeSlot = wrapper.getSlot(tab.CODE);

        Slot codeSlot = wrapper.getSlot(wrapper.getCodeSlotName());
        if (codeSlot != null)
        {
        	ptPanel.add(codeLabel, BorderLayout.EAST);
		}

        labelPanel.add(ptPanel, BorderLayout.CENTER);

		topComponent = new LabeledComponent("Class:  ", labelPanel);

        if (!AdvancedQuery.equals("AdvancedQuery"))
        {
			//012607
			if (editTypeFormAction == null){
				RDFResource resource = (RDFResource) wrapper.getCls("owl:Thing");
				//editTypeAction = new EditTypeAction(resource);
				editTypeFormAction = new EditTypeFormAction(resource);
			}

			topComponent.addHeaderButton(editTypeFormAction);
	    }

        //topComponent.addHeaderButton(editTypeAction);

		this.add(topComponent, BorderLayout.NORTH);

       	modify_panel = createClassTabbedPane();

        this.add(modify_panel, BorderLayout.CENTER);

		JPanel buttonPanel = new JPanel();

		if (newBtn)
		{
			newButton_Modify = new JButton("New");
			newButton_Modify.addActionListener(this);
		}

		reviewButton_Modify = new JButton("Review");
		reviewButton_Modify.addActionListener(this);

		//saveButton_Modify = new JButton("Save");
		saveButton_Modify.addActionListener(this);

		deleteButton_Modify.addActionListener(this);

		//cancelButton_Modify = new JButton("Cancel");
		cancelButton_Modify.addActionListener(this);

		if (newBtn)
		{
			buttonPanel.add(newButton_Modify);
		}

		if (tab.isActionAllowed(NCIEditTab.EDIT_RETIRED_CLASS_ACTION))
		{
			buttonPanel.add(deleteButton_Modify);
        }

		if (selectedInstance != null && selectedInstance instanceof OWLNamedClass)
		{
			OWLNamedClass retire_root = kb.getOWLNamedClass(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS));
			OWLNamedClass curr_cls = (OWLNamedClass) selectedInstance;
			boolean isretired = curr_cls.isSubclassOf(retire_root);
			if (!isretired)
			{
				deleteButton_Modify.setEnabled(false);
			}
		}
		else
		{
			deleteButton_Modify.setEnabled(false);
		}

        buttonPanel.add(reviewButton_Modify);
		buttonPanel.add(saveButton_Modify);
		buttonPanel.add(cancelButton_Modify);

		this.add(buttonPanel, BorderLayout.SOUTH);

        if (newButton_Modify != null)
        {
        	newButton_Modify.setEnabled(true);
	    }
        reviewButton_Modify.setEnabled(true);
		saveButton_Modify.setEnabled(false);

		//101306
		if ((tab.isActionAllowed(NCIEditTab.EDIT_RETIRED_CLASS_ACTION) ||
			tab.isActionAllowed(NCIEditTab.DELETE_ACTION)) &&
			!isSystemCls())
		{
			canDelete = true;
			deleteButton_Modify.setEnabled(true);
		}

        else
        {
			deleteButton_Modify.setEnabled(true);
		}



		//090606
		/*if (preferred_name == null || preferred_name.compareTo("") == 0)
		{
			saveButton_Modify.setEnabled(true);
		}*/
		cancelButton_Modify.setEnabled(false);
		isModified = false;


		this.show();
	}

    public JButton getReviewButton()
	{
		return reviewButton_Modify;
	}

    public JButton getCancelButton()
	{
		return cancelButton_Modify;
	}

	public void actionPerformed(ActionEvent event)
	{
		Object[] option_array = {"OK"};
		Object[] options = {"Yes", "No"};

		Object action = event.getSource();
		if (action == reviewButton_Modify){
			//OWLNamedClass cls = (OWLNamedClass) instance;
			if (focusCls != null)
			{
				//ReviewClassDialog rcd = new ReviewClassDialog(tab, (OWLNamedClass) instance);
				ReviewClassDialog rcd = new ReviewClassDialog(tab, this, (OWLNamedClass) focusCls);
		    }
		}

		else if (action == newButton_Modify) {

			if (isSaveButtonEnabled())
			{
				try {
					int ans = JOptionPane.showOptionDialog(this, "No data will be saved. Do you want to continue?", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);

					if (ans == 1) return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}

    		CreateSubclassDialog dlg = new CreateSubclassDialog(tab);
    		reviewButton_Modify.setEnabled(true);
		}

		else if (action == saveButton_Modify){

		    //if (!tab.isActionAllowed(NCIEditTab.EDIT_WRITE_ACTION))
		    if (!tab.isActionAllowed(NCIEditTab.EDIT_BASIC_ACTION))

		    {
				int ans = JOptionPane.showOptionDialog(this, "User does not have write privilege.", "Confirmation",
				JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
				null, option_array, options[0]);
				saveButton_Modify.setEnabled(false);
				return;
			}

			OWLNamedClass curr_cls = (OWLNamedClass) instance;
			tab.removeFromListenedToClses(curr_cls);

            try {
                kb.beginTransaction("Save class in EditPanel " + curr_cls.getBrowserText(), curr_cls.getName());

				saveButton_Modify.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				boolean retval = tab.getDataHandler().processData((Cls) instance, this);
				if (!retval)
				{
					tab.showError(instance.getBrowserText());
					saveButton_Modify.setEnabled(false);
					cancelButton_Modify.setEnabled(true);
					saveButton_Modify.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
					System.out.println("ERROR: Unable to save " + curr_cls.getBrowserText());
					tab.addToListenedToClses((OWLNamedClass) curr_cls);
					kb.rollbackTransaction();
					return;
				}


				System.out.print("Starting updateAll ...");
				long t0 = System.currentTimeMillis();
				updateAll();
				System.out.print("\t finished. Time = " + (System.currentTimeMillis() - t0));

				saveButton_Modify.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				int ans = JOptionPane.showOptionDialog(this, "Concept saved successful.", "Confirmation",
				JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
				null, option_array, options[0]);

				reviewButton_Modify.setEnabled(true);
				saveButton_Modify.setEnabled(false);
				cancelButton_Modify.setEnabled(false);

				initial_preferred_name = getObjectValue(ptTextField.getText());
				kb.commitTransaction();

		    } catch (Exception e) {
				kb.rollbackTransaction();
				OWLUI.handleError(kb, e);
				saveButton_Modify.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

			}

			tab.addToListenedToClses((OWLNamedClass) curr_cls);

		}

		else if (action == deleteButton_Modify){
		    OWLNamedClass retire_root = kb.getOWLNamedClass(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS));
            OWLNamedClass curr_cls = (OWLNamedClass) instance;

		    boolean isretired = curr_cls.isSubclassOf(retire_root);

			if (retire_root == null || !isretired)
			{
				deleteButton_Modify.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
				String text = curr_cls.getBrowserText() + " has not been retired yet.";
				ModalDialog.showMessageDialog(null, text);
				System.out.println(text);

				return;
			}

            boolean confirmDeletion = confirmDeleteClassAction(curr_cls.getBrowserText());

            if (!confirmDeletion) return;

            deleteButton_Modify.setCursor(new Cursor(Cursor.WAIT_CURSOR));
			tab.removeFromListenedToClses(curr_cls);
			String deletedClsName = curr_cls.getBrowserText();
            curr_cls.delete();

            reviewButton_Modify.setEnabled(false);
            deleteButton_Modify.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
			String text = deletedClsName + " has been deleted.";
			ModalDialog.showMessageDialog(null, text);
			deleteButton_Modify.setEnabled(false);

			tab.initializeEditPanel();

		}

		else if (action == cancelButton_Modify){
			int option = JOptionPane.showConfirmDialog
				(null, "No data will be saved. Do you want to continue?", "Confirmation", JOptionPane.YES_NO_OPTION);

			if (option==0){
				updateAll();
				reviewButton_Modify.setEnabled(true);
				saveButton_Modify.setEnabled(false);
				cancelButton_Modify.setEnabled(false);
			}
		}
	}

	public String getPreferredName(){
		return ptTextField.getText();
	}

	public String getUserName(){
		return tab.getUserName();
	}

	public void enableSaveButton(boolean state)
	{
		reviewButton_Modify.setEnabled(state);
		saveButton_Modify.setEnabled(state);
		cancelButton_Modify.setEnabled(state);
		isModified = true;
	}

	public boolean isSaveButtonEnabled()
	{
		return saveButton_Modify.isEnabled();
	}

	public boolean dataModified()
	{
		return isModified;
	}

//////////////////////////////////////////////////////////
// Review
//////////////////////////////////////////////////////////


	//public NCIAnnotationsTableModel get_synonym_tablemodel()
	public NCIFULLSYNTableModel get_synonym_tablemodel()
	{
		return model_1;
	}

	public NCIAnnotationsTableModel get_definition_tablemodel()
	{
		return model_2;
	}

	public NCIAnnotationsTableModel get_property_tablemodel()
	{
		return model_3;
	}


	public NCIAnnotationsTableModel get_association_tablemodel()
	{
		return model_4;
	}

	public NCIAnnotationsTableModel get_complex_property_tablemodel()
	{
		return model_5;
	}


	public NCIConditionsTableModel get_restriction_tablemodel()
	{
		return cond_model_1;
	}

	public NCIConditionsTableModel get_superconcept_tablemodel()
	{
		return cond_model_2;
	}

	public NCIQualifierTableModel get_qualifier_tablemodel_1()
	{
		return qualifier_model_1;
	}

	public NCIQualifierTableModel get_qualifier_tablemodel()
	{
		return qualifier_model;
	}


//////////////////////////////////////////////////////////
// Save
//////////////////////////////////////////////////////////


    public Vector getInitialState()
    {
		// Concept
		Vector v = new Vector();
		//String name = instance.getBrowserText();
		Cls cls = (Cls) instance;
		String name = wrapper.getInternalName(cls);//instance.getBrowserText();

		String value = "";
		OWLNamedClass owlCls = null;
		String restriction = "";
		String modifier = "";
		int cardinality = -1;

		TreeItem item = new TreeItem(TreeItem.TYPE_CONCEPT,
				name,
				value,
				restriction,
				modifier,
				cardinality);
        v.add(item);

 // preferred_name
        if (initial_preferred_name != null)
        {
			item = new TreeItem(TreeItem.TYPE_PROPERTY,
					getSlotName(NCIEditTab.PREFERRED_NAME),
					getObjectValue(initial_preferred_name),
					restriction,
					modifier,
					cardinality);
			v.add(item);
	    }


		// Synonym and PT Properties
        ArrayList properties = (ArrayList) get_synonym_tablemodel().getInitialProperties();
        ArrayList values = (ArrayList) get_synonym_tablemodel().getInitialValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);

			//value = getObjectValue(values.get(i));

			item = new TreeItem();
			name = property.getName();
			item.setType(TreeItem.TYPE_PROPERTY);
			//item.setName(property.getBrowserText());
			item.setLanguage(getLanguage(values.get(i)));

			item.setName(property.getName());
			item.setValue(value);
			item.setNameValue(name, values.get(i));
			v.add(item);
		}

		// Definition Properties
        properties = (ArrayList) get_definition_tablemodel().getInitialProperties();
        values = (ArrayList) get_definition_tablemodel().getInitialValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			//value = (String) values.get(i);
			//value = getObjectValue(values.get(i));
			//name = property.getBrowserText();
			name = property.getName();//BrowserText();
			item = new TreeItem();
			item.setType(TreeItem.TYPE_PROPERTY);
			item.setLanguage(getLanguage(values.get(i)));

			item.setName(name);
			item.setValue(value);
			item.setNameValue(name, values.get(i));
			v.add(item);
		}

		// Other Properties
        properties = (ArrayList) get_property_tablemodel().getInitialProperties();
        values = (ArrayList) get_property_tablemodel().getInitialValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
			    //value = (String) values.get(i);
			    //value = getObjectValue(values.get(i));
				//name = property.getBrowserText();
				name = property.getName();
				item = new TreeItem();
				item.setType(TreeItem.TYPE_PROPERTY);
				item.setLanguage(getLanguage(values.get(i)));

				item.setName(name);
				item.setValue(value);
				item.setNameValue(name, values.get(i));
				v.add(item);
		    }
		}

        properties = (ArrayList) get_complex_property_tablemodel().getInitialProperties();
        values = (ArrayList) get_complex_property_tablemodel().getInitialValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
			    //value = (String) values.get(i);
			    //value = getObjectValue(values.get(i));
				//name = property.getBrowserText();
				name = property.getName();
				item = new TreeItem();
				item.setType(TreeItem.TYPE_PROPERTY);
				item.setName(name);
				item.setLanguage(getLanguage(values.get(i)));

				item.setValue(value);
				item.setNameValue(name, values.get(i));
				v.add(item);
		    }
		}

		// Associations
        properties = (ArrayList) get_association_tablemodel().getInitialProperties();
        values = (ArrayList) get_association_tablemodel().getInitialValues();


        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			owlCls = (OWLNamedClass) values.get(i);

			//value = owlCls.getBrowserText();
			value = wrapper.getInternalName(owlCls);
			//name = property.getBrowserText();
			name = property.getName();
			item = new TreeItem();
			item.setType(TreeItem.TYPE_ASSOCIATION);
			item.setName(name);
			item.setValue(value);
			item.setNameValue(name + ": " + value);
			item.setCls(owlCls);
			item.setProperty(property);
			item.setIsDefining(false);
			v.add(item);
		}

		// Superconcepts
		ArrayList items = (ArrayList) get_superconcept_tablemodel().getInitialItems();
        for (int i=0; i<items.size(); i++)
        {
			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
			if (!tableItem.isSeparator())
			{
				if (tableItem.getCls() instanceof OWLNamedClass)
				{
					//value = tableItem.getDisplayText();

					//added by tt
					value = wrapper.getInternalName(tableItem.getCls());
					//end added by tt

					item = new TreeItem();
					item.setType(TreeItem.TYPE_PARENT);
					item.setName(SUBCLASSOF);
					item.setValue(value);
					item.setNameValue(SUBCLASSOF + ": " + value);

					item.setIsDefining(tableItem.getIsDefining());
					item.setCls(tableItem.getCls());

					v.add(item);
			    }
			}
		}

		// Restrictions
		items = (ArrayList) get_restriction_tablemodel().getInitialItems();
        for (int i=0; i<items.size(); i++)
        {
			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
			// 101906, KLO
			if (!tableItem.isSeparator() && !tableItem.isInherited())
			//if (!tableItem.isSeparator())
			{
				RDFSClass aClass = tableItem.aClass;
				if (!(aClass instanceof OWLNamedClass))
				{
					item = new TreeItem();
					item.setType(TreeItem.TYPE_RESTRICTION);
					item.setNameValue(aClass.getBrowserText());
                    item.setIsDefining(tableItem.getIsDefining());
 					item.setCls(tableItem.getCls());
					v.add(item);
				}

		    }
		}
		return v;
	}


    public Vector getFinalState()
    {
		// Concept
		Vector v = new Vector();
		Cls cls = (Cls) instance;
		String name = wrapper.getInternalName(cls);

		String value = "";
		OWLNamedClass owlCls = null;
		String restriction = "";
		String modifier = "";
		int cardinality = -1;

		TreeItem item = new TreeItem(TreeItem.TYPE_CONCEPT,
				name,
				value,
				restriction,
				modifier,
				cardinality);
        v.add(item);

 // preferred_name
        String pt = ptTextField.getText();
        pt = item.getPlainString(pt);

		item = new TreeItem(TreeItem.TYPE_PROPERTY,
				getSlotName(NCIEditTab.PREFERRED_NAME),
				getObjectValue(pt),
				restriction,
				modifier,
				cardinality);
        v.add(item);

		// Synonym and PT Properties
        ArrayList properties = (ArrayList) get_synonym_tablemodel().getProperties();
        ArrayList values = (ArrayList) get_synonym_tablemodel().getValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			//value = getObjectValue(values.get(i));
			name = property.getName();
			item = new TreeItem();
			item.setLanguage(getLanguage(values.get(i)));
			item.setType(TreeItem.TYPE_PROPERTY);
			item.setName(property.getName());

			item.setValue(item.getPlainString(value));
			item.setNameValue(name, values.get(i));
			v.add(item);
		}

		// Definition Properties
        properties = (ArrayList) get_definition_tablemodel().getProperties();
        values = (ArrayList) get_definition_tablemodel().getValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			//value = getObjectValue(values.get(i));
			name = property.getName();

			item = new TreeItem();
			item.setLanguage(getLanguage(values.get(i)));
			item.setType(TreeItem.TYPE_PROPERTY);
			item.setName(name);
			item.setValue(value);
			item.setNameValue(name, values.get(i));
			v.add(item);
		}

		// Other Properties
        properties = (ArrayList) get_property_tablemodel().getProperties();
        values = (ArrayList) get_property_tablemodel().getValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
			    //value = getObjectValue(values.get(i));
				name = property.getName();

				item = new TreeItem();
				item.setLanguage(getLanguage(values.get(i)));
				item.setType(TreeItem.TYPE_PROPERTY);
				item.setName(name);
				item.setValue(value);
				item.setNameValue(name, values.get(i));
				v.add(item);
		    }
		}


        properties = (ArrayList) get_complex_property_tablemodel().getProperties();
        values = (ArrayList) get_complex_property_tablemodel().getValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
			    //value = getObjectValue(values.get(i));
				name = property.getName();

				item = new TreeItem();
				item.setLanguage(getLanguage(values.get(i)));
				item.setType(TreeItem.TYPE_PROPERTY);
				item.setName(name);
				item.setValue(value);
				item.setNameValue(name, values.get(i));
				v.add(item);
		    }
		}


		// Associations
        properties = (ArrayList) get_association_tablemodel().getProperties();

        values = (ArrayList) get_association_tablemodel().getValues();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);

			//owlCls = (OWLNamedClass) values.get(i);

			//value = owlCls.getBrowserText();

			//value = wrapper.getInternalName(owlCls);//.getBrowserText();

			owlCls = (OWLNamedClass) values.get(i);
			value = wrapper.getInternalName(owlCls);

			//name = property.getBrowserText();
			name = property.getName();

			item = new TreeItem();
			item.setType(TreeItem.TYPE_ASSOCIATION);
			item.setName(name);
			item.setValue(value);
			item.setNameValue(name + ": " + value);


			item.setProperty(property);

			item.setCls(owlCls);

			v.add(item);
		}

		// Superconcepts
		ArrayList items = (ArrayList) get_superconcept_tablemodel().getItems();
        for (int i=0; i<items.size(); i++)
        {
			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
			if (!tableItem.isSeparator())
			{
				//value = tableItem.getDisplayText();
				if (tableItem.getCls() instanceof OWLNamedClass)
				{
					value = wrapper.getInternalName(tableItem.getCls());
					item = new TreeItem();
					item.setType(TreeItem.TYPE_PARENT);
					item.setName(SUBCLASSOF);

					item.setValue(value);
					item.setNameValue(SUBCLASSOF + ": " + value);

					item.setCls(tableItem.getCls());

					item.setIsDefining(tableItem.getIsDefining());
					item.setCls(tableItem.getCls());

					v.add(item);
			    }
			}
		}

		// Restrictions
		items = (ArrayList) get_restriction_tablemodel().getItems();

        for (int i=0; i<items.size(); i++)
        {
			NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
			// 101906, KLO
			if (!tableItem.isSeparator() && !tableItem.isInherited())
			//if (!tableItem.isSeparator())
			{
				RDFSClass aClass = tableItem.aClass;
				if (!(aClass instanceof OWLNamedClass))
				{
					item = new TreeItem();
					item.setType(TreeItem.TYPE_RESTRICTION);
					item.setNameValue(aClass.getBrowserText());
					item.setIsDefining(tableItem.getIsDefining());

					if (!tableItem.getIsNew() && !(aClass instanceof OWLNamedClass))
					{
//						RDFSClass copy = wrapper.parsableText2RDFSClass(tableItem.parsableText);
						//Log.getLogger().warning("Creating clone of " + aClass.getBrowserText());
						//RDFSClass copy = aClass.createClone();
						//item.setCls(copy);
						item.setCls(aClass);
					}
					else
					{
						item.setCls(tableItem.getCls());
					}
					v.add(item);
				}
		    }
		}
		return v;
	}


/*
	static final int TYPE_PROPERTY = 1;
	static final int TYPE_RESTRICTION = 3;
	static final int TYPE_PARENT = 2;
	static final int TYPE_ASSOCIATION = 4;

	public static String toNameValue(String name, Object value)
	{
		return name + ": " + getObjectValue(value);
	}
*/

    private String object2String(Object obj)
    {
		if (obj == null) return null;
		Object newValue;
		String str = obj.toString();

		if (obj instanceof RDFSLiteral) {
			newValue = (RDFSLiteral) obj;

			RDFSLiteral literal = (RDFSLiteral) obj;
			if (literal.getLanguage() == null || literal.getLanguage().compareTo("") == 0 )
			{
				str = str.substring(2, str.length());
			}
			else if (str.length() > 6)//if (str.indexOf("~#") != -1)
			{
				str = str.substring(5, str.length());
			}

		}
		else if (obj instanceof Boolean) {
			newValue = Boolean.valueOf(str.equals("true"));
		}
		else if (obj instanceof Float) {
			newValue = Float.valueOf(str);
		}
		else if (obj instanceof Integer) {
			newValue = Integer.valueOf(str);
		}
		else {

			newValue = getPlainString(str);
		}

		return newValue.toString();
	}

	public String getPlainString(String s)	{
		String[] languages = NCIEditTab.owlModel.getUsedLanguages();
		if (s.indexOf("~#") == -1)
			return s;

		for (int i=0; i<languages.length; i++){
			if (s.startsWith("~#"+languages[i]+" "))
				return s.substring(5);
		}

		return s.substring(2);
	}


	public String toNameValue(String name, Object value)
	{
		return name + ": " + object2String(value);
	}


    public Vector getNameAndValues(int type)
    {
        Vector v = new Vector();
        ArrayList properties;
        ArrayList values;
        String name;
        String value;

        if (type == TreeItem.TYPE_PROPERTY)
        {
	 // preferred_name
			String pt = ptTextField.getText();
			pt = OWLWrapper.getPlainString(pt);
			v.add(toNameValue(getSlotName(NCIEditTab.PREFERRED_NAME), getObjectValue(pt)));

			// Synonym and PT Properties
			properties = (ArrayList) get_synonym_tablemodel().getProperties();
			values = (ArrayList) get_synonym_tablemodel().getValues();
			for (int i=0; i<properties.size(); i++)
			{
				RDFProperty property = (RDFProperty) properties.get(i);
				v.add(toNameValue(property.getName(), values.get(i)));
			}

			// Definition Properties
			properties = (ArrayList) get_definition_tablemodel().getProperties();
			values = (ArrayList) get_definition_tablemodel().getValues();
			for (int i=0; i<properties.size(); i++)
			{
				RDFProperty property = (RDFProperty) properties.get(i);
				v.add(toNameValue(property.getName(), values.get(i)));
			}

			// Other Properties
			properties = (ArrayList) get_property_tablemodel().getProperties();
			values = (ArrayList) get_property_tablemodel().getValues();
			for (int i=0; i<properties.size(); i++)
			{
				RDFProperty property = (RDFProperty) properties.get(i);
				if (!(property instanceof DefaultOWLObjectProperty))
				{
					v.add(toNameValue(property.getName(), values.get(i)));
				}
			}

			properties = (ArrayList) get_complex_property_tablemodel().getProperties();
			values = (ArrayList) get_complex_property_tablemodel().getValues();
			for (int i=0; i<properties.size(); i++)
			{
				RDFProperty property = (RDFProperty) properties.get(i);
				if (!(property instanceof DefaultOWLObjectProperty))
				{
					v.add(toNameValue(property.getName(), values.get(i)));
				}
			}
	    }

        else if (type == TreeItem.TYPE_ASSOCIATION)
        {
			// Associations
			properties = (ArrayList) get_association_tablemodel().getProperties();
			values = (ArrayList) get_association_tablemodel().getValues();
			for (int i=0; i<properties.size(); i++)
			{
				RDFProperty property = (RDFProperty) properties.get(i);
				OWLNamedClass owlCls = (OWLNamedClass) values.get(i);
				value = wrapper.getInternalName(owlCls);
				name = property.getName();
                v.add(toNameValue(name, value));
			}
	    }

        else if (type == TreeItem.TYPE_PARENT)
        {
			// Superconcepts
			ArrayList items = (ArrayList) get_superconcept_tablemodel().getItems();
			for (int i=0; i<items.size(); i++)
			{
				NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
				if (!tableItem.isSeparator())
				{
					//value = tableItem.getDisplayText();
					if (tableItem.getCls() instanceof OWLNamedClass)
					{
						value = wrapper.getInternalName(tableItem.getCls());
						v.add(SUBCLASSOF + ": " + value);
					}
				}
			}
	    }
        else if (type == TreeItem.TYPE_RESTRICTION)
        {
			// Restrictions
			ArrayList items = (ArrayList) get_restriction_tablemodel().getItems();
			for (int i=0; i<items.size(); i++)
			{
				NCIConditionsTableItem tableItem = (NCIConditionsTableItem) items.get(i);
				if (!tableItem.isSeparator() && !tableItem.isInherited())
				//if (!tableItem.isSeparator())
				{
					RDFSClass aClass = tableItem.aClass;
					if (!(aClass instanceof OWLNamedClass))
					{
						v.add(aClass.getBrowserText());
					}
				}
			}
	    }
		return v;
	}



    private Collection getExcludedProperties() {
        Collection properties = new ArrayList();
        Collection allowedProperties = kb.getRDFProperties();
        for (Iterator it = allowedProperties.iterator(); it.hasNext();) {
            RDFProperty property = (RDFProperty) it.next();
            if (property.isVisible() && property.hasObjectRange() && !property.isSystem()
                ) {
                properties.add(property);
            }
        }
        properties.add(kb.getOWLDisjointWithProperty());
        properties.add(kb.getOWLDifferentFromProperty());
        properties.add(kb.getOWLEquivalentPropertyProperty());
        properties.add(kb.getOWLSameAsProperty());
        properties.add(kb.getRDFProperty(RDFSNames.Slot.IS_DEFINED_BY));
        properties.add(kb.getRDFProperty(RDFSNames.Slot.SEE_ALSO));
        return properties;
    }



    private String getObjectValue(Object obj)
    {
		if (obj == null) return null;
		Object newValue;
		String str = obj.toString();

		if (str.indexOf("~#") != -1)
		{
			str = str.substring(5, str.length());
		}

		if (obj instanceof RDFSLiteral) {
			RDFSLiteral oldLiteral = (RDFSLiteral) obj;
			newValue = getOWLModel().createRDFSLiteral(str, oldLiteral.getDatatype());
		}
		else if (obj instanceof Boolean) {
			newValue = Boolean.valueOf(str.equals("true"));
		}
		else if (obj instanceof Float) {
			newValue = Float.valueOf(str);
		}
		else if (obj instanceof Integer) {
			newValue = Integer.valueOf(str);
		}
		else {
			newValue = str;
		}

		return newValue.toString();
	}


    public boolean confirmDeleteAction(String name) {
        return ProtegeUI.getModalDialogFactory().showConfirmDialog(kb,
                "The selected class " + name + " will be deleted. Are you sure you want to delete it?",
                "Confirm Delete");
    }

    public boolean confirmDeleteClassAction(String name) {
        return ProtegeUI.getModalDialogFactory().showConfirmDialog(kb,
                "The selected class " + name + " will be permanently deleted. Are you sure you want to delete it?",
                "Confirm Delete");
    }

	public void enableDelEditHB(int i, boolean b){
		if (i==1){
			if (hb_delete_1 == null) return;
			hb_delete_1.setEnabled(b);
			hb_edit_1.setEnabled(b);
		}else if (i==2){
			if (hb_delete_2 == null) return;
			hb_delete_2.setEnabled(b);
			hb_edit_2.setEnabled(b);
		}else if (i==3){
			if (hb_delete_3 == null) return;
			hb_delete_3.setEnabled(b);
			hb_edit_3.setEnabled(b);
		}else if (i==4){
			if (hb_delete_4 == null) return;
			hb_delete_4.setEnabled(b);
			hb_edit_4.setEnabled(b);
		}else if (i==5){
			if (hb_delete_5 == null) return;
			hb_delete_5.setEnabled(b);
			hb_edit_5.setEnabled(b);
		}else if (i==6){
			if (hb_delete_6 == null) return;
			hb_delete_6.setEnabled(b);
			hb_edit_6.setEnabled(b);
		}else if (i==7){
			if (hb_delete_7 == null) return;
			hb_delete_7.setEnabled(b);
			hb_edit_7.setEnabled(b);
		}
	}

	public void disableAll()
	{
		boolean b = false;
		hb_add_1.setEnabled(b);
		hb_add_2.setEnabled(b);
		hb_add_3.setEnabled(b);
		hb_add_4.setEnabled(b);
		hb_add_5.setEnabled(b);
		hb_add_6.setEnabled(b);
		hb_add_7.setEnabled(b);

		hb_delete_1.setEnabled(b);
		hb_edit_1.setEnabled(b);
		hb_delete_2.setEnabled(b);
		hb_edit_2.setEnabled(b);
		hb_delete_3.setEnabled(b);
		hb_edit_3.setEnabled(b);
		hb_delete_4.setEnabled(b);
		hb_edit_4.setEnabled(b);
		hb_delete_5.setEnabled(b);
		hb_edit_5.setEnabled(b);
		hb_delete_6.setEnabled(b);
		hb_edit_6.setEnabled(b);
		hb_delete_7.setEnabled(b);
		hb_edit_7.setEnabled(b);

        if (newButton_Modify != null)
        {
			newButton_Modify.setEnabled(b);
	    }
		deleteButton_Modify.setEnabled(b);
	}

	public void enableAddButtons()
	{
		enableAddButtons(true);
	}


	public void enableAddButtons(boolean b)
	{
		hb_add_1.setEnabled(b);
		hb_add_2.setEnabled(b);
		hb_add_3.setEnabled(b);
		hb_add_4.setEnabled(b);
		hb_add_5.setEnabled(b);
		hb_add_6.setEnabled(b);
		hb_add_7.setEnabled(b);
	}



	public String getSlotName(String name)
	{
		return wrapper.getSlotName(name);
	}


    public boolean itemExists(String s, int type)
    {
		Vector nv_vec = getNameAndValues(type);
        for (int i=0; i<nv_vec.size(); i++)
        {
			String t = (String) nv_vec.elementAt(i);
			if (t.compareTo(s) == 0)
			{
				return true;
			}
		}
		return false;
	}

    private String getLanguage(Object obj)
    {
		if (obj == null) return null;
		if (obj instanceof RDFSLiteral) {
			RDFSLiteral literal = (RDFSLiteral) obj;
			return literal.getLanguage();
		}
		return null;
	}

	//101306
	private boolean isSystemCls(){
		Instance selectedInstance = getSelectedInstance();

		//120606
		if (AdvancedQuery.equals("AdvancedQuery"))
		{
			selectedInstance = focusCls;
		}

		if (selectedInstance==null) return true;

		Cls cls = (Cls) selectedInstance;
		if (wrapper.getInternalName(cls).compareTo("owl:Thing") == 0 ||
				wrapper.getInternalName(cls).compareTo("rdfs:Class") == 0 ||
				wrapper.getInternalName(cls).compareTo("rdf:Property") == 0){
			return true;
		}

		return false;
	}
}

