package gov.nih.nci.protegex.edit;
import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;

import javax.swing.tree.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class ModifyPropertyDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextArea ta;
	String separator;
	String prop_value;
	DefaultMutableTreeNode dmtn = null;
	String prop_name;
	NCIEditTab tab;
	DefaultTreeModel model = null;

    public ModifyPropertyDialog(NCIEditTab tab, DefaultMutableTreeNode dmtn,
    	                        DefaultTreeModel model)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Modify Property", true);
		this.dmtn = dmtn;
		this.prop_value = (String) dmtn.getUserObject().toString();
		this.tab = tab;
		this.model = model;
	}

    public ModifyPropertyDialog(NCIEditTab tab, DefaultMutableTreeNode dmtn,
    	                        DefaultTreeModel model, String label)
    {
		super((JFrame)tab.getTopLevelAncestor(), label, true);
		this.dmtn = dmtn;
		this.prop_value = (String) dmtn.getUserObject().toString();
		this.tab = tab;
		this.model = model;
	}

	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new GridBagLayout());

        String propertyStr = (String) dmtn.getUserObject().toString();
        System.out.println("Property: " + propertyStr);

		int pos = propertyStr.indexOf(": ");

		//System.out.println("pos: " + pos);

		prop_name = propertyStr.substring(0, pos);
		//System.out.println("Property name: " + prop_name);

		String abs_prop_value = prop_value.substring(pos+2);
		//System.out.println("Property value: " + abs_prop_value);

/*
        JScrollPane scrollpane = new JScrollPane();

		JLabel label = new JLabel("New value: ");
		tf = new JTextArea(abs_prop_value);
		boolean wrap = true;
		tf.setLineWrap(wrap);
		tf.setPreferredSize(new Dimension (200, 100));

        JPanel midPanel = new JPanel();

		midPanel.add(label, BorderLayout.NORTH);
		//midPanel.add(tf, BorderLayout.CENTER);

		midPanel.add(tf, BorderLayout.CENTER);

		//scrollpane.add(label, BorderLayout.NORTH);
		//scrollpane.add(tf, BorderLayout.CENTER);
*/

        JPanel midPanel = new JPanel();
        midPanel.setLayout(new BorderLayout());

		JLabel label2 = new JLabel("New Value: ");

		ta = new JTextArea(abs_prop_value);
		boolean wrap = true;
		ta.setLineWrap(wrap);
		JScrollPane valuePane = new JScrollPane(ta);
		//valuePane.setPreferredSize(new Dimension (200, 100));
		valuePane.setPreferredSize(new Dimension (300, 200));
		midPanel.add(label2, BorderLayout.NORTH);
		midPanel.add(valuePane, BorderLayout.CENTER);
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(midPanel, gridbagconstraints1);

/*
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(midPanel, gridbagconstraints1);
*/
		//contain.add(scrollpane, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(buttonPanel, gridbagconstraints1);

		pack();
		this.setVisible(true);
   	}

	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			String s = ta.getText().trim();
			if (!s.equals("")){
				TreeItem item = (TreeItem) dmtn.getUserObject();
				item.setValue(s);
				item.setNameValue(prop_name + ": " + s);
				//dmtn.setUserObject((Object) prop_name + ": " + s);
				dmtn.setUserObject((Object) item);
				model.reload();
				dispose();
			}
		} else if (action == cancelButton)
		{
			dispose();
		}
	}

}
