package gov.nih.nci.protegex.edit;

import java.awt.* ;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.tree.*;

import org.w3c.dom.*;
import org.apache.xerces.parsers.*;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.InputSource;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class ModifyPropertyDialog2 extends ModifyPropertyDialog
{
	private static final String DEFAULT_SAX_DRIVER_CLASS ="org.apache.xerces.parsers.SAXParser";
	Hashtable name2val_hashmap;
	JList name_list;
	DefaultListModel name_model;
	JTextArea ta;

	String prev_selected_name = "";

    public ModifyPropertyDialog2(NCIEditTab tab, DefaultMutableTreeNode dmtn,
    	DefaultTreeModel model)
    {
		super(tab,dmtn, model);
		name2val_hashmap = new Hashtable();
		name_model = new DefaultListModel();
	}

    public ModifyPropertyDialog2(NCIEditTab tab, DefaultMutableTreeNode dmtn,
    	DefaultTreeModel model, String label)
    {
		super(tab, dmtn, model, label);
		name2val_hashmap = new Hashtable();
		name_model = new DefaultListModel();
	}


	public void init()
	{
		Container contain = this.getContentPane();
		setLocation(360,300);
		contain.setLayout(new GridBagLayout());

        String propertyStr = dmtn.getUserObject().toString();
		int pos = propertyStr.indexOf(": ");

		prop_name = propertyStr.substring(0, pos);

		String abs_prop_value = prop_value.substring(pos+2);

        JPanel midPanel = new JPanel();
        midPanel.setLayout(new BorderLayout());

		JLabel label2 = new JLabel("New Value: ");

		parseXML(abs_prop_value);
		if (name2val_hashmap.size()==0){
			String msg = "The XML format is not valid.";
			JOptionPane.showMessageDialog(null, msg, "alert", JOptionPane.ERROR_MESSAGE);
			return;
		}

		String key;
		Enumeration keys = name2val_hashmap.keys();
		while  (keys.hasMoreElements()){
			key = (String) keys.nextElement();
			name_model.addElement(key);
		}

		ta = new JTextArea("");
		ta.setLineWrap(true);
		JScrollPane value_pane = new JScrollPane(ta);
		//value_pane.setPreferredSize(new Dimension (200, 100));
		value_pane.setPreferredSize(new Dimension (300, 200));

		name_list = new JList(name_model);
		name_list.setSelectedIndex(0);
		//String s=(String)name_list.getSelectedValue();
		prev_selected_name = (String)name_list.getSelectedValue();

		ta.setText((String)name2val_hashmap.get(prev_selected_name));
		name_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		add(name_list);
		JScrollPane name_pane = new JScrollPane(name_list);
		//name_pane.setPreferredSize(new Dimension (200, 100));
		name_pane.setPreferredSize(new Dimension (200, 200));

		MouseInputListener l = new MouseInputAdapter() {
			private transient int selected = -1;
		    public void mouseClicked(MouseEvent e) {
	            int row = name_list.locationToIndex(e.getPoint());
	            if (row != -1){
					if (prev_selected_name.compareTo("") != 0)
					{
						String prop_value = ta.getText().trim();
						String prev_prop_value
						   = (String) name2val_hashmap.put((Object) prev_selected_name,
						                                   (Object) prop_value);
				    }

					String selected_name = (String) name_list.getSelectedValue();
					prev_selected_name = selected_name;
					ta.setText((String)name2val_hashmap.get(selected_name));
				}
		    }
	    };

	    name_list.addMouseListener(l);

		JPanel pane_panel = new JPanel();
		pane_panel.add(name_pane);
		pane_panel.add(value_pane);

		midPanel.add(label2, BorderLayout.NORTH);
		midPanel.add(pane_panel, BorderLayout.CENTER);
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(midPanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(buttonPanel, gridbagconstraints1);

		pack();
		this.setVisible(true);
   	}

 	public void parseXML(String xml)
	{
		xml="<?xml version=\"1.0\"?><fake>"+xml+"</fake>";
		try
		{
			DOMParser parser = new DOMParser();
			BufferedReader reader = new BufferedReader(new StringReader(xml));
			InputSource inputsource = new InputSource(reader);
			parser.parse(inputsource);
			Document document = parser.getDocument();
			traverse (document);
			reader.close();
		} catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
	}

	private String formatPropertyValue()
	{
		if (prev_selected_name.compareTo("") != 0)
		{
			String prop_value = ta.getText().trim();
			String t = (String) name2val_hashmap.put((Object) prev_selected_name,
													 (Object) prop_value);
		}

		String xml = "";
		Iterator iter = name2val_hashmap.keySet().iterator();
		while (iter.hasNext())
		{
		    String key = (String) iter.next();
			String value = (String) name2val_hashmap.get(key);
			xml = xml + "<" + key + ">" + value + "</" + key + ">";
		}
		return xml;
	}

    private void traverse (Node node)
    {
        int type = node.getNodeType();
        if (type == Node.ELEMENT_NODE)
        {
            String nodename = node.getNodeName();
			NodeList children = node.getChildNodes();
			if (children!=null && children.item(0)!=null){
				String nodevalue = children.item(0).getNodeValue();
				if (nodevalue!=null)
					name2val_hashmap.put(nodename, nodevalue);
			}
		}
		NodeList children = node.getChildNodes();
        if (children != null) {
            for (int i=0; i< children.getLength(); i++)
                traverse (children.item(i));
        }
    }

	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			String s = formatPropertyValue();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			String prop_name = item.getName();
			item.setValue(s);
			item.setNameValue(prop_name + ": " + item.getValue());
			dmtn.setUserObject((Object) item);
			model.reload();
			dispose();
		}
		else if (action == cancelButton)
		{
			dispose();
		}
	}

}
