package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protegex.owl.ui.components.triples.*;

import com.hp.hpl.jena.datatypes.xsd.impl.XMLLiteralType;
import edu.stanford.smi.protege.ui.FrameComparator;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.model.event.PropertyValueAdapter;
import edu.stanford.smi.protegex.owl.model.event.PropertyValueListener;
import edu.stanford.smi.protegex.owl.model.impl.DefaultRDFSLiteral;
import edu.stanford.smi.protegex.owl.model.impl.XMLSchemaDatatypes;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.metadata.AnnotationsWidgetPlugin;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import java.net.URI;
import java.util.*;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;

import javax.swing.table.DefaultTableModel;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.components.annotations.*;

import edu.stanford.smi.protegex.owl.model.RDFSNames;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIAnnotationsTableModel extends AbstractTableModel {

    private JTextField textField;

    private JComboBox typeComboBox;

    private boolean isModified = false;
    /**
     * The list of Properties currently displayed
     */
    private ArrayList properties = new ArrayList();


    /**
     * The resource being annotated
     */
    private RDFResource subject;

    private JTable table;

    /**
     * The initial list of Properties
     */

    private Vector userDefinedRelevantProperties;
    private Vector excludedProperties;

    private boolean objectValuedOnly;

    private ArrayList init_properties = new ArrayList();
    private ArrayList init_values = new ArrayList();

    private final String SUBPROPERTYOF = "rdfs:subPropertyOf";

    private Vector u = null;

    OWLModel owlModel = null;

    int tablemodel_type = 0;

    boolean is_complex;

    boolean hasPropertyColumn = true;

    public static final int COL_DEFINITION_VALUE = 0;

    EditPanel edit_panel = null;

	//062906
	int type;

    /**
     * A FrameListener that detects any changes in own slot values of annotation
     * properties and then updates the table model accordingly.
     */

    private PropertyValueListener valueListener = new PropertyValueAdapter() {
        public void propertyValueChanged(RDFResource resource, RDFProperty property, Collection oldValues) {
            if (isRelevantProperty(property)) {
                //updateValues();
            }
        }
    };


    /**
     * The values currently displayed in each row (either plain values or RDFObjects)
     */
    private ArrayList values = new ArrayList();
    private HashMap value2xml_map = new HashMap();

    public final static int COL_PROPERTY = 0;
    public final static int COL_VALUE = 1;


    public final static int SIMPLE_PROPERTY_MODEL = 1;
    public final static int COMPLEX_PROPERTY_MODEL = 2;
    public final static int OBJECT_PROPERTY_MODEL = 4;

    int qualifier_tblmodel_id = -1;


    public NCIAnnotationsTableModel(OWLModel owlModel) {
		this.owlModel = owlModel;
		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
        initialize();
    }



	public void setHasPropertyColumn(boolean hasPropertyColumn){
		this.hasPropertyColumn = hasPropertyColumn;
	}

	public boolean getHasPropertyColumn(){
		return hasPropertyColumn;
	}

    public boolean isComplex()
    {
		return is_complex;
	}

	public int get_qualifier_tblmodel_id()
	{
		return qualifier_tblmodel_id;
	}

    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
    		RDFResource subject, int type) {
		this.owlModel = owlModel;
		this.type=type;

		this.edit_panel = edit_panel;
		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
		this.objectValuedOnly = false;
        this.subject = subject;
        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
			initialize();
	    }

        refill();
    }

    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
    		RDFResource subject, Vector v, int type) {

		this.owlModel = owlModel;
		this.type=type;


		this.edit_panel = edit_panel;
		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
		this.objectValuedOnly = false;
        this.subject = subject;

        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        for (int i=0; i<v.size(); i++)
        {
			userDefinedRelevantProperties.add((String) v.elementAt(i));
		}

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
			initialize();
	    }
        refill();
    }

    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
    		RDFResource subject, Vector v, int qualifier_tblmodel_id, int type) {

		this.owlModel = owlModel;
		this.type=type;

		this.edit_panel = edit_panel;
		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
		this.objectValuedOnly = false;
        this.subject = subject;
        this.qualifier_tblmodel_id = qualifier_tblmodel_id;

        if (qualifier_tblmodel_id > 0)
        {
			is_complex = true;
		}

        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        for (int i=0; i<v.size(); i++)
        {
			userDefinedRelevantProperties.add((String) v.elementAt(i));
		}

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
			initialize();
	    }
        refill();
    }



    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
    		RDFResource subject, Vector v, Vector w, int type) {
		this.owlModel = owlModel;
		this.type=type;

		this.edit_panel = edit_panel;

		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
		this.objectValuedOnly = false;
        this.subject = subject;
        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        for (int i=0; i<v.size(); i++)
        {
			userDefinedRelevantProperties.add((String) v.elementAt(i));
		}
        for (int i=0; i<w.size(); i++)
        {
			excludedProperties.add((String) w.elementAt(i));
		}

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
/*
			if (type == 3)
			{
				RDFProperty commentSlot = owlModel.getRDFProperty(RDFSNames.Slot.COMMENT);
				u.add(commentSlot);
			}
*/
			initialize();
	    }
		refill();
    }

    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
                RDFResource subject, Vector v, Vector w, int qualifier_tblmodel_id,
                int type) {
		this.owlModel = owlModel;
		this.type=type;

		this.edit_panel = edit_panel;

		this.userDefinedRelevantProperties = new Vector();
		this.excludedProperties = new Vector();
		this.objectValuedOnly = false;
        this.subject = subject;
        this.qualifier_tblmodel_id = qualifier_tblmodel_id;
        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        for (int i=0; i<v.size(); i++)
        {
			userDefinedRelevantProperties.add((String) v.elementAt(i));
		}
        for (int i=0; i<w.size(); i++)
        {
			excludedProperties.add((String) w.elementAt(i));
		}

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
			initialize();
	    }
		refill();
    }



    public void setModelType(int type)
    {
		tablemodel_type = type;
		is_complex = false;
		if (tablemodel_type == COMPLEX_PROPERTY_MODEL)
		{
			is_complex = true;
		}
	}



    public EditPanel getEditPanel()
    {
		return edit_panel;
    }



    public NCIAnnotationsTableModel(OWLModel owlModel, EditPanel edit_panel,
    		RDFResource subject, Vector w, boolean objectValuedOnly, int type) {
        this.owlModel = owlModel;
        this.edit_panel = edit_panel;
		this.type=type;

		setModelType(type);

		userDefinedRelevantProperties = new Vector();
		excludedProperties = new Vector();
		this.objectValuedOnly = objectValuedOnly;
        this.subject = subject;
        if (subject != null) {
            subject.addPropertyValueListener(valueListener);
        }

        for (int i=0; i<w.size(); i++)
        {
			excludedProperties.add((String) w.elementAt(i));
		}

        if (subject != null)
        {
			owlModel = (OWLModel) subject.getKnowledgeBase();
			u = new Vector();
			u.add(owlModel.getOWLDifferentFromProperty());
			u.add(owlModel.getOWLDisjointWithProperty());
			u.add(owlModel.getOWLEquivalentPropertyProperty());
			u.add(owlModel.getOWLSameAsProperty());
			u.add(owlModel.getRDFSIsDefinedByProperty());
			RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
			u.add(seeAlsoSlot);
			initialize();
	    }
        refill();
    }

    private void initialize() {
        if (subject == null) return;

		//062906
		if (edit_panel==null)
			System.out.println("edit_panel is null");
		edit_panel.enableDelEditHB(type, false);

        OWLModel owlModel = (OWLModel) subject.getKnowledgeBase();

        // For Assocations and other object valued properties

		if (objectValuedOnly)
		{
			Vector v = new Vector();
			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (property.isAnnotationProperty()
				    && property.hasObjectRange()
				    && property instanceof DefaultOWLObjectProperty
				    && !excludedProperties.contains(property.getName()))
				{
				    v.add(property);
				}
			}

            v.add(owlModel.getOWLDifferentFromProperty());
            v.add(owlModel.getOWLDisjointWithProperty());
            v.add(owlModel.getOWLEquivalentPropertyProperty());
            v.add(owlModel.getOWLSameAsProperty());
            v.add(owlModel.getRDFSIsDefinedByProperty());

            RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
            v.add(seeAlsoSlot);

            for (int i=0; i<v.size(); i++)
            {
				RDFProperty property = (RDFProperty) v.elementAt(i);
				if(property.isVisible()) {
					Collection c = subject.getPropertyValues(property);
					for (Iterator it = c.iterator(); it.hasNext();) {
						Object value = it.next();

						this.init_properties.add(property);
						this.init_values.add(value);

						OWLNamedClass cls = (OWLNamedClass) value;
					}
				}
			}

			v.clear();
		}
		else
		{
            Collection c = getRelevantProperties();
            RDFProperty[] ss = (RDFProperty[]) c.toArray(new RDFProperty[0]);

            Arrays.sort(ss, new FrameComparator());
            for (int i = 0; i < ss.length; i++) {
                RDFProperty property = ss[i];
                if (property.isAnnotationProperty() && !(property instanceof DefaultOWLObjectProperty))
                {
					//if (userDefinedRelevantProperties.contains(property.getBrowserText()))
					if (userDefinedRelevantProperties.contains(property.getName()))
					{
						if(property.isVisible()) {
							Collection c2 = subject.getPropertyValues(property);

							for (Iterator it = c2.iterator(); it.hasNext();) {
								Object value = it.next();

								this.init_properties.add(property);
								this.init_values.add(value);
							}
						}
					}

					else if (userDefinedRelevantProperties.size() == 0
						  //&& !excludedProperties.contains(property.getBrowserText()))
						  && !excludedProperties.contains(property.getName()))
					{
						//if(property.isVisible() && property.getBrowserText().compareTo(SUBPROPERTYOF) != 0) {
							if(property.isVisible() && property.getName().compareTo(SUBPROPERTYOF) != 0) {
							Collection c2 = subject.getPropertyValues(property);

							//070506
							//if (property.getBrowserText().indexOf("comment")!=-1){
								if (property.getName().indexOf("comment")!=-1){
								if (c2.size()==0){
									init_properties.add(property);
									init_values.add("");
								}
							}

							for (Iterator it = c2.iterator(); it.hasNext();) {
								Object value = it.next();

								this.init_properties.add(property);
								this.init_values.add(value);
							}

						}
					}
			    }

            }

	        for(Iterator it = getDefaultProperties().iterator(); it.hasNext(); ) {
		        RDFProperty curProp = (RDFProperty) it.next();
		        if(this.properties.contains(curProp) == false) {

			        this.init_properties.add(0, curProp);
			        this.init_values.add(0, null);
		        }
	        }
		}

    }



    public int addRow(RDFProperty property) {


System.out.println("addRow " + property.toString());


        Object value = createDefaultValue(property);
        if (value != null) {
            return addRow(property, value);
        }
        else {
            return -1;
        }
    }

//////////////////////////////////////////////////////////////////////

    private boolean hasPropertyValue(RDFProperty property, Object value) {
		if (property == null || value == null) return false;

        int index = getPropertyValueRow(property, value);
        if (index >= 0 && index < getRowCount())
        {
			return true;
		}
		/*
		if (!property_map_1.getKeys().contains((Object)property)) return false;

		Vector v = (Vector) property_map_1.getValues((Object)property);
		if (v.contains(value)) return true;
		*/

		return false;
	}

    public void addPropertyValue(RDFProperty property, Object value) {
        int index = getPropertyValueRow(property, value);

        if (index >= 0 && index < getRowCount())
        {
			System.out.println("addPropertyValue: property already exists -- nothing done.");
			return;
		}
        if (isComplex())
        {
			properties.add(property);
			values_add(value);
		}
		else
		{
			// 100606
            properties.add(property);
			values.add(value);
		}

        updateValues();
	}


    public void removePropertyValue(RDFProperty property, Object value) {
        int index = getPropertyValueRow(property, value);
        if (index >= 0 && index < getRowCount())
        {
			properties.remove(index);
			if (isComplex())
			{
				values_remove(index);
			}
			else
			{
				values.remove(index);
			}

			updateValues();
		}
	}



//////////////////////////////////////////////////////////////////////

/*

    public int addRow(RDFProperty property, Object value) {

        if (!subject.hasPropertyValue(property, value)) {
//KLO #1
            subject.addPropertyValue(property, value);
            addPropertyValue(property, value);
            isModified = true;
        }
        return getPropertyValueRow(property, value);
    }
*/
    public int addRow(RDFProperty property, Object value) {
        if (!hasPropertyValue(property, value)) {
            addPropertyValue(property, value);
            isModified = true;
        }

        int index = getPropertyValueRow(property, value);
        return index;
    }



    private Object createDefaultValue(RDFProperty property) {
        for (Iterator it = TriplesComponent.plugins(); it.hasNext();) {
            AnnotationsWidgetPlugin plugin = (AnnotationsWidgetPlugin) it.next();
            if (plugin.canEdit(subject, property, null)) {
                Object defaultValue = plugin.createDefaultValue((RDFResource) subject, property);
                if (defaultValue != null) {
                    return defaultValue;
                }
            }
        }
        RDFResource range = property.getRange();
        if (range instanceof RDFSDatatype) {
            return ((RDFSDatatype) range).getDefaultValue();
        }
        else if (range instanceof OWLDataRange) {
            OWLDataRange dataRange = (OWLDataRange) range;
            RDFList oneOf = dataRange.getOneOf();
            Object firstValue = null;
            if (oneOf != null) {
                Collection values = oneOf.getValues();
                if (!values.isEmpty()) {
                    firstValue = values.iterator().next();
                }
            }
            return firstValue;
        }
        else if (property instanceof OWLObjectProperty) {
            return null;
        }
        else {
            return "";
        }
    }


    private Object createNewValue(RDFProperty property, String text, String language) {
        Object newValue = null;
        if (language == null || language.trim().length() == 0) {
            newValue = text;
        }
        else {
            newValue = property.getOWLModel().createRDFSLiteralOrString(text, language);
        }
        return newValue;
    }

    private Object createNewValue(String text, String language) {
        Object newValue = null;
        if (language == null || language.trim().length() == 0) {
            newValue = text;
        }
        else {
            newValue = owlModel.createRDFSLiteralOrString(text, language);
        }
        return newValue;
    }



    public void deleteRow(int rowIndex) {
        RDFProperty property = getPredicate(rowIndex);
        Object value = getValue(rowIndex);
        removePropertyValue(property, value);
        isModified = true;
    }

    public void dispose() {
        if (subject != null) {
            subject.removePropertyValueListener(valueListener);
        }
    }

    public Class getColumnClass(int column) {
		if (hasPropertyColumn){
			if (column == COL_PROPERTY) {
				return RDFProperty.class;
			}
			else if (column == COL_VALUE) {
				return Object.class;
			}
			else if (hasTypeColumn() && column == COL_VALUE + 1) {
				return RDFResource.class;
			}
			else {
				return String.class;
			}
		}else
			return String.class;
    }


	//062206
    public int getColumnCount() {
        //return hasTypeColumn() ? 4 : 3;
        if (hasTypeColumn())
        	return 4;
        else if (hasPropertyColumn){
			if (type==OBJECT_PROPERTY_MODEL)
				return 2;
			else
        		return 3;
		}

        return 2;
    }

	//062206
    public String getColumnName(int column)
    {
		if (hasPropertyColumn){
			if (column == COL_PROPERTY) {
				return "Property";
			}
			else if (column == COL_VALUE) {
				return "Value";
			}
			else if (isTypeColumn(column)) {
				return "Type";
			}
			else {
				return "Lang";
			}
		}else{
			if (column == 0)
				return "Value";
			else
				return "Lang";
		}
    }



    public Object getDisplayValue(int rowIndex) {
        Object value = values.get(rowIndex);
        if (value instanceof RDFSLiteral) {
            return ((RDFSLiteral) value).getString();
        }
        return value;
    }


    public String getLanguage(int row) {
        Object value = getValue(row);
        if (value instanceof RDFSLiteral) {
            return ((RDFSLiteral) value).getLanguage();
        }
        return null;
    }


    public OWLModel getOWLModel() {
        //return subject.getOWLModel();
        return owlModel;
    }


    public RDFProperty getPredicate(int rowIndex) {
        return (RDFProperty) properties.get(rowIndex);
    }


    public int getPropertyValueRow(RDFProperty property, Object value) {
        for (int i = 0; i < properties.size(); i++) {
            RDFProperty s = getPredicate(i);
            if (s.equals(property)) {
                if (value == null && getValue(i) == null) {
                    return i;
                }
                else if (value != null && value.equals(getValue(i))) {
                    return i;
                }
            }
        }
        return -1;
    }


    protected Collection getRelevantProperties() {
        OWLModel owlModel = subject.getOWLModel();
        return owlModel.getRDFProperties();
    }


    public int getRowCount() {
        return properties.size();
    }


    public RDFResource getSubject() {
        return subject;
    }

/*
    public Object getValueAt(int rowIndex, int columnIndex) {
        if (columnIndex == COL_PROPERTY) {
            return getPredicate(rowIndex);
        }
        else if (columnIndex == COL_VALUE) {
            return getDisplayValue(rowIndex);
        }
        else if (isTypeColumn(columnIndex)) {
            Object value = getValue(rowIndex);
            if (value instanceof RDFResource) {
                return ((RDFResource) value).getRDFType();
            }
            else if (value instanceof RDFSLiteral) {
                return ((RDFSLiteral) value).getDatatype();
            }
            else {
                RDFSLiteral literal = DefaultRDFSLiteral.create(getOWLModel(), value);
                return literal.getDatatype();
            }
        }
        else {
            return getLanguage(rowIndex);
        }
    }
*/

	//062206
    public Object getValueAt(int rowIndex, int columnIndex) {
        if (hasPropertyColumn){
			if (columnIndex == COL_PROPERTY) {
				return getPredicate(rowIndex);
			}
			else if (columnIndex == COL_VALUE) {
				return getDisplayValue(rowIndex);
			}
			else if (isTypeColumn(columnIndex)) {
				Object value = getValue(rowIndex);
				if (value instanceof RDFResource) {
					return ((RDFResource) value).getRDFType();
				}
				else if (value instanceof RDFSLiteral) {
					return ((RDFSLiteral) value).getDatatype();
				}
				else {
					RDFSLiteral literal = DefaultRDFSLiteral.create(getOWLModel(), value);
					return literal.getDatatype();
				}
			}
			else {
				return getLanguage(rowIndex);
			}
		}else{
			if (columnIndex==0)
				return getDisplayValue(rowIndex);
			else
				return getLanguage(rowIndex);
		}
    }



    public Object getValue(int rowIndex) {
        return values.get(rowIndex);
    }


    protected boolean hasTypeColumn() {
        //return true;
        return false;
    }


    public boolean isCellEditable(int rowIndex, int columnIndex) {
		if (type == OBJECT_PROPERTY_MODEL) return false;

		if (columnIndex == getColumnCount()-1)
			return true;
		return false;

        /*if (columnIndex != COL_PROPERTY) {
            RDFProperty property = getPredicate(rowIndex);
            if (columnIndex == COL_VALUE) {
                Object value = getValue(rowIndex);
                for (Iterator it = TriplesComponent.plugins(); it.hasNext();) {
                    AnnotationsWidgetPlugin plugin = (AnnotationsWidgetPlugin) it.next();
                    if (plugin.canEdit(subject, property, value)) {
                        return false;
                    }
                }
                OWLModel owlModel = property.getOWLModel();
                return (property instanceof OWLDatatypeProperty &&
                        !property.isReadOnly() &&
                        owlModel.getTripleStoreModel().isActiveTriple(subject, property, value)) ||
                       getDefaultProperties().contains(property) && value == null;
            }
            else if (isTypeColumn(columnIndex)) {
                return getValueAt(rowIndex, columnIndex) instanceof RDFSDatatype;
            }
            else {
                return property instanceof OWLDatatypeProperty &&
                        property.getOWLModel().getXSDstring().equals(property.getRange()) &&
                        !property.isReadOnly();
            }
        }
        else {
            return false;
        }*/
    }


    public boolean isDeleteEnabled(int row) {
        RDFProperty predicate = getPredicate(row);
        Object object = getValue(row);
        return edu.stanford.smi.protegex.owl.ui.actions.triple.DeleteTripleAction.isSuitable(subject, predicate, object);
    }


    public static boolean isInvalidXMLLiteral(RDFProperty property, Object value) {
        if (XMLSchemaDatatypes.isXMLLiteralSlot(property) && value instanceof String) {
            if (!XMLLiteralType.theXMLLiteralType.isValid((String) value)) {
                ProtegeUI.getModalDialogFactory().showErrorMessageDialog(property.getOWLModel(),
                        "This value is not a valid XML literal:\n" + value);
                return true;
            }
        }
        return false;
    }


    protected boolean isRelevantProperty(RDFProperty property) {
        return true;
    }


    private boolean isTypeColumn(int column) {
        return hasTypeColumn() && column == COL_VALUE + 1;
    }


    private void refill() {
        if (subject == null) return;

        OWLModel owlModel = (OWLModel) subject.getKnowledgeBase();

        // For Assocations and other object valued properties

		if (objectValuedOnly)
		{
			Vector v = new Vector();
			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			//Collection selectableProperties = new ArrayList();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (property.isAnnotationProperty()
				    && property.hasObjectRange()
				    && property instanceof DefaultOWLObjectProperty
				    //&& !excludedProperties.contains(property.getBrowserText()))
				    && !excludedProperties.contains(property.getName()))
				{
					//selectableProperties.add(property);
				    v.add(property);
				}
			}

            v.add(owlModel.getOWLDifferentFromProperty());
            v.add(owlModel.getOWLDisjointWithProperty());
            v.add(owlModel.getOWLEquivalentPropertyProperty());
            v.add(owlModel.getOWLSameAsProperty());
            v.add(owlModel.getRDFSIsDefinedByProperty());

            RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
            v.add(seeAlsoSlot);
            for (int i=0; i<v.size(); i++)
            {
				RDFProperty property = (RDFProperty) v.elementAt(i);
                Collection c2 = subject.getPropertyValues(property);

				//if(property.isVisible()) {

					for (Iterator it = c2.iterator(); it.hasNext();) {
						Object value = it.next();

						this.properties.add(property);
                        if (isComplex())
                        {
							this.values_add(value);

						}
						else
						{

					    	this.values.add(value);
					    }
					}
				//}
			}
			v.clear();
		}
		else
		{
            Collection c = getRelevantProperties();
            RDFProperty[] ss = (RDFProperty[]) c.toArray(new RDFProperty[0]);

            Arrays.sort(ss, new FrameComparator());
            for (int i = 0; i < ss.length; i++) {
                RDFProperty property = ss[i];
                if (property.isAnnotationProperty() && !(property instanceof DefaultOWLObjectProperty))
                {
					//if (userDefinedRelevantProperties.contains(property.getBrowserText()))
					if (userDefinedRelevantProperties.contains(property.getName()))
					{
						if(property.isVisible()) {
							Collection values = subject.getPropertyValues(property);
							for (Iterator it = values.iterator(); it.hasNext();) {
								Object value = it.next();

								this.properties.add(property);

								if (isComplex())
								{
									values_add(value);
								}
								else
								{
									this.values.add(value);
								}

							}
						}
					}

					else if (userDefinedRelevantProperties.size() == 0
						  //&& !excludedProperties.contains(property.getBrowserText()))
						  && !excludedProperties.contains(property.getName()))
					{
						//if(property.isVisible() && property.getBrowserText().compareTo(SUBPROPERTYOF) != 0) {
							if(property.isVisible() && property.getName().compareTo(SUBPROPERTYOF) != 0) {
							Collection c2 = subject.getPropertyValues(property);


							//070506
							//if (property.getBrowserText().indexOf("comment")!=-1){
							if (property.getName().indexOf("comment")!=-1){
								if (c2.size()==0){
									properties.add(property);
									values.add("");
								}
							}

							for (Iterator it = c2.iterator(); it.hasNext();) {
								Object value = it.next();

								this.properties.add(property);


								if (isComplex())
								{
									values_add(value);
								}
								else
								{
									this.values.add(value);
								}
							}

						}
					}
			    }

            }

	        for(Iterator it = getDefaultProperties().iterator(); it.hasNext(); ) {

		        RDFProperty curProp = (RDFProperty) it.next();
		        if(this.properties.contains(curProp) == false) {

			        this.properties.add(0, curProp);

                    if (isComplex())
                    {
						values_add(0, null);
					}
					else
					{
			        	this.values.add(0, null);
				    }
		        }
	        }

		}

		if (values.size() >0) {
			if (table != null) {
				table.getSelectionModel().setSelectionInterval(0, 0);
			}
			if (qualifier_tblmodel_id > 0)
			{
				edit_panel.updateQualifierTable(qualifier_tblmodel_id);
			}
			edit_panel.enableDelEditHB(type, true);
		}
    }


    private void setDatatype(int row, RDFSDatatype datatype) {
        Object oldValue = getValue(row);
        final String lexicalValue = oldValue.toString();
        RDFSLiteral newValue = datatype.getOWLModel().createRDFSLiteral(lexicalValue, datatype);
        RDFProperty predicate = getPredicate(row);

        //subject.removePropertyValue(predicate, oldValue);
        removePropertyValue(predicate, oldValue);

        //subject.addPropertyValue(predicate, newValue);
        addPropertyValue(predicate, newValue);
    }

/*
    private Object setLanguage(int row, String newLanguage) {
        RDFProperty property = getPredicate(row);
        Object text = getDisplayValue(row);

		if (isComplex())
			text = value2xml_map.get(text);

        Object newValue = createNewValue(property, text.toString(), newLanguage);
        if (!subject.getPropertyValues(property).contains(newValue)) {
             Object oldValue = getValue(row);

             //subject.removePropertyValue(property, oldValue);
			removePropertyValue(property, oldValue);

             //subject.addPropertyValue(property, newValue);
			addPropertyValue(property, newValue);
        }

        table.getSelectionModel().setSelectionInterval(getRowCount()-1, getRowCount()-1);
        return newValue;
    }
*/

    //010307
    private Object setLanguage(int row, String newLanguage) {
        RDFProperty property = getPredicate(row);
        Object text = getDisplayValue(row);

		if (isComplex())
		{
			text = value2xml_map.get(text);
		}

        Object newValue = createNewValue(property, text.toString(), newLanguage);
        if (!subject.getPropertyValues(property).contains(newValue)) {
			 Object oldValue = null;
			 boolean bool_value = false;
			 if (isComplex())
			 {
                 oldValue = get_Value(row);
			 }
			 else
			 {
				 oldValue = getValue(row);
			 }
             bool_value = resetValue(property.getName(), oldValue, newValue);
             // 010307
             table.getSelectionModel().setSelectionInterval(row, row);
        }

        return newValue;
    }


    public void setSubject(RDFResource instance) {
        RDFResource oldSubject = this.subject;


        if (oldSubject != null) {
            oldSubject.removePropertyValueListener(valueListener);
        }
        this.subject = instance;

        init_properties.clear();
        init_values.clear();

        properties.clear();
        values.clear();

        if (instance != null) {
            instance.addPropertyValueListener(valueListener);

            initialize();
            refill();
        }
        fireTableDataChanged();
        isModified = false;
    }


    public Object setValue(Object aValue, int row) {
        RDFProperty property = getPredicate(row);
        Object oldValue = getValue(row);
        if (oldValue == null || !oldValue.equals(aValue)) {
            RDFResource range = property.getRange();
            try {
                Object newValue;
                String str = aValue.toString();
                OWLModel owlModel = property.getOWLModel();
                if (owlModel.getOWLOntologyProperties().contains(property)) {
                    String message = str + " is not a valid URI.";
                    try {
                        new URI(str);
                    }
                    catch (Exception ex) {
                        ProtegeUI.getModalDialogFactory().showErrorMessageDialog(owlModel, message);
                        return oldValue;
                    }
                    if (!str.startsWith("http://") && !str.startsWith("file:")) {
                        ProtegeUI.getModalDialogFactory().showErrorMessageDialog(owlModel, message);
                        return oldValue;
                    }
                }
                String lang = getLanguage(row);
                if(aValue instanceof RDFSLiteral && ((RDFSLiteral)aValue).getLanguage() != null) {
                    newValue = aValue;
                }
                else if (lang != null) {
                    newValue = createNewValue(property, str, lang);
                }
                else if (oldValue instanceof RDFSLiteral) {
                    RDFSLiteral oldLiteral = (RDFSLiteral) oldValue;
                    newValue = getOWLModel().createRDFSLiteral(str, oldLiteral.getDatatype());
                }
                else if (oldValue instanceof Boolean) {
                    newValue = Boolean.valueOf(str.equals("true"));
                }
                else if (oldValue instanceof Float) {
                    newValue = Float.valueOf(str);
                }
                else if (oldValue instanceof Integer) {
                    newValue = Integer.valueOf(str);
                }
                else {
                    newValue = str;
                }
                if (!subject.getPropertyValues(property).contains(newValue)) {

                    //subject.removePropertyValue(property, oldValue);
                    removePropertyValue(property, oldValue);

                    //subject.addPropertyValue(property, newValue);
                    addPropertyValue(property, newValue);

                }
                return newValue;
            }
            catch (NumberFormatException ex) {
                // Ignore illegal number format
            }
        }
        return oldValue;
    }


    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        setValueAndGetIt(aValue, rowIndex, columnIndex);
    }


    public Object setValueAndGetIt(Object value, int row, int col) {
		if (col == getColumnCount()-1)
			return setLanguage(row, (String) value);

        if (col == COL_PROPERTY) {
            return null;
        }
        if (col == COL_VALUE) {
            return setValue(value, row);
        }
        else if (isTypeColumn(col)) {
            if (value instanceof RDFSDatatype) {
                RDFSDatatype datatype = (RDFSDatatype) value;
                setDatatype(row, datatype);
                return datatype;
            }
            else {
                return null;
            }
        }
        return null;
    }


    /**
     * Removes all rows containing a given property and then re-adds them with the
     * most recent values.
     */

    void updateValues() {
        int index = -1;
        if (table != null) {
            index = table.getSelectedRow();
            //System.out.println("table != null && index = " + index);
        }
        fireTableDataChanged();
        if (table != null && index >= 0 && index < getRowCount()) {
            table.getSelectionModel().setSelectionInterval(index, index);
        }
        else if (table != null && getRowCount() > 0) {
            table.getSelectionModel().setSelectionInterval(0, 0);
        }

    }


	public void setTable(JTable table) {
        this.table = table;
    }

	//062706
	public JTable getTable() {
        return table;
    }

	public Collection getDefaultProperties() {
		return Collections.EMPTY_LIST;
	}

	public Collection getProperties() {
		return properties;
	}

	public Collection getValues() {
		if (isComplex()) return get_Values();
		return values;
	}

	public Collection getInitialProperties() {
		return init_properties;
	}

	public Collection getInitialValues() {
		return init_values;
	}


    private String getStringValue(Object obj)
    {
		if (obj instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) obj;
            return literal.getString();
		}
		else
		{
			return (String) obj;
		}
	}

	private String getLanguage(Object obj)
	{
		if (obj instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) obj;
            return literal.getLanguage();
		}
		else
		{
			return null;
		}

	}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
 /*
    public boolean resetValue(String prop_name, Object prop_value_obj, Object new_prop_value_obj)
    {
		//String prop_value = (String) prop_value_obj;
		String prop_value = getStringValue(prop_value_obj);
	    String new_prop_value = getStringValue(new_prop_value_obj);

        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
				//String name = property.getBrowserText();
				String name = property.getName();
				Object value = null;
				if (isComplex())
				{
					value = (Object) values_get(i);
				}
				else
				{
					value = values.get(i);
				}
				String str_value = getStringValue(value);

				if (name.compareToIgnoreCase(prop_name) == 0 &&
				    str_value.compareToIgnoreCase(prop_value) == 0)
				{
   				    if (isComplex())
					{

						String text = ComplexPropertyParser.getText(str_value);

						value2xml_map.remove(text);

						text = ComplexPropertyParser.getText(getStringValue(new_prop_value_obj));
						value2xml_map.put(text, new_prop_value_obj);

                        String language = getLanguage(i);
                        if (language != null)
                        {
							if (language.compareTo("") == 0) language = "en";
                            Object obj = createNewValue(text, language);
                            values.set(i, obj);
						}
						else
						{
							values.set(i, text);
						}

					}
					else
					{
						values.set(i, new_prop_value_obj);
					}

					//updateValues();

					fireTableDataChanged();
					return true;
				}

		    }
		}
		return false;
	}
*/

    public boolean resetValue(String prop_name, Object prop_value_obj, Object new_prop_value_obj)
    {
		//String prop_value = (String) prop_value_obj;
		String prop_value = getStringValue(prop_value_obj);
	    String new_prop_value = getStringValue(new_prop_value_obj);

        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			if (!(property instanceof DefaultOWLObjectProperty))
			{
				//String name = property.getBrowserText();
				String name = property.getName();
				Object value = null;
				if (isComplex())
				{
					value = (Object) values_get(i);
				}
				else
				{
					value = values.get(i);
				}
				String str_value = getStringValue(value);

				if (name.compareToIgnoreCase(prop_name) == 0 &&
				    str_value.compareToIgnoreCase(prop_value) == 0)
				{
   				    if (isComplex())
					{

						String text = ComplexPropertyParser.getText(str_value);

						value2xml_map.remove(text);

						text = ComplexPropertyParser.getText(getStringValue(new_prop_value_obj));
						value2xml_map.put(text, new_prop_value_obj);
                        //String language = getLanguage(i);
                        //010307
                        String language = "en";
                        if (new_prop_value_obj instanceof RDFSLiteral)
                        {
							language = ((RDFSLiteral) new_prop_value_obj).getLanguage();
							if (language == null || language.compareTo("") == 0) language = "en";
                            Object obj = createNewValue(text, language);
                            values.set(i, obj);
						}
						else
						{
							values.set(i, text);
						}
					}
					else
					{
						values.set(i, new_prop_value_obj);
					}

					//updateValues();

					fireTableDataChanged();
					return true;
				}

		    }
		}
		return false;
	}


//////////////////////////////////////////////////////////////////////////////////////////////////////////


    public String getObjectValue(Object obj)
    {
		if (obj == null) return null;
		Object newValue;
		String str = obj.toString();
		if (obj instanceof RDFSLiteral) {
			RDFSLiteral oldLiteral = (RDFSLiteral) obj;
			newValue = owlModel.createRDFSLiteral(str, oldLiteral.getDatatype());
		}
		else if (obj instanceof Boolean) {
			newValue = Boolean.valueOf(str.equals("true"));
		}
		else if (obj instanceof Float) {
			newValue = Float.valueOf(str);
		}
		else if (obj instanceof Integer) {
			newValue = Integer.valueOf(str);
		}
		else {
			newValue = str;
		}
		return newValue.toString();
	}


    private void values_add(int i, Object value)
    {
		String text = ComplexPropertyParser.getText(value.toString());
		value2xml_map.put(text, value);

		String language = getLanguage(i);
		if (language != null)
		{
			values.add(i, createNewValue(text, language));
		}
		else
		{
			values.add(i, text);
	    }
	}


    private void values_add(Object value, boolean langUpdated)
    {
		String text = ComplexPropertyParser.getText(value.toString());
		String old_value = (String) value2xml_map.get(text);

		if (value instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) value;
			String language = literal.getLanguage();
			values.add(createNewValue(old_value, language));
		}
		else
		{
			values.add(old_value);
	    }
	}


    private void values_add(Object value)
    {
		//String text = ComplexPropertyParser.getText((String) value);
		String text = ComplexPropertyParser.getText(value.toString());

		value2xml_map.put(text, value);

		if (value instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) value;
			String language = literal.getLanguage();
			values.add(createNewValue(text, language));
		}
		else
		{
			values.add(text);
	    }
	}

    private void values_set(int i, Object value)
    {
		//String text = ComplexPropertyParser.getText((String) value);
		String text = ComplexPropertyParser.getText(value.toString());
		value2xml_map.put(text, value);

		String language = getLanguage(i);
		if (language != null)
		{
			values.add(i, createNewValue(text, language));
		}
		else
		{
			values.add(i, text);
	    }
	}


    private void values_set(Object value)
    {
		//String text = ComplexPropertyParser.getText((String) value);
		String text = ComplexPropertyParser.getText(value.toString());
		value2xml_map.put(text, value);

		if (value instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) value;
			String language = literal.getLanguage();
			values.add(createNewValue(text, language));
		}
		else
		{
			values.add(text);
	    }
	}



    private Object values_get(int i)
    {
		// 080506
		//String text = (String) values.get(i);

		Object obj = values.get(i);
		String text = (String) obj.toString();

        obj = value2xml_map.get(text);
		if (obj == null) return null;

		//return getObjectValue(obj);
		return obj;
	}

    private String values_get(String text)
    {
		return (String) value2xml_map.get(text);
	}

    public Object get_Value(int i)
    {
		return values_get(i);
	}


	public ArrayList get_Values()
	{
		ArrayList curr_values = new ArrayList();
        for (int i=0; i<values.size(); i++)
        {
			curr_values.add(values_get(i));
		}
		return curr_values;
	}
/*
    private void values_remove(int i)
    {
		String text = (String) values.get(i);
		value2xml_map.remove(text);
		values.remove(i);
	}
*/
    private void values_remove(int i)
    {
		Object text = (Object) values.get(i);
		value2xml_map.remove(getObjectValue(text));
		values.remove(i);
	}

    private void values_remove(int i, boolean langUpdated)
    {
		Object text = (Object) values.get(i);
		//value2xml_map.remove(getObjectValue(text));
		values.remove(i);
	}

	private void values_clear()
	{
		values.clear();
		value2xml_map.clear();
	}


    public String getPropertyName(int row) {
        RDFProperty property = getPredicate(row);
        //return property.getBrowserText();
        return property.getName();
    }

    public String getPropertyValue(int row) {
		String text = (String) values.get(row);
        return text;
    }

    public RDFProperty getProperty(int row) {
        RDFProperty property = getPredicate(row);
        //return property.getBrowserText();
        return property;
    }

}
