package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protegex.owl.model.RDFProperty;
import edu.stanford.smi.protegex.owl.model.RDFResource;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

import java.util.Collection;
import java.util.ArrayList;

import edu.stanford.smi.protegex.owl.ui.actions.ResourceAction;

import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protege.ui.DisplayUtilities;
import java.util.*;

//053006
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditorManager;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protegex.owl.ui.metadata.AnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditor;

import edu.stanford.smi.protegex.owl.ui.metadata.DateAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.DateTimeAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.TimeAnnotationsWidgetPlugin;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCICreateFULLSYNAction extends ResourceAction {

//053006
private static Set plugins = new HashSet();

	//060106
	JTextArea desc_ta;
	JComboBox syn_group_combo, source_combo, def_group_combo;
	JTextField name_field, code_field, attr_field, reviewdate_field, reviewer_field;

    OWLModel kb;
    NCIEditTab tab;
    Collection properties;
    Collection excludedProperties = null;
    String title = "Select properties to add";
    NCIFULLSYNTableModel tableModel = null;

    String property_name = null;
    String property_value = null;
    boolean cancelBtnPressed = false;

    public NCICreateFULLSYNAction(NCIEditTab tab) {
        super("Create new annotation value", OWLIcons.getCreateIcon(OWLIcons.ANNOTATION));
        this.tab = tab;
        this.kb = tab.getOWLModel();
        this.properties = kb.getVisibleUserDefinedRDFProperties();
    }


    public NCICreateFULLSYNAction(NCIEditTab tab, NCIFULLSYNTableModel tableModel,
           Collection properties) {

        super("Create new annotation value", OWLIcons.getCreateIcon(OWLIcons.ANNOTATION));
        this.tab = tab;
        this.kb = tab.getOWLModel();
        this.properties = properties;
        if (properties == null)
        {
			this.properties = kb.getVisibleUserDefinedRDFProperties();
		}
        this.tableModel = tableModel;
    }

    public void actionPerformed(ActionEvent e) {
        String name = "";
        String prop_value = "";
        RDFProperty property = null;
        if (this.properties != null && this.properties.size() == 1)
        {
			Object[] objs =	this.properties.toArray();
			property = (RDFProperty) objs[0];
			//name = property.getBrowserText();
			name = property.getName();
		}
		else
		{
			Collection allowedSlots = properties;
			if (allowedSlots == null)
			{
				allowedSlots = new ArrayList(kb.getSlots());
			}
			Slot slot = DisplayUtilities.pickSlot(tab, allowedSlots, "Select Property");
			if (slot == null) return;

			//name = slot.getBrowserText();
			name = property.getName();
			property = (RDFProperty) slot;
		}
		if (name.compareTo("") == 0) return;
        property_name = name;

		CustomizedAnnotationDialog dialog =
			new CustomizedAnnotationDialog(tab.getEditPanel(), property_name, "", -1, tableModel);

		prop_value = dialog.getValue();
		HashMap hm = ComplexPropertyParser.parseXML(prop_value);

		property_value = hm.get("term-name")+"|"+hm.get("term-group")+"|"+
			hm.get("term-source");
		if (hm.containsKey("source-code"))
		{
			property_value += "|"+hm.get("source-code");
		}

		String key1 = name + ": " + prop_value;     //for existing cls
		String key2 = name + ": " + property_value; //for newly created cls

		if (tab.getEditPanel().itemExists(key1, TreeItem.TYPE_PROPERTY) ||
		    tab.getEditPanel().itemExists(key2, TreeItem.TYPE_PROPERTY))
		{
			Component warning_label = new JLabel("Property already exists.");
			LabeledComponent lc2 = new LabeledComponent("", warning_label);
			int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
			property_value = "";
			cancelBtnPressed = true;
			return;
		}

		if (tableModel != null && prop_value != null && prop_value.compareTo("") != 0)
		{
			tableModel.addRow(property, prop_value);
			tab.getEditPanel().enableSaveButton(true);

			if (tableModel.getRowCount()==1)
			{
				tab.getEditPanel().enableDelEditHB(1, true);
			}
	    }

	}

	public String getPropertyName()
	{
		return property_name;
	}

	public String getPropertyValue()
	{
		return property_value;
	}

    public boolean isSuitable(Component component, RDFResource resource) {
        return resource instanceof RDFProperty && resource.isEditable() && component instanceof JTree;
    }
}

