package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protege.util.Log;
import javax.swing.*;
import java.awt.*;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIOWLIcons extends OWLIcons{

    static Map theNCIOWLIcons = new HashMap();


    public static ImageIcon getImageIcon(String name) {
        ImageIcon icon = (ImageIcon) theNCIOWLIcons.get(name);
        if (icon == null || icon.getIconWidth() == -1) {
            String partialName = "images/" + name;
            if (name.lastIndexOf('.') < 0) {
                partialName += ".gif";
            }
            icon = loadImageIcon(NCIOWLIcons.class, partialName);
            if (icon == null && !name.equals("Ugly")) {
                icon = getImageIcon("Ugly");
            }
            theNCIOWLIcons.put(name, icon);
        }
        return icon;
    }


    static ImageIcon loadImageIcon(Class cls, String name) {
        ImageIcon icon = null;
        URL url = cls.getResource(name);
        if (url != null) {
            icon = new ImageIcon(url);
            if (icon.getIconWidth() == -1) {
                Log.error("failed to load", NCIOWLIcons.class, "loadImageIcon", cls, name);
            }
        }
        return icon;
    }

}
