package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.ui.FrameRenderer;
import edu.stanford.smi.protege.util.PopupMenuMouseListener;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.model.triplestore.Triple;
import edu.stanford.smi.protegex.owl.model.triplestore.impl.DefaultTriple;
import edu.stanford.smi.protegex.owl.ui.ResourceRenderer;
import edu.stanford.smi.protegex.owl.ui.actions.CopyPropertyValueAction;
import edu.stanford.smi.protegex.owl.ui.actions.DeleteAllPropertyValuesAction;
import edu.stanford.smi.protegex.owl.ui.actions.DeleteMatchingPropertyValuesAction;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleAction;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleActionManager;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleActionSwingAction;
import edu.stanford.smi.protegex.owl.ui.components.ComponentUtil;
import edu.stanford.smi.protegex.owl.ui.results.TripleDisplay;
import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import java.util.HashSet;
import java.util.Collections;

import edu.stanford.smi.protegex.owl.ui.components.annotations.*;//AnnotationsValueRenderer

import javax.swing.table.DefaultTableCellRenderer;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIQualifierTable extends JTable {

    private static HashSet multiLineProperties = new HashSet();

    static {
        multiLineProperties.add(RDFSNames.Slot.COMMENT);
    }

    private NCIQualifierTableModel tableModel;
    private JTextField textField;

    public NCIQualifierTable(NCIQualifierTableModel model) {

        super(model);
        this.tableModel = model;

        model.setTable(this);

        TableColumn nameColumn = getColumnModel().getColumn(NCIQualifierTableModel.COL_NAME);
        TableColumn valueColumn = getColumnModel().getColumn(NCIQualifierTableModel.COL_VALUE);

        DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();

        valueColumn.setCellRenderer(renderer);
        valueColumn.setPreferredWidth(700);

        nameColumn.setCellRenderer(renderer);
        nameColumn.setPreferredWidth(200);

        setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        getTableHeader().setReorderingAllowed(false);
        setRowMargin(0);
        setIntercellSpacing(new Dimension(0, 0));
        setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        setRowHeight(new JTextField().getPreferredSize().height);
        setGridColor(Color.LIGHT_GRAY);
        setShowGrid(true);
        setIntercellSpacing(new Dimension(1, 1));

    }


    public NCIQualifierTableModel getTableModel() {
        return tableModel;
    }


}
