package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protegex.owl.ui.components.triples.*;

import com.hp.hpl.jena.datatypes.xsd.impl.XMLLiteralType;
import edu.stanford.smi.protege.ui.FrameComparator;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.model.event.PropertyValueAdapter;
import edu.stanford.smi.protegex.owl.model.event.PropertyValueListener;
import edu.stanford.smi.protegex.owl.model.impl.DefaultRDFSLiteral;
import edu.stanford.smi.protegex.owl.model.impl.XMLSchemaDatatypes;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.metadata.AnnotationsWidgetPlugin;

import javax.swing.*;
import javax.swing.table.AbstractTableModel;
import java.net.URI;
import java.util.*;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;

import javax.swing.table.DefaultTableModel;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.components.annotations.*;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIQualifierTableModel extends AbstractTableModel {

    static final int COL_NAME = 0;
    static final int COL_VALUE = 1;

    String[] columnNames;
    Object[][] data;

    NCIQualifierTable table;

    Vector text_vec = null;

    public NCIQualifierTableModel(String[] columnNames) {
		this.columnNames = new String[columnNames.length];
		for (int i=0;i<columnNames.length; i++)
		{
			this.columnNames[i] = columnNames[i];
		}
        text_vec = new Vector();
        text_vec.add("def-definition");
        text_vec.add("go-term");

        data = new String[5][2];
    }

    public String getColumnName(int col) {
        return columnNames[col].toString();
    }


    public void setData(HashMap hmap) // key: qualifier name; value: qualifier value
    {
		 Set set = hmap.keySet();
		 int size = set.size();
		 String text = "";
		 for (int i=0; i<text_vec.size(); i++)
		 {
			 text = (String) text_vec.elementAt(i);
			 if (hmap.containsKey(text))
			 {
				 size = size - 1;
				 break;
			 }
		 }

		 if (size == 0) return;
		 data = new String [size+1][2];
		 int row = 0;
		 int col = 0;

		 if (text.compareTo("def-definition") == 0)
		 {
			 for (int i=0; i<CustomizedAnnotationDialog.definition_qualifiers.length; i++)
			 {
				 String key = (String) CustomizedAnnotationDialog.definition_qualifiers[i];
				 if (hmap.containsKey(key))
				 {
                     col = 0;
					 data[row][col] = key;
					 //fireTableCellUpdated(row, col);
					 col++;


                     String value = (String) hmap.get(key);
					 data[row][col] = value;
					 //fireTableCellUpdated(row, col);
					 row++;
			     }
			 }
		 }

		 else if (text.compareTo("go-term") == 0)
		 {
			 for (int i=0; i<CustomizedAnnotationDialog.goannotation_qualifiers.length; i++)
			 {
				 String key = (String) CustomizedAnnotationDialog.goannotation_qualifiers[i];
				 if (hmap.containsKey(key))
				 {
                     col = 0;
					 data[row][col] = key;
					 fireTableCellUpdated(row, col);
					 col++;

                     String value = (String) hmap.get(key);
					 data[row][col] = value;
					 fireTableCellUpdated(row, col);
					 row++;
			     }
			 }
		 }
	}




    public void initialize() // key: qualifier name; value: qualifier value
    {
		 int n = getRowCount();
		 if (n == 0) return;
		 data = new String [n][2];
		 for (int i=0; i<n; i++)
		 {
			 for (int j=0; j<2; j++)
			 {
				data[i][j] = "";
			 	fireTableCellUpdated(i, j);
		     }
		 }
	}

    public int getRowCount() { return data.length; }

    public int getColumnCount() { return columnNames.length; }

    public Object getValueAt(int row, int col) {
        return data[row][col];
    }

    public boolean isCellEditable(int row, int col)
        { return false; }

    public void setValueAt(Object value, int row, int col) {

        data[row][col] = value;
        fireTableCellUpdated(row, col);
    }

	public void setTable(NCIQualifierTable table) {
        this.table = table;
    }
}

