package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.ui.FrameRenderer;
import edu.stanford.smi.protege.util.PopupMenuMouseListener;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.model.triplestore.Triple;
import edu.stanford.smi.protegex.owl.model.triplestore.impl.DefaultTriple;
import edu.stanford.smi.protegex.owl.ui.ResourceRenderer;
import edu.stanford.smi.protegex.owl.ui.actions.CopyPropertyValueAction;
import edu.stanford.smi.protegex.owl.ui.actions.DeleteAllPropertyValuesAction;
import edu.stanford.smi.protegex.owl.ui.actions.DeleteMatchingPropertyValuesAction;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleAction;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleActionManager;
import edu.stanford.smi.protegex.owl.ui.actions.triple.TripleActionSwingAction;
import edu.stanford.smi.protegex.owl.ui.components.ComponentUtil;
import edu.stanford.smi.protegex.owl.ui.results.TripleDisplay;
import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import java.awt.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import java.util.HashSet;
import java.util.Collections;

import edu.stanford.smi.protegex.owl.ui.components.annotations.*;//AnnotationsValueRenderer

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIRoleGroupTable extends JTable {

    private NCIRoleGroupTableModel tableModel;
    private JTextField textField;
    private Project project;
    OWLModel kb;

    public NCIRoleGroupTable(OWLModel kb, NCIRoleGroupTableModel model) {

        super(model);
        this.project = kb.getProject();
        this.tableModel = model;
        this.kb = kb;

        model.setTable(this);

        textField = new JTextField();
        OWLUI.addCopyPastePopup(textField);
        setDefaultEditor(Object.class, new DefaultCellEditor(textField));
        TableColumn groupColumn = getColumnModel().getColumn(0);
        TableColumn roleColumn = getColumnModel().getColumn(1);

        groupColumn.setPreferredWidth(100);
        roleColumn.setPreferredWidth(500);

        OWLModel owlModel = (OWLModel) project.getKnowledgeBase();

        setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        getTableHeader().setReorderingAllowed(false);
        setRowMargin(0);
        setIntercellSpacing(new Dimension(0, 0));
        setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        addMouseListener(new PopupMenuMouseListener(this) {

            protected JPopupMenu getPopupMenu() {
                return null;
            }

            protected void setSelection(JComponent c, int x, int y) {
                int row = y / getRowHeight();
                if (row >= 0 && row < getRowCount()) {
                    getSelectionModel().setSelectionInterval(row, row);
                }
            }
        });


        setRowHeight(new JTextField().getPreferredSize().height);
        setGridColor(Color.LIGHT_GRAY);
        setShowGrid(true);
        setIntercellSpacing(new Dimension(1, 1));

    }


	private Project getProject()
	{
		return kb.getProject();
	}


    public NCIRoleGroupTableModel getTableModel() {
        return tableModel;
    }

    public boolean isCellEditable(int rowIndex, int columnIndex)
    {
        if (columnIndex == 0)
        	return true;

		return false;
	}

}
