package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protege.widget.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.ui.*;


import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.InstanceDisplay;
import edu.stanford.smi.protege.util.*;
import edu.stanford.smi.protege.widget.ClsWidget;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.cls.*;
import edu.stanford.smi.protegex.owl.ui.clsdesc.DisjointClassesWidget;
import edu.stanford.smi.protegex.owl.ui.conditions.ConditionsWidget;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourceDisplay;
import edu.stanford.smi.protegex.owl.ui.subsumption.InferredSubsumptionTreePanel;
import edu.stanford.smi.protegex.owl.ui.widget.WidgetUtilities;
import edu.stanford.smi.protegex.owl.model.RDFSClass;
import edu.stanford.smi.protegex.owl.model.OWLProperty;

import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class PartonomyPanel extends JPanel //implements DropTargetListener
{
	NCIEditTab tab;
	Instance selectedInstance;
	int selected_tab;

    JTree edit_tree;
    JScrollPane treeView;
    DefaultTreeModel model;

    DefaultMutableTreeNode root_node;
    OWLModel kb;

    Vector role_vec;
    OWLWrapper wrapper;

	int total=0;

	HashSet visitedNodes;

    public PartonomyPanel(NCIEditTab tab, Instance selectedInstance,
    	                  OWLModel kb, OWLWrapper wrapper)
    {
		this.selectedInstance = selectedInstance;
		this.selected_tab = selected_tab;
		this.tab = tab;
		this.kb = kb;
		this.wrapper = wrapper;

		role_vec = new Vector();

		initialize(null);
		this.kb = tab.getOWLModel();
	}

   	public void initialize(DefaultMutableTreeNode dmtn)
   	{
		if (dmtn != null)
		{
			root_node = dmtn;
			createNodes(root_node);
		}
		else if (selectedInstance != null)
		{
			root_node = dmtn;
			createNodes(root_node);
		}

		edit_tree = new JTree(root_node);
		edit_tree.setEditable(true);

		edit_tree.getSelectionModel().setSelectionMode
				(TreeSelectionModel.SINGLE_TREE_SELECTION);

		DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
		renderer.setLeafIcon(new ImageIcon("images/middle.gif"));
		edit_tree.setCellRenderer(renderer);

        treeView = new JScrollPane(edit_tree);
		setLayout(new BorderLayout());
		add(treeView, BorderLayout.CENTER);

		visitedNodes = new HashSet();
    }

    private void createNodes(DefaultMutableTreeNode top)
    {
		if (selectedInstance == null)
		{
			System.out.println("WARNING: selectedInstance == null");
			return;
		}

        Cls cls = (Cls) selectedInstance;
    }


    public void draw(String cls_name, Object[] roles)
    {
		total=0;
		for (int i=0; i<roles.length; i++)
		{
			role_vec.add(roles[i]);
		}

		Cls cls = wrapper.getOWLNamedClass(cls_name);
		if (cls == null)
		{
			Object[] options = {"Yes", "No"};
			Object[] option_array = {"OK"};
			int ans = JOptionPane.showOptionDialog(this, "Class " + cls_name
			+ " not found.", "Confirmation",
			JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
			null, option_array, options[0]);

			return;
		}

		createTree(wrapper.getOWLNamedClass(cls_name));
    }


    private void createTree(Cls cls)
    {
		selectedInstance = cls;
		String name = wrapper.getInternalName(cls);//selectedInstance.getBrowserText();
		root_node = new DefaultMutableTreeNode(name);

		edit_tree = new JTree(root_node);
		edit_tree.setEditable(true);

		model = new DefaultTreeModel(root_node);

		visitedNodes.clear();

		for (int i=0; i<role_vec.size(); i++)
		{
			String arole = (String)role_vec.elementAt(i);
			traverseUp(root_node, arole, (OWLNamedClass) cls, 1);
		}

		if (total == 0)
			JOptionPane.showMessageDialog(null,"No partonomy data to display for "+ name,"Warning",JOptionPane.WARNING_MESSAGE);
		else{
			edit_tree = new JTree(root_node);
			edit_tree.getSelectionModel().setSelectionMode
					(TreeSelectionModel.SINGLE_TREE_SELECTION);

			DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
			renderer.setLeafIcon(new ImageIcon("images/middle.gif"));
			edit_tree.setCellRenderer(renderer);

			treeView.setViewportView(edit_tree);

			tab.enableButton("saveButton_Partonomy", true);
			tab.enableButton("clearButton_Partonomy", true);

		}
    }

/*
    void traverseDown(DefaultMutableTreeNode parNode, String roleName, OWLNamedClass cls, int level)
	{
		Vector roles;
		int nextLevel = level + 1;
		int pos;
		String role, role_name=null, role_value=null;
		try
		{
			roles = wrapper.getRestrictionTargetStrings(cls);

			if (roles==null)
			{

System.out.println("wrapper.getRestrictionTargetStrings returns null -- traversal ends.");

				return;
			}



System.out.println("roles.size(): " + roles.size());


			boolean flag = false;

			for (int k=0; k<roles.size(); k++)
			{
				role = (String) roles.elementAt(k);
				pos = role.indexOf("$");
				role_name = role.substring(0, pos);

System.out.println("role_name " + role_name);

				if (role_name.equalsIgnoreCase(roleName))
				{
					flag = true;
					if (role_name.equalsIgnoreCase(roleName))
					{
						role_value = role.substring(pos+1);
						OWLNamedClass role_cls = wrapper.getOWLNamedClass(role_value);
						if (role_cls != null)
						{
							traverseDown(parNode, roleName, role_cls, nextLevel);
					    }
					}
				}
			}

// role found
			if (!flag)
			{
				String conName = wrapper.getInternalName(cls);//cls.getBrowserText();
System.out.println("Traversing up from " + conName);
				Vector referring_clses = wrapper.getRestrictionSources(conName, roleName);
				if (referring_clses!=null && referring_clses.size()!=0)
				{
					total++;
					DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(conName+" ("+roleName+")");
					parNode.add(childNode);
					traverseUp(childNode, roleName, (OWLNamedClass) referring_clses, 1);
				}
			}
      }catch (Exception ex) {
			Log.getLogger().log(Level.WARNING, "Exception caught", ex);;
	  }
   }
*/

/*
   void traverseUp(DefaultMutableTreeNode parNode, String roleName, String conName, int level)
   {
		int nextLevel = level + 1;
		DefaultMutableTreeNode root = (DefaultMutableTreeNode)model.getRoot();

		Vector referring_clses = wrapper.getRestrictionSources(conName, roleName);
		if (referring_clses!=null && referring_clses.size()!=0)
		{
			for (int i=0; i<referring_clses.size(); i++){
				Cls referring_cls = (Cls) referring_clses.elementAt(i);
				//String name = referring_cls.getBrowserText();

				String name = wrapper.getInternalName(referring_cls);//.getBrowserText();

System.out.println("traverseUp " + name);


				DefaultMutableTreeNode childNode;
				if (name.equalsIgnoreCase(root.toString()))
					childNode = new DefaultMutableTreeNode(name+" (inverse "+roleName+")");
				else
					childNode = new DefaultMutableTreeNode(name+" (inverse "+roleName+")");
				parNode.add(childNode);
				traverseUp(childNode, roleName, name, nextLevel);
			}
		}
	}
*/
   void traverseUp(DefaultMutableTreeNode parNode, String roleName, OWLNamedClass cls, int level)
   {
		int nextLevel = level + 1;
		String conName = wrapper.getInternalName(cls);
		DefaultMutableTreeNode root = (DefaultMutableTreeNode)model.getRoot();

		Vector referring_clses = wrapper.getRestrictionSources(conName, roleName);
		if (referring_clses!=null && referring_clses.size()!=0)
		{
			for (int i=0; i<referring_clses.size(); i++){
				Cls referring_cls = (Cls) referring_clses.elementAt(i);
				String name = wrapper.getInternalName(referring_cls);//.getBrowserText();

				if (!visitedNodes.contains(name))
				{
					total++;
					visitedNodes.add(name);
					DefaultMutableTreeNode childNode;
					if (name.equalsIgnoreCase(root.toString()))
						childNode = new DefaultMutableTreeNode(name+" (inverse "+roleName+")");
					else
						childNode = new DefaultMutableTreeNode(name+" (inverse "+roleName+")");
					parNode.add(childNode);

					traverseUp(childNode, roleName, (OWLNamedClass) referring_cls, nextLevel);
			    }
			}
		}
		else
		{
			System.out.println(" referring_clses ==null ||  referring_clses.size()==0 -- Nothing Done.");
		}
	}


	public boolean outputTree(PrintWriter pw)
	{
		if (pw == null) return false;
		if (root_node == null) return false;
        int level = 0;
		outputNode(pw, root_node, level);

		return true;
	}

	private void outputNode(PrintWriter pw, DefaultMutableTreeNode node, int level)
	{
		if (node == null) return;
		outputNodeLabel(pw, node, level);
		int n = node.getChildCount();
		if (n == 0) return;
		level++;
		Enumeration e = node.children();
		while (e.hasMoreElements())
		{
			DefaultMutableTreeNode childnode = (DefaultMutableTreeNode) e.nextElement();
			outputNode(pw, childnode, level);
		}
	}


	private void outputNodeLabel(PrintWriter pw, DefaultMutableTreeNode node, int level)
	{
		if (node == null) return;
		String indent = "";
		for (int i=0; i<level; i++)
		{
			indent = indent + "\t";
		}
		String s = (String)node.getUserObject().toString();
		pw.println(indent + s);
	}
}