package gov.nih.nci.protegex.edit;

import java.util.*;
import java.lang.System;

import javax.swing.*;

import edu.stanford.smi.protege.widget.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.ui.*;
import edu.stanford.smi.protege.util.*;
import edu.stanford.smi.protegex.owl.model.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.tree.*;

import java.awt.FileDialog;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourceDisplay;
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourcePanel;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;

import edu.stanford.smi.protege.event.*;
import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.model.Model;
import edu.stanford.smi.protegex.owl.model.OWLNamedClass;
import edu.stanford.smi.protegex.owl.model.RDFSClass;

////////
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.*;
import edu.stanford.smi.protegex.owl.ui.components.annotations.*;
import edu.stanford.smi.protegex.owl.ui.conditions.*;
import edu.stanford.smi.protegex.owl.ui.icons.*;
import edu.stanford.smi.protegex.owl.ui.owltable.*;
import edu.stanford.smi.protegex.owl.ui.restrictions.*;
import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;


import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.components.triples.*;

import edu.stanford.smi.protege.plugin.PluginUtilities;

import javax.swing.border.*;

import edu.stanford.smi.protege.server.metaproject.impl.OperationImpl;
import edu.stanford.smi.protege.server.framestore.RemoteClientFrameStore;

import edu.stanford.smi.protegex.owl.model.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

class ProgressBar extends JPanel

 {
	private	JProgressBar    progress;
	private	JLabel          statusField;
	private	JPanel          topPanel;

	private int max;
	private OWLWrapper wrapper;
	private NCIEditTab tab;
	private String newline = "\n";

    private Vector classList;

    boolean completed = false;
    PrintWriter pw = null;
    Cls root;
    int maxlevel;
    boolean withAttributes;
    int iCtr = 0;

    File exportFile = null;
    int treesize = 0;


	SwingWorker worker;
	JButton startButton;
	JButton interruptButton;

	boolean interrupted;

	Vector messages;

	public ProgressBar(NCIEditTab tab, File exportFile, Cls root, int maxlevel, boolean withAttributes)
	{
		//setTitle( "Report Writer Progress" );
		setLocation(450, 300);

		this.tab = tab;
		this.wrapper = tab.getOWLWrapper();
		this.classList = new Vector();

		this.root = root;
		this.maxlevel = maxlevel;
		this.withAttributes = withAttributes;
		this.exportFile = exportFile;

		tab.showProgressBar(true);
		tab.initializeProgressBar();

		setSize( 310, 130 );
		setBackground( Color.gray );

		topPanel = new JPanel();

		topPanel.setPreferredSize( new Dimension( 310, 100 ) );

		//getContentPane().add( topPanel );
		add( topPanel );

		// Create a label and progress bar
		statusField = new JLabel( "Ready to write to file..." );
		statusField.setPreferredSize( new Dimension( 280, 24 ) );
		topPanel.add( statusField);

		progress = new JProgressBar();
		progress.setPreferredSize( new Dimension( 300, 20 ) );
		progress.setMinimum( 0 );

/*
		if (maxlevel == -1)
		{
			maxlevel = getMaxLevel((OWLNamedClass) root);
		}

		System.out.println("Level: " + maxlevel);
		this.max = getTreeSize(root, 0, maxlevel);
*/

		statusField.setText("Ready to generate report." );
		//tab.showProgressBar(false);
		iCtr = 0;

		progress.setMaximum( max );
		progress.setValue( 0 );
		progress.setBounds( 20, 35, 260, 20 );
		topPanel.add( progress );

        startButton = new JButton("Start");
        startButton.addActionListener(startListener);
        startButton.setEnabled(true);

        interruptButton = new JButton("Cancel");
        interruptButton.addActionListener(interruptListener);
        interruptButton.setEnabled(false);

        JComponent buttonBox = new JPanel();
        buttonBox.add(startButton);
        buttonBox.add(interruptButton);

        topPanel.add( buttonBox );

        interrupted = false;

		try {
			pw = new PrintWriter(new BufferedWriter(new FileWriter(exportFile)));
		} catch (Exception e) {
			System.out.println("Unable to open " + exportFile.getPath());
		}
	}

    private void updateProgressBar()
    {
		// Update the progress indicator and label
		iCtr++;
		if (iCtr >= max)
		{
			completed = true;
			//startButton.setLabel( "Close" );
			startButton.setEnabled( false );
			interruptButton.setEnabled(false);
			return;
		}
		statusField.setText( "" + iCtr + " out of " + max + " completed.");
		Rectangle labelRect = statusField.getBounds();
		labelRect.x = 0;
		labelRect.y = 0;
		statusField.paintImmediately( labelRect );

		progress.setValue( iCtr );
		Rectangle progressRect = progress.getBounds();
		progressRect.x = 0;
		progressRect.y = 0;
		progress.paintImmediately( progressRect );

	}


    private void writeToFile(){
        if (pw == null) return;
		try{
			String line = "";
			int length=classList.size();

			for(int i=0;i<length;i++) {
				line = (String) classList.elementAt(i);
				if (wrapper.printable(line))
				{
					pw.println(line);
			    }
			}
			pw.flush();
		}
		catch(Exception e){
			Log.getLogger().log(Level.WARNING, "Exception caught", e);;
		}
    }

	private String getClsData(PrintWriter pw, Cls superCls, int level, int maxLevel, boolean withAttributes) //throws InterruptedException
	{
		if (interrupted) return "Cancelled";
		if (maxLevel != -1 && level > maxLevel) return "";

		if (superCls == null)
		{
			return "";
		}


		String tabString="";
		for(int i=0;i<level;i++){
			tabString+="\t";
		}

		try{
			if (withAttributes)
			{
				classList.add("");
		    }

            String pt = null;
            try {
				pt = wrapper.getOwnSlotValue(superCls, tab.getSlotName(NCIEditTab.PREFERRED_NAME));
			} catch (Exception ex) {

			}
			if (pt == null)
			{
				pt = superCls.getName();
			}

			classList.add(tabString+pt);

			//tab.getReportTextArea().append(tabString+pt+newline);
			//updateProgressBar();

			if (withAttributes)
			{
				// output slot data
				getSlots(superCls, level, tabString);
				//getEquivalentClasses((RDFSClass) superCls, tabString);
				getAnonymousSuperclasses((RDFSClass) superCls, tabString);
		    }

			writeToFile();
			classList.clear();

			iCtr++;
			updateStatus(iCtr);
			if (Thread.interrupted()) {
				throw new InterruptedException();
			}
			Thread.sleep(300);

			Collection subclasses = wrapper.getDirectSubclasses(superCls);
			level++;
			if(subclasses != null && !subclasses.isEmpty()){
				Iterator i = subclasses.iterator();
				while(i.hasNext()) {
					Cls subcls = (Cls) i.next();
					if (subcls instanceof OWLNamedClass)
					{
						if(subcls.getBrowserText().compareTo(superCls.getBrowserText()) != 0) {
							getClsData(pw, subcls, level, maxLevel, withAttributes);
						}
				    }
				}
			}
		}



        catch (InterruptedException e) {
            updateStatus(0);
            return "Interrupted";
        }

		catch(Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);;
			return "Error";
		}


        return "All Done";

	}

	private void getSlots(Cls cls, int level,
		String tabString) {
		Collection ownslots = cls.getOwnSlots();
		if (ownslots != null) {
			Iterator j = ownslots.iterator();
			while(j.hasNext()){
				Slot slot = (Slot)j.next();
				Collection slotColl = cls.getOwnSlotValues(slot);
				if(slotColl == null || slotColl.isEmpty())
					continue;
				String slotName = slot.getBrowserText();
				if (slotName.equals(Model.Slot.NAME)) {
					continue;
				}
				else if (slotName.equals(Model.Slot.DIRECT_SUBCLASSES))
					continue;
				else if (slotName.equals(Model.Slot.DIRECT_INSTANCES))
					continue;
				else {
					getOwnslot(slotName, slotColl, tabString);
				}
			}
		}
	}

    private void getOwnslot(String slotname, Collection values, String tabString)
    {
		if (values != null) {
			Iterator i = values.iterator();
			while(i.hasNext()) {
				Object obj = i.next();
				ValueType type = wrapper.getObjectValueType(obj);
				String entry = wrapper.convertObjecttoString(obj, type);
				String stringType = type.toString();
				try {
					if (slotname.compareTo(NCIEditTab.SUBCLASSOF) != 0)
					{
						classList.add("\t" + tabString + slotname + ": " + entry);
				    }
				}
				catch(Exception e){
					Log.getLogger().log(Level.WARNING, "Exception caught", e);;
				}
			}
		}
	}



	private void getAnonymousSuperclasses(RDFSClass cls, String tabString)
	{
		HashSet hset = new HashSet();
        Vector v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = NCIEditTab.SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());
			if (!hset.contains(value))
			{
				classList.add("\t" + tabString + value);
			    hset.add(value);
			}
		}
        v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
			if (!hset.contains(value))
			{
				classList.add("\t" + tabString + value );
			    hset.add(value);
			}
		}


        v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = NCIEditTab.SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());
			if (!hset.contains(value))
			{
				classList.add("\t" + tabString + value);
			    hset.add(value);
			}
		}
        v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
 			if (!hset.contains(value))
			{
				classList.add("\t" + tabString + value);
			    hset.add(value);
			}
		}
	}



    JButton getStartButton() {
        return startButton;
    }

    void updateStatus(final int i) {
        Runnable doSetProgressBarValue = new Runnable() {
            public void run() {
				statusField.setText( "" + iCtr + " out of " + max + " completed.");
                progress.setValue(i);
            }
        };
        SwingUtilities.invokeLater(doSetProgressBarValue);
    }

    Object generateReport() {
		tab.initializeProgressBar();
		iCtr = 0;
		OWLModel owlModel = NCIEditTab.getActiveOWLModel();
		boolean eventsEnabled = owlModel.setDispatchEventsEnabled(false);
		try {
			getClsData(pw, root, 0, maxlevel, withAttributes);
		} finally {
			owlModel.setDispatchEventsEnabled(eventsEnabled);
		}

        if (interrupted)
        {
			progress.setValue(0);
			startButton.setEnabled(false);
			interruptButton.setEnabled(false);
			return "Report generation cancelled.";
		}
        return "Report generation completed.";
    }



    ActionListener startListener = new ActionListener() {
        public void actionPerformed(ActionEvent event) {
            startButton.setEnabled(false);
            interruptButton.setEnabled(true);

            statusField.setText("Report generation in progress ...");

            worker = new SwingWorker() {
                public Object construct() {

                    statusField.setText("Calculating tree size. Please wait ..." );
					if (maxlevel == -1)
					{
						maxlevel = getMaxLevel((OWLNamedClass) root);
					}
					max = getTreeSize(root, 0, maxlevel);
					statusField.setText("Tree size: " + max);

					progress.setMaximum( max );
					tab.showProgressBar(true);



                    iCtr = 0;
                    return generateReport();
                }
                public void finished() {
                    //startButton.setEnabled(true);
                    interruptButton.setEnabled(false);
                    statusField.setText(get().toString());
                }
            };
            worker.start();
        }
    };


    ActionListener interruptListener = new ActionListener() {
        public void actionPerformed(ActionEvent event) {
            tab.initializeProgressBar();
            interruptButton.setEnabled(false);
            worker.interrupt();
            startButton.setEnabled(false);
            interrupted = true;

			try {
				if (pw != null)
				{
					pw.flush();
					pw.close();
			    }
				pw = null;
			} catch (Exception ex) {

			}
        }
    };


	private int getMaxLevel(OWLNamedClass cls)
	{
		if (interrupted) return 0;
		try {
			tab.updateProgressBar();
			int n = cls.getSubclassCount();
			if (n == 0) return 1;
			Collection subclasses = wrapper.getDirectSubclasses(cls);
			Iterator i = subclasses.iterator();
			int max = 0;
			while(i.hasNext()) {
				Object obj = i.next();
				if (obj instanceof OWLNamedClass)
				{
					OWLNamedClass subcls = (OWLNamedClass) obj;
					int m = getMaxLevel(subcls);
					if (m > max) max = m;
				}
			}
			return max+1;
	    } catch (Exception e) {
            updateStatus(0);
            return 0;
		}
	}


	private int getTreeSize(Cls cls, int level, int maxlevel)
	{
		if (interrupted) return 0;
		try {
			tab.updateProgressBar();
			int num_subs = 0;
			if (level < maxlevel)
			{
				level++;
				Collection subclasses = wrapper.getDirectSubclasses(cls);
				Iterator i = subclasses.iterator();
				while(i.hasNext()) {
					Cls subcls = (Cls) i.next();
					if (subcls instanceof OWLNamedClass)
					{
						num_subs = num_subs + getTreeSize(subcls, level, maxlevel);
					}
				}
			}
			return num_subs+1;
	    } catch (Exception e) {
            updateStatus(0);
            return 0;
		}
	}



}


