/*****************************************************************************
*
* NGIT 2006. All Rights Reserved.
* @Author: NGIT, Kim Ong, Iris Guo
*
*****************************************************************************/

package gov.nih.nci.protegex.edit;

import java.io.*;
import java.text.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;

import edu.stanford.smi.protege.util.*;


public class ReportWriter extends JDialog implements ActionListener
{
	boolean btnPressed;

	int windowClosingTag=0;

	JButton fInputButton, fOutputButton;
	JButton continueButton, cancelButton;

	JTextField fInputFile, fOutputFile;

    NCIEditTab tab;
    OWLModel owlModel;

	String infile;// = fInputTf.getText();
	String outfile;// = fOutputFile.getText();

	OWLWrapper wrapper = null;
	OWLClass selectedCls;

	FileField outputFileField = null;
	JComboBox levelComboBox;
	JRadioButton yesRadio;
	JRadioButton noRadio;

	boolean withAttributes = true;

	public ReportWriter(NCIEditTab tab, OWLModel kb)
	{
		super((JFrame)tab.getTopLevelAncestor(), "Report Writer", true);

		this.tab = tab;
		this.owlModel = kb;
		this.wrapper = tab.getWrapper();

		this.infile = "";
		this.outfile = "";

		initialize();
	}


    public File getOutputFile()
    {
		return outputFileField.getFilePath();
	}

    public boolean getWithAttributes()
    {
		return withAttributes;
	}

	public void initialize()
	{
		Container container = this.getContentPane();
		//setLocation(360,300);
		setLocation(450,300);
		setSize(new Dimension(450,240));
		container.setLayout(new BorderLayout());

        JPanel inputPanel = new JPanel();
        inputPanel.setLayout(new BorderLayout());

		String label = "Output File";
		String path = "";
		String extension = "txt";
		String description = "";
		outputFileField = new FileField(label, path, extension, description);
		//Note: use public File getFilePath() to get the file path

		inputPanel.add(outputFileField, BorderLayout.NORTH);

        JPanel rootPanel = new JPanel();
        rootPanel.setLayout(new BorderLayout());
		JTextField rootConcept = new JTextField();
		if (tab.getSelectedInstance() !=null){
			selectedCls = (OWLClass)tab.getSelectedInstance();
			rootConcept.setText(wrapper.getInternalName(selectedCls));
		}
		rootPanel.add(rootConcept, BorderLayout.CENTER);

		LabeledComponent lc2
		   = new LabeledComponent("Root Concept", rootPanel);

		inputPanel.add(lc2, BorderLayout.CENTER);

		String[] levels = new String[12];
		levels[0] = "All";
		for (int i=1; i<levels.length; i++)
		{
			Integer int_obj = new Integer(i-1);
			levels[i] = int_obj.toString();
		}

		levelComboBox = new JComboBox(levels);
		levelComboBox.setSelectedIndex(0);

		LabeledComponent lc3
		   = new LabeledComponent("Hierarchy Level", levelComboBox);

		inputPanel.add(lc3, BorderLayout.SOUTH);


		container.add(inputPanel, BorderLayout.NORTH);


		JLabel attributesLabel = new JLabel("With Attributes?");
		ButtonGroup yesnoGroup = new ButtonGroup();
		JPanel yesnoPanel = new JPanel();
		JRadioButton yesRadio = new JRadioButton("Yes");
		yesRadio.setSelected(true);
		yesRadio.addActionListener(this);

		noRadio = new JRadioButton("No");
		noRadio.addActionListener(this);
		yesnoGroup.add(yesRadio);
		yesnoGroup.add(noRadio);
		yesnoPanel.add(yesRadio);
		yesnoPanel.add(noRadio);


		LabeledComponent lc4
		   = new LabeledComponent("With Attributes", yesnoPanel);
		container.add(lc4, BorderLayout.CENTER);

		continueButton = new JButton("Continue");
		continueButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		JPanel okcancelPanel = new JPanel();
		okcancelPanel.add(continueButton);
		okcancelPanel.add(cancelButton);

        container.add(okcancelPanel, BorderLayout.SOUTH);

        pack();

        tab.enableReportButton(false);
		setVisible(true);

	}


    public boolean getOKBtnPressed()
    {
		return btnPressed;
	}

    public int getLevel()
    {
		int level = levelComboBox.getSelectedIndex();
		return level-1;
	}

	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == continueButton){
			File outputFile = getOutputFile();
			if (outputFile == null)
			{
				Object[] options = {"OK"};
				JOptionPane.showOptionDialog(this, "Input and output files are required.", "Warning",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);

				return;
			}

			btnPressed = true;
			tab.enableReportButton(true);
			dispose();

		}else if (action == cancelButton){
			btnPressed = false;
			tab.enableReportButton(true);
			dispose();
		}else if (action == yesRadio){
            withAttributes = true;
		}else if (action == noRadio){
            withAttributes = false;
		}
	}

	public void beginOutput()
	{
		continueButton.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		continueButton.removeActionListener(this);
		System.out.println("Report writer in progress. Please wait...");
	}

}



