package gov.nih.nci.protegex.edit;
import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;

import javax.swing.tree.*;

import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.model.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


public class ReviewClassDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextArea ta;
	String separator;
	String prop_value;
	NCIEditTab tab;
	OWLNamedClass cls = null;
	OWLWrapper wrapper = null;
	Vector classList = null;
	private String newline = "\n";
	EditPanel editpanel = null;

	private NCIFULLSYNTableModel synonym_tablemodel;//get_synonym_tablemodel()
	private NCIAnnotationsTableModel definition_tablemodel;//get_definition_tablemodel()
	private NCIAnnotationsTableModel property_tablemodel;//get_definition_tablemodel()
	private NCIAnnotationsTableModel association_tablemodel;//get_association_tablemodel()

    private NCIAnnotationsTableModel complex_property_tablemodel;

	private NCIConditionsTableModel  restriction_tablemodel;
	private NCIConditionsTableModel  superconcept_tablemodel;


    public ReviewClassDialog(NCIEditTab tab, EditPanel editpanel, OWLNamedClass cls)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Review " + cls.getBrowserText(), true);
		this.classList = new Vector();

		this.tab = tab;
		this.wrapper = tab.getWrapper();
		this.cls = cls;
		this.classList = new Vector();

		//this.editpanel = tab.getEditPanel();
		this.editpanel = editpanel;

		this.synonym_tablemodel = editpanel.get_synonym_tablemodel();
		this.definition_tablemodel = editpanel.get_definition_tablemodel();
		this.property_tablemodel = editpanel.get_property_tablemodel();
		this.complex_property_tablemodel = editpanel.get_complex_property_tablemodel();

		this.association_tablemodel = editpanel.get_association_tablemodel();
		this.restriction_tablemodel = editpanel.get_restriction_tablemodel();
		this.superconcept_tablemodel = editpanel.get_superconcept_tablemodel();

		//this.cls = (OWLNamedClass) synonym_tablemodel.getSubject();
		init();
	}


	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new BorderLayout());

		ta = new JTextArea(cls.getBrowserText());
		boolean wrap = true;
		ta.setLineWrap(wrap);
		ta.getDropTarget().setActive(false);

		String textAreaText="";
		String conceptDetail="";
		getCls(cls, 0);

		for(int i=0;i<classList.size();i++){
			conceptDetail=(String)classList.elementAt(i);
			if (tab.printable(conceptDetail))
			{
				textAreaText+=conceptDetail;
		    }
		}
		ta.setText(textAreaText);
		ta.setEditable(false);

		JScrollPane reportPane = new JScrollPane(ta);
		reportPane.setPreferredSize(new Dimension (800, 500));

		//midPanel.add(reportPane, BorderLayout.CENTER);
		contain.add(reportPane, BorderLayout.CENTER);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("Close");
		okButton.addActionListener(this);
		buttonPanel.add(okButton);

        contain.add(buttonPanel, BorderLayout.SOUTH);
		pack();

		setLocation(100, 100);

		this.setVisible(true);
   	}


	private void getCls(Cls superCls, int level) {

		if (superCls == null)
		{
			return;
		}

		String tabString="";
		Cls cls;

		for(int i=0;i<level;i++){
			tabString+="\t";
		}

        classList.clear();
		try{
			classList.add(newline);
			classList.add(tabString + "Annotation Properties:" + newline);

			Vector v = getOwnslotValues(tab.CODE);
			for (int i=0; i<v.size(); i++)
			{
				String s = (String) v.elementAt(i);
				classList.add(s);
			}

			String pt = (String) editpanel.getPreferredName();
			String s = "\t" + "Preferred_Name:" + "\t" + pt + newline;
			classList.add(s);

			classList.add(newline);

			sortData();
		}
		catch(Exception e){
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}

	}

    private Vector getOwnslotValues(String slotname)
    {
		Vector v = new Vector();
		Slot slot = wrapper.getSlot(slotname);
		if (slot == null) return v;
		Collection values = cls.getOwnSlotValues(slot);
		if(values == null || values.isEmpty()) return v;
		Iterator i = values.iterator();
		while(i.hasNext()) {
			Object obj = i.next();
			ValueType type = wrapper.getObjectValueType(obj);
			String entry = wrapper.convertObjecttoString(obj, type);
			String stringType = type.toString();
			try {
				String s = "\t" + slotname + "\t" + entry + newline;
				v.add(s);
			}
			catch(Exception e){
				Log.getLogger().log(Level.WARNING, "Exception caught", e);
				return new Vector();
			}
		}
        return v;
	}


	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			dispose();
		}

	}

    private void sortItems(ArrayList a) {
        Collections.sort(a);
    }


    private void sortData()
    {
        sortAnnotationData((ArrayList) property_tablemodel.getProperties(),
                 (ArrayList) property_tablemodel.getValues());

        sortAnnotationData((ArrayList) synonym_tablemodel.getProperties(),
                 (ArrayList) synonym_tablemodel.getValues());

        sortAnnotationData((ArrayList) definition_tablemodel.getProperties(),
                 (ArrayList) definition_tablemodel.getValues());

        sortAnnotationData((ArrayList) complex_property_tablemodel.getProperties(),
                 (ArrayList) complex_property_tablemodel.getValues());

		sortConditionData("Named Superclasses:", (ArrayList) superconcept_tablemodel.getItems());

        sortConditionData("Restrictions:", (ArrayList) restriction_tablemodel.getItems());

		sortObjectValuedAnnotationData((ArrayList) association_tablemodel.getProperties(),
		         (ArrayList) association_tablemodel.getValues());

	}

    private void sortAnnotationData(ArrayList properties, ArrayList values)
    {
        Vector v = new Vector();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);

			// 080306
			//String value = (String) values.get(i);
			Object value_obj = (Object) values.get(i);
			String value = "";
			if (value_obj instanceof RDFSLiteral) {
				value = ((RDFSLiteral) value_obj).getString();
            }
            else
            {
				value = value_obj.toString();
			}

			String s = property.getBrowserText() + ": " + value;
			v.add(s);
		}

        QuickSortVecStrings qsvs = new QuickSortVecStrings();
        try {
			qsvs.sort(v);
			for (int i=0; i<v.size(); i++)
			{
				String s = (String) v.elementAt(i);

				int pos = s.indexOf(":");
				String name = s.substring(0, pos);
				String value = s.substring(pos+1, s.length());

				HashMap map = ComplexPropertyParser.parseXML(value);
				String text = "";
				if (map.containsKey("def-definition"))
				{
					text = (String) map.get("def-definition");
					classList.add("\t" + name + ": " + text + newline);

                    Iterator it = map.keySet().iterator();
                    while (it.hasNext())
                    {
					    String qName = (String) it.next();
					    if (qName.compareTo("def-definition") != 0 && qName.compareTo("root") != 0)
					    {
							String qValue = (String) map.get(qName);
							classList.add("\t\t" + qName + ": " + qValue + newline);
						}
					}

				}
				else if (map.containsKey("go-term"))
				{
					text = (String) map.get("go-term");
					classList.add("\t" + name + ": " + text + newline);

                    Iterator it = map.keySet().iterator();
                    while (it.hasNext())
                    {
					    String qName = (String) it.next();
					    if (qName.compareTo("go-term") != 0 && qName.compareTo("root") != 0)
					    {
							String qValue = (String) map.get(qName);
							classList.add("\t\t" + qName + ": " + qValue + newline);
						}
					}
				}
				else if (map.containsKey("def-definition"))
				{
					text = (String) map.get("def-definition");
					classList.add("\t" + name + ": " + text + newline);

                    Iterator it = map.keySet().iterator();
                    while (it.hasNext())
                    {
					    String qName = (String) it.next();
					    if (qName.compareTo("def-definition") != 0 && qName.compareTo("root") != 0)
					    {
							String qValue = (String) map.get(qName);
							classList.add("\t\t" + qName + ": " + qValue + newline);
						}
					}
				}
				else if (map.containsKey("term-name"))
				{
					text = (String) map.get("term-name");
					classList.add("\t" + name + ": " + text + newline);

                    Iterator it = map.keySet().iterator();
                    while (it.hasNext())
                    {
					    String qName = (String) it.next();
					    if (qName.compareTo("term-name") != 0 && qName.compareTo("root") != 0)
					    {
							String qValue = (String) map.get(qName);
							classList.add("\t\t" + qName + ": " + qValue + newline);
						}
					}
				}


				else
				{
					classList.add("\t" + s + newline);
				}
			}
			classList.add(newline);
	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
	}

    private void sortObjectValuedAnnotationData(ArrayList properties, ArrayList values)
    {
		String label = "Object-Valued Annotation Properties (Associations)";
		classList.add(newline);
		classList.add(label + newline);

        Vector v = new Vector();
        for (int i=0; i<properties.size(); i++)
        {
			RDFProperty property = (RDFProperty) properties.get(i);
			OWLNamedClass value = (OWLNamedClass) values.get(i);

			String s = property.getBrowserText() + "\t" + value.getBrowserText();
			v.add(s);
		}

        QuickSortVecStrings qsvs = new QuickSortVecStrings();
        try {
			qsvs.sort(v);
			for (int i=0; i<v.size(); i++)
			{
				String s = (String) v.elementAt(i);
				classList.add("\t" + s + newline);
			}
	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
	}

    private void sortConditionData(String label, ArrayList items)
    {
		classList.add(newline);
		classList.add(label + newline);

        Vector v = new Vector();
        for (int i=0; i<items.size(); i++)
        {
			NCIConditionsTableItem item = (NCIConditionsTableItem) items.get(i);
			String s = item.getDisplayText();
			if (item.isDefining()) s = s + "   [defining]";
			//121406
			if (item.isInherited()) s = s + "   [inherited]";

			v.add(s);
		}

        QuickSortVecStrings qsvs = new QuickSortVecStrings();
        try {
			qsvs.sort(v);
			for (int i=0; i<v.size(); i++)
			{
				String s = (String) v.elementAt(i);
				classList.add("\t" + s + newline);
			}
	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
	}

}

