package gov.nih.nci.protegex.edit;

import java.io.*;
import java.net.URL;
import java.awt.Color;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class TreeNode extends DefaultMutableTreeNode
{
    int nodeType;
    String sep = File.separator;

    public TreeNode(Object obj, int nodeType)
    {
        super(obj);
        this.nodeType = nodeType;
    }

    public int getType()
    {
		return nodeType;
    }

    public String getText()
    {
    	return this.toString();
    }

/*
	static final int TYPE_CONCEPT = 0;
	static final int TYPE_PROPERTY = 1;
	static final int TYPE_PARENT = 2;
	static final int TYPE_RESTRICTION = 3;
	static final int TYPE_ASSOCIATION = 4;
*/

    public Color getColor()
    {
    	Color color=Color.orange.darker();
	if (nodeType == 0)
	   	color = Color.black;
	else if (nodeType == 1)
		color = Color.orange.darker().darker();
	else if (nodeType == 2)
		color = Color.magenta.darker().darker();
	else if (nodeType == 3)
		color = Color.blue.darker();
	else if (nodeType == 4)
		color = Color.cyan.darker();
	else if ((nodeType == 5) || (nodeType == 6))
		color = Color.yellow.darker();
	return color;
    }

    public ImageIcon getIcon()
    {
        ImageIcon icon=null;
/*
        URL url = getImageURL("orange-ball.gif");

    	if (nodeType == 0) // code, id
    		url = getImageURL("blue-ball.gif");
		else if (nodeType == 4) // code, id
			url = getImageURL("orange-ball.gif");
		else if (nodeType == 3) // role, property
			url = getImageURL("magenta-ball.gif");
		else if (nodeType == 2) // super
			url = getImageURL("singleprimitiveP.gif");
		//else if (nodeType == 1) // kind
		//	url = getImageURL("cyan-ball.gif");
		else if ((nodeType == 1) || (nodeType == 5) || (nodeType == 6)) // primitive, defined
			url = getImageURL("yellow-ball.gif");

		if (url != null)
			icon = new ImageIcon(url);
*/


    	if (nodeType == 0) // code, id
    		return NCIOWLIcons.getImageIcon("blue-ball.gif");
		else if (nodeType == 4) // code, id
			return NCIOWLIcons.getImageIcon("orange-ball.gif");
		else if (nodeType == 3) // role, property
			return NCIOWLIcons.getImageIcon("magenta-ball.gif");
		else if (nodeType == 2) // super
			return NCIOWLIcons.getImageIcon("singleprimitiveP.gif");
		//else if (nodeType == 1) // kind
		//	url = getImageURL("cyan-ball.gif");
		else if ((nodeType == 1) || (nodeType == 5) || (nodeType == 6)) // primitive, defined
			return NCIOWLIcons.getImageIcon("yellow-ball.gif");

		return NCIOWLIcons.getImageIcon("orange-ball.gif");
    }

    private URL getImageURL(String iconName) {
		return this.getClass().getResource(iconName);
	}
}
