package gov.nih.nci.protegex.edit;

import edu.stanford.smi.protege.widget.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.ui.*;


import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.InstanceDisplay;
import edu.stanford.smi.protege.util.*;
import edu.stanford.smi.protege.widget.ClsWidget;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.cls.*;
import edu.stanford.smi.protegex.owl.ui.clsdesc.DisjointClassesWidget;
import edu.stanford.smi.protegex.owl.ui.conditions.ConditionsWidget;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourceDisplay;
import edu.stanford.smi.protegex.owl.ui.subsumption.InferredSubsumptionTreePanel;
import edu.stanford.smi.protegex.owl.ui.widget.WidgetUtilities;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;

import java.io.*;
import java.sql.Connection;
import java.util.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import edu.stanford.smi.protegex.owl.model.RDFSClass;

import edu.stanford.smi.protegex.owl.model.OWLProperty;

import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;

import edu.stanford.smi.protege.util.ComponentFactory;
import edu.stanford.smi.protegex.owl.model.impl.DefaultRDFSDatatype;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */


public class TreePanel extends JPanel implements DropTargetListener
{

// (1) need to store which tab this tree panal belongs
// (2) perform pre-condition checking on drop event
//     for example, for a concept to be retired, the concept must have already
//     been flagged for retirement through preretire action, reject drop if needed.
//

    static final int TYPE_UNKNOWN = -1;
	static final int TYPE_SPLIT = 0;

	static final int TYPE_PREMERGE = 1;
	static final int TYPE_PREMERGE_UPPER = 11;
	static final int TYPE_PREMERGE_LOWER = 12;

	static final int TYPE_MERGE = 2;
	static final int TYPE_MERGE_UPPER = 21;
	static final int TYPE_MERGE_LOWER = 22;

	static final int TYPE_PRERETIRE = 3;

	static final int TYPE_RETIRE = 4;

	static final int TYPE_CLONE = 5;
	static final int TYPE_CLONE_UPPER = 51;
	static final int TYPE_CLONE_LOWER = 52;

	static final int TYPE_DELETE = 6;

    Vector associationNames = null;

	Instance selectedInstance;

	protected JPopupMenu m_popup;
	protected Action m_action;
	protected TreePath m_clickedPath;

    protected JTree edit_tree;
    JScrollPane treeView;
    int selected_tab;

    TreeNode root_node;

    DropTarget dt;

    DefaultTreeModel model;

    public Cls droppedCls = null;

    //Rename
    JDialog renamePopUpDialogBox;
    JButton renameCancelButton;

//    TreePanel thisTree;
    //KnowledgeBase kb;
    OWLModel kb;

    Vector initialState = null;
    Vector finalState = null;

    NCIEditTab tab;

    String code = null;
    String name = null;

    String newname = null;

    private boolean canDrop;

    public int type;
    public int subtype;

    private static final String SUBCLASSOF = "rdfs:subClassOf";

    HashSet hset;

    OWLWrapper wrapper;

    QuickSortVecStrings sort = null;

    //042106
    Vector item_vec;

    Vector nonEditableProperties;

    private Vector inboundRoles;
    private Vector oldSubclasses;

    private Vector old_child_vec = null;
    private Vector old_source_role_vec = null;


    public boolean isNew;

    public boolean popUpWindowEnabled = true;

    private OWLNamedClass retiredCls = null;

    // 032207
    private Vector initial_state;


    public Cls getInstance()
    {
		return (Cls) selectedInstance;
	}


// Merge: lowerTreePanel_Merge = new TreePanel(this, selectedInstance, selected_tab, dmtn, null);
//		lowerTreePanel_Premerge = new TreePanel(this, selectedInstance,  dmtn, null);

    public TreePanel(NCIEditTab tab,
                     Instance selectedInstance,
                     TreeNode dmtn,
                     String code)
    {

		this.kb = tab.getOWLModel();
		this.wrapper = tab.getOWLWrapper();

		init();
		this.item_vec = new Vector();
        this.sort = new QuickSortVecStrings();
		this.selectedInstance = selectedInstance;
		this.selected_tab = selected_tab;
		this.tab = tab;

		this.root_node = dmtn;

    	this.initialState = new Vector();
    	initialState.add((TreeItem) dmtn.getUserObject());

        TreeItem tree_item = (TreeItem) dmtn.getUserObject();
    	newname = tree_item.getName();
    	name = tree_item.getName();

        model = new DefaultTreeModel(dmtn);
		initialize(dmtn);

		initial_state = createInitialState((Cls) selectedInstance, dmtn);

		setupDrop();

		hset = getOWLAnnotationProperties();

    	this.finalState = new Vector();

		this.type = TYPE_UNKNOWN;


		setCode(wrapper.getCode(wrapper.getCls(name)));

		old_child_vec = new Vector();
		old_source_role_vec = new Vector();
    }


// Split: lowerTreePanel_Split = new TreePanel(this, selectedInstance, selected_tab, root, code, v);

    public TreePanel(NCIEditTab tab,
                     Instance selectedInstance,
                     TreeNode dmtn,
                     String code,
                     Vector treeitems)
    {

		this.kb = tab.getOWLModel();
		this.wrapper = tab.getOWLWrapper();

		init();
		this.item_vec = new Vector();
        this.sort = new QuickSortVecStrings();
		this.selectedInstance = selectedInstance;
		this.selected_tab = selected_tab;
		this.tab = tab;

		this.root_node = dmtn;

		this.code = code;

    	this.initialState = new Vector();
    	initialState.add((TreeItem) dmtn.getUserObject());

        TreeItem tree_item = (TreeItem) dmtn.getUserObject();
    	newname = tree_item.getName();
    	name = tree_item.getName();
    	tree_item.setType(0);

		//041906
		edit_tree = new JTree(dmtn);

		// 010807
		TreeRenderer renderer = new TreeRenderer();
		edit_tree.setCellRenderer(renderer);
		NCITreeCellEditor editor = new NCITreeCellEditor(edit_tree, renderer);
		edit_tree.setCellEditor(editor);


		model = (DefaultTreeModel) edit_tree.getModel();

		populate(treeitems);

		initial_state = createInitialState((Cls) selectedInstance, dmtn);

		setupDrop();

		hset = getOWLAnnotationProperties();
    	this.finalState = new Vector();

		this.type = TYPE_UNKNOWN;

		old_child_vec = new Vector();
		old_source_role_vec = new Vector();
    }



    public TreePanel(NCIEditTab tab,
                     Instance selectedInstance,
                     OWLModel kb)
    {

		this.kb = tab.getOWLModel();
		this.wrapper = tab.getOWLWrapper();

		init();
		this.item_vec = new Vector();
		this.sort = new QuickSortVecStrings();
		this.selectedInstance = selectedInstance;
		this.selected_tab = selected_tab;
		this.tab = tab;

		initialize(null);
		setupDrop();

		//this.kb = kb;
		hset = getOWLAnnotationProperties();

//		thisTree = this;

    	this.initialState = new Vector();

    	this.finalState = new Vector();

    	this.type = TYPE_UNKNOWN;



    	if (selectedInstance != null)
    	{
			String instance_name = wrapper.getInternalName((Cls)selectedInstance);

			setName(instance_name);

			//setName(selectedInstance.getBrowserText());
			setCode(wrapper.getCode((Cls) selectedInstance));

		}

		old_child_vec = new Vector();
		old_source_role_vec = new Vector();


    }

    public void setIsNew(boolean b)
    {
		isNew = b;
	}
    public boolean getIsNew()
    {
		return isNew;
	}

	public boolean containsCls(){
		if (droppedCls==null)
			return false;
		return true;
	}


    public void reset_old_child_vec()
    {
		old_child_vec.clear();
	}

    public void add_old_child(String sub)
    {
		old_child_vec.add(sub);
	}

    public Vector get_old_child_vec()
    {
		return old_child_vec;
	}


    public void reset_old_source_role_vec()
    {
		old_source_role_vec.clear();
	}

    public void add_old_source_role(String role)
    {
		old_source_role_vec.add(role);
	}

    public Vector get_old_source_role_vec()
    {
		return old_source_role_vec;
	}


    private void init()
    {
    	associationNames = new Vector();
        associationNames.add(RDFSNames.Slot.IS_DEFINED_BY);
        associationNames.add(RDFSNames.Slot.SEE_ALSO);
        associationNames.add(OWLNames.Slot.SAME_AS);
        associationNames.add(kb.getOWLDifferentFromProperty().getBrowserText());
        associationNames.add(kb.getOWLEquivalentPropertyProperty().getBrowserText());
        associationNames.add(kb.getOWLDisjointWithProperty().getBrowserText());

		nonEditableProperties = wrapper.getReadOnlyProperties();

		this.inboundRoles = new Vector();
		this.oldSubclasses = new Vector();

		this.isNew = false;
	}

	public boolean isNonEditable(String prop_name)
	{
		if (nonEditableProperties.contains(prop_name))
		{
			return true;
		}
		return false;
	}


    public void setCode(String code)
    {
		this.code = code;
	}


    boolean canRetire(OWLNamedClass retireCls)
    {
		OWLModel okb = (OWLModel) tab.getOWLModel();
		OWLNamedClass retire_root = okb.getOWLNamedClass(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS));

        String assignedName = tab.getOWLWrapper().getInternalName(retireCls);

		if (retire_root != null)
		{
			if (retireCls.isSubclassOf(retire_root))
			{
				return true;
			}
			else if (assignedName.compareTo(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS)) == 0)
			{
				return true;
			}
		}
		return false;
	}

    boolean isRetired(OWLNamedClass retireCls)
    {
		OWLModel okb = (OWLModel) tab.getOWLModel();
		OWLNamedClass retire_root = okb.getOWLNamedClass(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS));
		String assignedName = tab.getOWLWrapper().getInternalName(retireCls);

		if (retire_root != null)
		{
			if (retireCls.isSubclassOf(retire_root))
			{
				return true;
			}
			else if (assignedName.compareTo(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS)) == 0)
			{
				return true;
			}
		}
		return false;
	}


    public void setType(int type)
    {
		this.type = type;
	}

    public void setSubType(int subtype)
    {
		this.subtype = subtype;
	}

    public void setName(String name)
    {
		this.name = name;
	}

    public Cls getDroppedCls()
    {
		return droppedCls;
	}

    public TreeNode getRootNode()
    {
		return root_node;
	}


    public Vector getInitialState()
    {
		// See ConceptStatus for initial state
		//return initialState;
		if (initial_state == null) return initialState;
		return initial_state;
	}

    public static void outputState(Vector v)
    {
		for (int i=0; i<v.size(); i++)
		{
			TreeItem item = (TreeItem) v.elementAt(i);
			System.out.println("Type: " + item.getType());
			System.out.println("Name: " + item.getName());
			System.out.println("Value: " + item.getValue());
			System.out.println("toString: " + item.toString());

			if (item.getCls() != null && item.getIsDefining())
			{
				System.out.println("aClass: " + item.getCls().getBrowserText());
				System.out.println("defining: TRUE");
			}
			else if (item.getCls() != null)
			{
				System.out.println("aClass: " + item.getCls().getBrowserText());
				System.out.println("defining: FALSE");
			}

			if (item.getModifier().compareTo("") != 0)
			{
				System.out.println("Modifier: " + item.getModifier());
		    }
			System.out.println("");
		}
	}

    public static void outputState(String label, Vector v)
    {
		System.out.println("Tree Items (" + label + ")" );
		outputState(v);
	}

    public void outputFinalState()
    {
		finalState = getFinalState();
		outputState(finalState);
	}

    public Vector getFinalState()
    {
		Vector v = new Vector();//finalState.clear();

		if (root_node == null)
		{
			System.out.println("TreePanel getFinalState WARNING: root_node == null");
			return v;
		}
		else if (root_node.getUserObject() == null)
		{
			return v;
		}

		TreeItem item = (TreeItem) root_node.getUserObject();
		v.add(item);

		Enumeration enumeration = root_node.children();

		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			item = (TreeItem) dmtn.getUserObject();

			v.add(item);
		}

		return v;
	}


    String getItemKey(TreeItem treeitem)
    {
		if (treeitem.getIsDefining())
		{
			return treeitem.toString() + "(defining)";
		}
		return treeitem.toString();
	}



    public static void outputState(String outputfile, String label, Vector v)
    {
		PrintWriter pw = null;
		try {
			pw = new PrintWriter (new BufferedWriter(new FileWriter(outputfile)));

			pw.println(label);
			if (v.size() == 0)
			{
				pw.println("\nNone");
			}
			for (int i=0; i<v.size(); i++)
			{
				TreeItem item = (TreeItem) v.elementAt(i);
				pw.println("Type: " + item.getType());
				pw.println("Name: " + item.getName());
				pw.println("Value: " + item.getValue());

				String key = item.toString();
				if (item.getIsDefining())
				{
					key = item.toString() + "(defining)";
				}
				pw.println("ItemKey: " + key);


				if (item.getModifier().compareTo("") != 0)
				{
					pw.println("Modifier: " + item.getModifier());
				}

				if (item.getCls() != null)
				{
					pw.println("aClass: " + item.getCls().getBrowserText());
					if (item.getIsDefining())
					{
						pw.println("defining: TRUE");
					}
					else
					{
						pw.println("defining: FALSE");
					}
				}

				pw.println("");

			}
			pw.close();
		}catch(Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
	}




    public void outputTreeNode(TreeNode dmtn)
    {
		TreeItem item = (TreeItem) dmtn.getUserObject();
		System.out.println("Type: " + item.getType());
		System.out.println("Name: " + item.getName());
		System.out.println("Value: " + item.getValue());
		System.out.println("");
	}


    private boolean isUserDefinedRDFProperty(String name)
    {
		Collection allProperties = kb.getVisibleUserDefinedRDFProperties();
		Collection selectableProperties = new ArrayList();
		for (Iterator it = allProperties.iterator(); it.hasNext();) {
			RDFProperty property = (RDFProperty) it.next();
			if (property.isAnnotationProperty()
				&& property.hasObjectRange()
				&& property instanceof DefaultOWLObjectProperty)
			{
				//if (property.getBrowserText().compareTo(name) == 0)
				if (property.getName().compareTo(name) == 0)
				{
					return true;
				}
			}
		}
		return false;
	}

   	public void initialize(TreeNode dmtn)
   	{
		canDrop = true;
		if (dmtn != null)
		{
			root_node = dmtn;
			createNodes(root_node);

		}
		else if (selectedInstance != null)
		{
			root_node = dmtn;
			createNodes(root_node);
		}

		edit_tree = new JTree(root_node);
		edit_tree.setEditable(true);

		edit_tree.getSelectionModel().setSelectionMode
				(TreeSelectionModel.SINGLE_TREE_SELECTION);


		TreeRenderer renderer = new TreeRenderer();

		//renderer.setLeafIcon(new ImageIcon("images/middle.gif"));
		edit_tree.setCellRenderer(renderer);

		//Listen for when the selection changes.
		edit_tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				TreeNode node = (TreeNode)
					edit_tree.getLastSelectedPathComponent();

				if (node == null) return;

				Object nodeInfo = node.getUserObject();
				if (node.isLeaf()) {

				}
			}
		});


		addPopup(edit_tree);

        //treeView = new JScrollPane(edit_tree);
        //treeView=new JScrollPane(edit_tree, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		setLayout(new BorderLayout());
		//add(treeView, BorderLayout.CENTER);
		add(edit_tree, BorderLayout.CENTER);
    }


   	public void populate(Vector treeitems)
   	{
		canDrop = true;

		edit_tree.setEditable(true);
		edit_tree.getSelectionModel().setSelectionMode
				(TreeSelectionModel.SINGLE_TREE_SELECTION);

		TreeRenderer renderer = new TreeRenderer();

		edit_tree.setCellRenderer(renderer);

		edit_tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				TreeNode node = (TreeNode)
					edit_tree.getLastSelectedPathComponent();

				if (node == null) return;

				Object nodeInfo = node.getUserObject();
				if (node.isLeaf()) {

				}
			}
		});

		createNodes(treeitems);

        //treeView = new JScrollPane(edit_tree);

		setLayout(new BorderLayout());
		//add(treeView, BorderLayout.CENTER);
		add(edit_tree, BorderLayout.CENTER);
		addPopup(edit_tree);
    }


	//private void addPopup(final JTree edit_tree)
	void addPopup(final JTree edit_tree)
	{
		model = (DefaultTreeModel) edit_tree.getModel();

		m_popup = new JPopupMenu();
		m_action = new AbstractAction()
		{
			public void actionPerformed(ActionEvent e)
			{
				if (m_clickedPath==null)
					return;
				if (edit_tree.isExpanded(m_clickedPath))
					edit_tree.collapsePath(m_clickedPath);
				else
					edit_tree.expandPath(m_clickedPath);
			}
		};
		m_popup.add(m_action);
		m_popup.addSeparator();

		Action a1 = new AbstractAction("Delete")
		{
			public void actionPerformed(ActionEvent e)
			{
        		TreeNode selectedNode
            		= (TreeNode) edit_tree.getLastSelectedPathComponent();

				TreeItem item = (TreeItem)selectedNode.getUserObject();

				if (item.getType() == TreeItem.TYPE_PROPERTY)
				{
					String prop_name = item.getName();

					// 042507 (Cannot delete preferred name)
					String pt_name = wrapper.getSlotName(tab.PREFERRED_NAME);
					if (prop_name.compareTo(pt_name) == 0)
					{
						ModalDialog.showMessageDialog(null, "Cannot delete " + prop_name + ".");
						System.out.println("WARNING: Cannot delete " + prop_name +".");
						return;
					}

					String prop_value = item.getValue();

					if (wrapper == null)
					{
						wrapper = tab.getOWLWrapper();
					}


					Boolean value = wrapper.isReadOnly(prop_name);
					if (Boolean.TRUE.equals(value))
					{
						ModalDialog.showMessageDialog(null, "Cannot delete " + prop_name + "; it is read only.");
						System.out.println("WARNING: " + prop_name + " is read only.");
						return;
					}
			    }
			    // 041707
			    else if (item.getType() == TreeItem.TYPE_PARENT)
			    {
					int n = getSuperclassCount();
					if (n == 1)
					{
						ModalDialog.showMessageDialog(null, "Cannot delete the last named superclass.");
						return;
					}
				}


				if (selectedNode.getParent() != null)
				{
					model.removeNodeFromParent(selectedNode);
					model.reload();
					edit_tree.repaint();
				}
				else
				{
					System.out.println("WARNING: selectedNode.getParent() == null");
				}
			}
		};
		m_popup.add(a1);
		m_popup.addSeparator();

		Action a2 = new AbstractAction("Modify Property")
		{
			public void actionPerformed(ActionEvent e)
			{

        		TreeNode selectedNode
            		= (TreeNode) edit_tree.getLastSelectedPathComponent();

				TreeItem item = (TreeItem)selectedNode.getUserObject();

				if (item.getType() != TreeItem.TYPE_PROPERTY)
				{
					return;
				}

                String prop_name = item.getName();
                String prop_value = item.getValue();

				if (wrapper == null)
				{
					wrapper = tab.getOWLWrapper();
				}

                Boolean value = wrapper.isReadOnly(prop_name);
                if (Boolean.TRUE.equals(value))
                {
					ModalDialog.showMessageDialog(null, "Cannot modify " + prop_name + "; it is read only.");
					System.out.println("WARNING: " + prop_name + " is read only.");
					return;
				}

				if (isNonEditable(prop_name))
				{
					ModalDialog.showMessageDialog(null, "Cannot add " + prop_name + "; it is created by computer.");
					System.out.println("WARNING: " + prop_name + " is assigned by computer.");
					return;
				}

                boolean hasAuthorization = tab.getFilter().canModify(item, initialState);
                if (!hasAuthorization)
                {
					String user = tab.getUserName();
					System.out.println("User " + user + " does not have privilege to modify this property.");
					String msg = "User " + user + " does not have privilege to modify this property.";

					ModalDialog.showMessageDialog(null, msg);
					return;
				}

				if (
				    prop_name.equals(tab.getSlotName(NCIEditTab.DEFINITION)) ||
					prop_name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) ||
					prop_name.equals(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) ||
					prop_name.equals(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) ||
					prop_name.equals(tab.getSlotName(NCIEditTab.ALT_DEFINITION))) {

				//if (prop_name.equals(tab.getSlotName(NCIEditTab.FULL_SYN)) || prop_name.equals(tab.getSlotName(NCIEditTab.DEFINITION))){



					CustomizedAnnotationDialog dialog
						= new CustomizedAnnotationDialog(tab.getEditPanel(), prop_name, prop_value, -1, new NCIAnnotationsTableModel(kb));

                    if (!dialog.cancelBtnPressed)
                    {
						String newValue = dialog.getValue();
						item.setValue(newValue);
						item.setNameValue(prop_name + ": " + item.getValue());

						selectedNode.setUserObject((Object) item);
						model.reload();
				    }
				}

				else if (prop_name.equals(tab.getSlotName(NCIEditTab.FULL_SYN)))
				{

				//if (prop_name.equals(tab.getSlotName(NCIEditTab.FULL_SYN)) || prop_name.equals(tab.getSlotName(NCIEditTab.DEFINITION))){

					CustomizedAnnotationDialog dialog =
						new CustomizedAnnotationDialog(tab.getEditPanel(), prop_name, prop_value, -1, new NCIFULLSYNTableModel(tab.getEditPanel(), kb));

                    if (!dialog.cancelBtnPressed)
                    {
						String newValue = dialog.getValue();
						item.setValue(newValue);
						item.setNameValue(prop_name + ": " + item.getValue());

						selectedNode.setUserObject((Object) item);
						model.reload();
				    }


				} else{


					Slot slot = kb.getSlot(prop_name);
					RDFProperty property = (RDFProperty) slot;
					String[] allowedvalues = getAllowableValues(property);
					if (allowedvalues != null)
					{
						JList valueList;
						valueList = ComponentFactory.createList(null);
						valueList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						Arrays.sort(allowedvalues);
						java.util.List list = Arrays.asList(allowedvalues);
						valueList.setListData(list.toArray());
						//valueList.setSelectedIndex(0);
						JScrollPane comp = new JScrollPane(valueList);

						valueList.setSelectedValue(prop_value, true);

						String label = property.getBrowserText();
						LabeledComponent lc = new LabeledComponent(label, comp);

						lc.setPreferredSize(new Dimension(400, 120));
						int r = ProtegeUI.getModalDialogFactory().showDialog(tab, lc, "Add Annotation", ModalDialogFactory.MODE_OK_CANCEL);
						if (r == ModalDialogFactory.OPTION_OK) {

							String newValue = (String) valueList.getSelectedValue();

							if (newValue.compareTo("") == 0)
							{
								Component warning_label = new JLabel("Property value is mandatory.");
								LabeledComponent lc2 = new LabeledComponent("", warning_label);
								int k = ProtegeUI.getModalDialogFactory().showDialog(tab.getEditPanel(), lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
							}
							else
							{
								item.setValue(newValue);
								item.setNameValue(prop_name + ": " + item.getValue());
								selectedNode.setUserObject((Object) item);
								model.reload();

							}
						}
					}

					else
					{

						JTextArea textArea = new JTextArea(value.toString());
						textArea.setLineWrap(true);
						textArea.setWrapStyleWord(true);
						textArea.setText(prop_value);

						Component comp = new JScrollPane(textArea);
						LabeledComponent lc = new LabeledComponent(prop_name, comp);

						lc.setPreferredSize(new Dimension(400, 120));
						int r = ProtegeUI.getModalDialogFactory().showDialog(tab.getEditPanel(), lc, "Edit Annotation", ModalDialogFactory.MODE_OK_CANCEL);
						if (r == ModalDialogFactory.OPTION_OK) {
							String newValue = textArea.getText();

							if (newValue.compareTo("") == 0)
							{
								Component warning_label = new JLabel("Property value is mandatory.");
								LabeledComponent lc2 = new LabeledComponent("", warning_label);
								int k = ProtegeUI.getModalDialogFactory().showDialog(tab.getEditPanel(), lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
							}
							else
							{
								item.setValue(newValue);
								item.setNameValue(prop_name + ": " + item.getValue());
								selectedNode.setUserObject((Object) item);
								model.reload();

							}
						}
				    }
				}

            }

		};

		m_popup.add(a2);
		m_popup.addSeparator();


//		Action a3 = new AbstractAction("Modify Restriction")
//		{
		Action a3 = new AbstractAction("Modify a restriction ...",
					NCIOWLIcons.getImageIcon("edit")) {

			public void actionPerformed(ActionEvent e) {

				TreeNode selectedNode
					= (TreeNode) edit_tree.getLastSelectedPathComponent();

				TreeItem item = (TreeItem) selectedNode.getUserObject();

				if (item.getType() != TreeItem.TYPE_RESTRICTION)
				{
					return;
				}

				boolean retval = modifyRestriction(item);//, item.getCls(), item.getIsDefining());
				if (retval)
				{
					selectedNode.setUserObject((Object) item);

					model.reload();
					edit_tree.repaint();
				}
				//edit_tree.repaint();

			}
		};


		m_popup.add(a3);
		m_popup.addSeparator();

		Action a4 = new AbstractAction("Add Property")
		{
			public void actionPerformed(ActionEvent e)
			{
        		TreeNode selectedNode
            		= (TreeNode) edit_tree.getLastSelectedPathComponent();

                if (selectedNode != null)
                {
					String currValue = (String)selectedNode.getUserObject().toString();
					CreatePropertyDialog dlg = new CreatePropertyDialog(tab, "", "");

					String prop_name = dlg.getPropertyName();
/*
					if (isNonEditable(prop_name))
					{
						ModalDialog.showMessageDialog(null, "Cannot add " + prop_name + "; it is created by computer.");
						System.out.println("WARNING: " + prop_name + " is assigned by computer.");
						return;
					}
*/
					String prop_value = dlg.getPropertyValue();
					if (prop_name.compareTo("") != 0 && prop_value.compareTo("") != 0)
					{
						TreeNode child_node = addProperty(prop_name, prop_value, null);
						edit_tree.repaint();
					}

			    }
			}
		};
		m_popup.add(a4);
		m_popup.addSeparator();


		Action a5 =
				new AbstractAction("Create a restriction ...",
						OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION))
		{
			String role_name = "";
			String role_value = "";
			String role_modifier = "";
			boolean isDefining = false;
			OWLRestriction restriction = null;

			public void actionPerformed(ActionEvent e)
			{
				boolean cancelBtnPressed = false;
				boolean dataEntryComplete = false;

				while (!cancelBtnPressed || !dataEntryComplete)
				{
					//final NCIRoleGroupEditorPanel rolegroupPanel = new NCIRoleGroupEditorPanel
					//   (tab, kb, cond_model_1, -1, null);

					final NCIRoleGroupEditorPanel rolegroupPanel = new NCIRoleGroupEditorPanel
					   (tab, kb);//, cond_model_1, -1, null);


					String label = "Roles (Simple Restrictions)";
					LabeledComponent lc = new LabeledComponent(label, rolegroupPanel);

					final String create_label = "Create a Restriction";
					Action createRestrictionAction_1 =
							new AbstractAction("Create a role (simple restriction)...",
									OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION)) {

						public void actionPerformed(ActionEvent e)
						{
							OWLRestriction r = null;
							boolean completed = false;

							while (!completed)
							{
								NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
									kb.getCls(OWLNames.Cls.SOME_VALUES_FROM_RESTRICTION),
									null, null, null);

								int ans = ModalDialog.showDialog(null, dlg, create_label, ModalDialog.MODE_OK_CANCEL);
								if (ans == ModalDialog.OPTION_OK)
								{
									r = dlg.getResult();
									if (r != null)
									{
										rolegroupPanel.getRoleGroupTableModel().addRow(r);
										completed = true;
										break;
									}
									else
									{
										try {
											Object[] options = {"OK"};
											int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
											JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
											null, options, options[0]);
											completed = false;
										}
										catch(Exception ex){
											Log.getLogger().log(Level.WARNING, "Exception caught", ex);
										}
									}
								}
								else
								{
									completed = true;
								}
							}
						}
					};

					//lc.addHeaderSeparator();
					JButton hb_add_6 = lc.addHeaderButton(createRestrictionAction_1);


					//////////////////////////////////////////////////////////////////////////////////////////////////

				   final String modify_label = "Modify a Restriction";
					Action modifyRestrictionAction_1 =
							new AbstractAction("Modify a role (simple restriction)...",
									NCIOWLIcons.getImageIcon("edit")) {

						public void actionPerformed(ActionEvent e)
						{
							OWLRestriction r = null;
							boolean completed = false;


							int selIndex = rolegroupPanel.getRoleGroupTable().getSelectedRow();
							if (selIndex == -1) return;

							r = rolegroupPanel.getRoleGroupTableModel().getRole(selIndex);

							RDFProperty p = r.getOnProperty();
							String prop_name = p.getName();

							String fillerText = r.getFillerText();
							String prop_modifier = wrapper.getRestrictionType(r);

							String label = wrapper.restrictionType2Label(prop_modifier);
							edu.stanford.smi.protege.model.Cls metaCls = wrapper.getMetaClsByName(label);

							int group_number = rolegroupPanel.getRoleGroupTableModel().getRoleGroupNumber(selIndex);

							while (!completed)
							{
								NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
									metaCls,
									p, fillerText, null);


								int ans = ModalDialog.showDialog(null, dlg, modify_label, ModalDialog.MODE_OK_CANCEL);
								if (ans == ModalDialog.OPTION_OK)
								{
									r = dlg.getResult();
									if (r != null)
									{
										System.out.println(r.getBrowserText());
										//rolegroupPanel.getRoleGroupTableModel().addRow(r);

										rolegroupPanel.getRoleGroupTableModel().updateRestriction(r, selIndex);

										completed = true;
										break;
									}
									else
									{
										try {
											Object[] options = {"OK"};
											int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
											JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
											null, options, options[0]);
											completed = false;
										}
										catch(Exception ex){
											Log.getLogger().log(Level.WARNING, "Exception caught", ex);
										}
									}
								}
								else
								{
									completed = true;
								}
							}
						}
					};

					lc.addHeaderSeparator();
					JButton hb_modify_6 = lc.addHeaderButton(modifyRestrictionAction_1);

					//////////////////////////////////////////////////////////////////////////////////////////////////

					lc.addHeaderSeparator();
					JButton hb_delete_6 = lc.addHeaderButton(new NCIDeleteRoleAction(rolegroupPanel, tab, rolegroupPanel.getRoleGroupTable()));
					//String label = "Create Restriction";

					int result = ModalDialog.showDialog(null, lc, create_label, ModalDialog.MODE_OK_CANCEL);

					if (result == ModalDialog.OPTION_OK)
					{
						RDFSClass restriction = rolegroupPanel.getRolegroups();
						if (restriction == null)
						{
							try {
								Object[] options = {"OK"};
								int ans = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
								JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
								null, options, options[0]);
								dataEntryComplete = false;
							}
							catch(Exception ex){
								Log.getLogger().log(Level.WARNING, "Exception caught", ex);
							}
						}
						else
						{
							// Process data
							HashMap hmap = rolegroupPanel.getRoleGroupTableModel().getRolegroups();
							RDFSClass aClass = rolegroupPanel.roleGroupHash2RDFSClass(hmap);
							boolean isDedefining = rolegroupPanel.getIsDefining();

						    TreeNode child_node = addRestriction(aClass, isDedefining);
						    edit_tree.repaint();
						    break;
						}
					}
					else
					{
						break;
					}
				}
			}
		};


		m_popup.add(a5);
		m_popup.addSeparator();

		Action a6 = new AbstractAction("Add Association")
		{
			public void actionPerformed(ActionEvent e)
			{
				CreateObjPropertyDialog dlg = new CreateObjPropertyDialog(tab);
				if (!dlg.cancelBtnPressed)
				{
					String association_name = dlg.getPropertyName();
					String association_value = dlg.getPropertyValue();

					Slot slot = dlg.getSelectedSlot();
					Cls  cls = dlg.getSelectedCls();

					/*

					if (association_value.compareTo(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS)) == 0 ||
						association_value.compareTo(tab.getClsName(NCIEditTab.PREMERGED_CONCEPTS)) == 0 ||
						association_value.compareTo(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS)) == 0)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select " +  association_value + ".");
						return;
					}
					*/

					//010407
					boolean invaldSelection = wrapper.isPremerged((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-merged concept.");
						return;
					}
					invaldSelection = wrapper.isPreretired((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-retired concept.");
						return;
					}
					invaldSelection = wrapper.isRetired((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a retired concept.");
						return;
					}



					if (association_name.compareTo("") != 0 &&
						association_value.compareTo("") != 0)
					{
						TreeNode child_node = addAssociation(slot, cls, association_name, association_value);
						edit_tree.repaint();
					}
				}
			 }



		};
		m_popup.add(a6);

		m_popup.addSeparator();

		Action a7 = new AbstractAction("Add Parent")
		{
			public void actionPerformed(ActionEvent e)
			{
				java.awt.TextField textfield = new TextField();
				String label = "Select a class.";

				Collection clses = kb.getRootClses();

				Cls cls = DisplayUtilities.pickConcreteCls(textfield, kb, clses);
				if (cls == null)
				{
					System.out.println("cls is null");
				}
				else
				{
					/*
					String prop_value = wrapper.getInternalName(cls);

					if (prop_value.compareTo(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS)) == 0 ||
						prop_value.compareTo(tab.getClsName(NCIEditTab.PREMERGED_CONCEPTS)) == 0 ||
						prop_value.compareTo(tab.getClsName(NCIEditTab.PRERETIRED_CONCEPTS)) == 0)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select " +  prop_value + ".");
						return;
					}

					//TreeNode child_node = addParent(prop_value);
					*/

					//010407
					boolean invaldSelection = wrapper.isPremerged((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-merged concept.");
						return;
					}
					invaldSelection = wrapper.isPreretired((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a pre-retired concept.");
						return;
					}
					invaldSelection = wrapper.isRetired((OWLNamedClass) cls);
					if (invaldSelection)
					{
						ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Cannot select a retired concept.");
						return;
					}

					TreeNode child_node = addParent(cls);
				}

				edit_tree.repaint();
			}
		};
		m_popup.add(a7);


/*		//091206
        m_popup.addSeparator();

		final TreePanel treepanel = this;
		Action a8 = new AbstractAction("Add Role Group")
		{
			public void actionPerformed(ActionEvent e)
			{
				RDFSClass aClass = null;
				boolean defining = false;
				NCIRoleGroupEditorPanel dlg = new NCIRoleGroupEditorPanel(tab, kb, aClass, treepanel);
				edit_tree.repaint();
			}
		};
		m_popup.add(a8);
*/
		edit_tree.add(m_popup);
		edit_tree.addMouseListener(new PopupTrigger());
	}


    private void outputNodeLabel(TreeNode node)
    {
		if (node == null) return;
		String s = (String)node.getUserObject().toString();
		System.out.println("Node: " + s);
	}

/*
	static final int TYPE_CONCEPT = 0;
	static final int TYPE_PROPERTY = 1;
	static final int TYPE_RESTRICTION = 2;
	static final int TYPE_PARENT = 3;

*/

/*
	//091206
	public void saveRoleGroup(NCIRoleGroupEditorPanel rolegroupPanel){



		//TODO: save role groups info based on HashMap rolegroups value
	}

*/


    private void createNodes(Vector treeitems)
    {
		if (selectedInstance == null)
		{
			System.out.println("WARNING: selectedInstance == null");
			return;
		}

		if (finalState != null) finalState.clear();

        if (initialState == null)
        {
			initialState = new Vector();
		}
		else
		{
			initialState.clear();
		}

        if (finalState == null)
        {
			finalState = new Vector();
		}
		else
		{
			finalState.clear();
		}

	    initialState.add((TreeItem) root_node.getUserObject());
        Cls cls = (Cls) selectedInstance;


		if (root_node == null)
		{
			System.out.println("WARNING: root_node is null.");
			return;
		}
		for (int i=0; i<treeitems.size(); i++)
		{
			TreeItem item = (TreeItem) treeitems.elementAt(i);
			if (item.getType() == TreeItem.TYPE_PROPERTY)
			{
				addProperty(item.getName(), item.getValue(), null);
			}
			else if (item.getType() == TreeItem.TYPE_RESTRICTION)
			{
				addRestriction(item.getCls(), item.getIsDefining());

			}
			else if (item.getType() == TreeItem.TYPE_PARENT)
			{
				addParent((Cls) item.getCls(), item.getIsDefining());
			}
			else if (item.getType() == TreeItem.TYPE_ASSOCIATION)
			{
				addAssociation(item.getProperty(), item.getCls(), item.getName(), item.getValue());
			}
		}
	}


	public Vector getDirectSuperClses()
	{
		if (root_node == null)
		{
			return null;
		}

        Vector v = new Vector();
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_PARENT)
			{
				v.add(item.getCls());
		    }
		}

		return v;
	}



	public Vector getRestrictionStrings()
	{
		if (root_node == null)
		{
			return null;
		}

        Vector v = new Vector();
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_RESTRICTION)
			{
				v.add(item.getName() + "|" + item.getValue() + "|" + item.getModifier());
		    }
		}

		return v;
	}


    private void createNodes(TreeNode top)
    {
		if (selectedInstance == null)
		{
			System.out.println("WARNING: selectedInstance == null");
			return;
		}

		if (finalState != null) finalState.clear();

        if (initialState == null)
        {
			initialState = new Vector();
		}
		else
		{
			initialState.clear();
		}

        if (finalState == null)
        {
			finalState = new Vector();
		}
		else
		{
			finalState.clear();
		}

	    initialState.add((TreeItem) top.getUserObject());
        Cls cls = (Cls) selectedInstance;

		try{
			getSlots(top, cls);
			//getParents(top, (OWLNamedClass) cls);
			getRoles(top, (OWLNamedClass) cls);
			TreeItem[] items = vector2Array(item_vec);
			TreeItem[] b = sortTreeItems(items);

			for (int i=0; i<b.length; i++)
			{
				TreeItem item = (TreeItem) b[i];

				//061306
				//TreeNode childnode = new TreeNode(item, -1);
				TreeNode childnode = new TreeNode(item, item.getType());

				root_node.add(childnode);
			}

			initial_state = createInitialState(cls, root_node);

		}
		catch(Exception e){
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
    }


	private void getParents(TreeNode dmtn, OWLNamedClass cls)
	{
		Collection parent_vec = cls.getDirectSuperclasses();//cls.getDirectSuperclasses();

		if (parent_vec == null || parent_vec.isEmpty())
		{
			return;
		}

		if (parent_vec != null) {
			Iterator j = parent_vec.iterator();
			while(j.hasNext())
			{
				Object obj = j.next();
				if (obj instanceof OWLNamedClass)
				{
					Cls owl_cls = (Cls) obj;
					try {
						TreeItem item = new TreeItem();
						item.setType(TreeItem.TYPE_PARENT);
						item.setName(SUBCLASSOF);
						String cls_name = wrapper.getInternalName(owl_cls);
						item.setValue(cls_name);
						item.setNameValue(SUBCLASSOF + ": " + cls_name);

						item.setCls((RDFSClass) owl_cls);

						initialState.add(item);
						item_vec.add(item);

					}
					catch(Exception e){
						Log.getLogger().log(Level.WARNING, "Exception caught", e);
					}

			    }


			}
		}
	}



	private void getSlots(TreeNode dmtn, Cls cls)
	{
		Collection ownslots = cls.getOwnSlots();
		if (ownslots != null) {
			Iterator j = ownslots.iterator();
			while(j.hasNext()){
				Slot slot = (Slot)j.next();
				//guoi
				Collection slotColl = cls.getOwnSlotValues(slot);
				//Collection slotColl = ((OWLNamedClass)cls).getPropertyValues(prop);

				if(slotColl == null || slotColl.isEmpty())
					continue;

				String slotName = slot.getName();

				if (slotName.equals(Model.Slot.NAME)) {
					continue;
				}
				else if (slotName.equals(Model.Slot.DIRECT_SUBCLASSES))
					continue;
				else if (slotName.equals(Model.Slot.DIRECT_INSTANCES))
					continue;
				else {
					getOwnslot(slotName, slotColl);
				}
			}
		}
	}

	private String getRestrictionString(OWLRestriction r)
	{
	    String prop = "";
		if (!(r instanceof OWLNamedClass))
        {
			String prop_modifier = tab.getOWLWrapper().getRestrictionType(r);
			RDFProperty p = r.getOnProperty();
            String prop_name = p.getName();
		    String prop_value = r.getFillerText();
            prop = prop_name + ": " + prop_modifier + " " + prop_value;
		}
		return prop;
	}

	public Vector getRestrictions()
	{
		if (root_node == null)
		{
			return null;
		}

        Vector v = new Vector();
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_RESTRICTION)
			{
				v.add(item.getCls());
		    }
		}

		return v;
	}


	private HashSet getOWLAnnotationProperties()
	{
		HashSet hset = new HashSet();

		if (tab == null)
		{
			return hset;
		}

		if (kb == null)
		{
			kb = tab.getOWLModel();
		}

		Collection annotationSlots = kb.getOWLAnnotationProperties();
		for(Iterator iterator = annotationSlots.iterator(); iterator.hasNext();) {
			Slot slot = (Slot) iterator.next();
			String slotName = slot.getName();
			hset.add(slotName);
		}
		return hset;
	}


    private String getStringValue(Object obj)
    {
		if (obj instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) obj;
            return literal.getString();
		}
		else
		{
			return (String) obj;
		}
	}

    private String getStringLanguage(Object obj)
    {
		if (obj instanceof RDFSLiteral)
		{
			RDFSLiteral literal = (RDFSLiteral) obj;
            return literal.getLanguage();
		}
		//guoi
		/*else
		{
			return (String) obj;
		}*/
		return "";
	}

    //private void getOwnslot(TreeNode dmtn, String slotname, Collection values)
    private void getOwnslot(String slotname, Collection values)
    {
		if (hset == null)
		{
//			System.out.println("WARNING: hset == null in getOwnslot");
			hset = getOWLAnnotationProperties();
			if (hset == null)
			{
				return;
			}
		}
		if (!hset.contains(slotname))
		{
			 if (slotname.compareTo(":DIRECT-SUPERCLASSES") != 0 &&
				 slotname.compareTo(":DIRECT-TYPE") != 0 &&
				 slotname.compareTo(":ROLE") != 0 &&
				 slotname.compareTo(SUBCLASSOF) != 0 &&
				 slotname.compareTo("owl:equivalentClass") != 0) {
				 if (values == null) return;
				 Iterator i = values.iterator();
				 while(i.hasNext()) {
					 Object obj = i.next();
					 TreeItem item = new TreeItem();

					 if (obj instanceof OWLNamedClass)
					 {
						 OWLNamedClass cls = (OWLNamedClass) obj;
						 String internalName = wrapper.getInternalName(cls);
						 if (internalName.compareTo("owl:Class") != 0)
						 {
							 item.setType(TreeItem.TYPE_ASSOCIATION);
							 item.setName(slotname);
							 item.setValue(internalName);
							 item.setNameValue(slotname + ": " + internalName);
							 initialState.add(item);
							 item_vec.add(item);
					     }
					 }
				 }
				 return;
			 }
		}


		if (values != null) {
			Iterator i = values.iterator();
			while(i.hasNext()) {
				Object obj = i.next();
                if (hset.contains(slotname))
				{
					ValueType type = getObjectValueType(obj);

					String entry = convertObjecttoString(obj, type);

                    String stringType = type.toString();

					try {
						TreeItem item = new TreeItem();
						if (slotname.compareTo(SUBCLASSOF) == 0)
						{
							item.setType(TreeItem.TYPE_PARENT);

							item.setCls((RDFSClass) obj);
						}

						else if (associationNames.contains(slotname)
						    || isUserDefinedRDFProperty(slotname))
						{
							item.setType(TreeItem.TYPE_ASSOCIATION);

//111706

							item.setCls((RDFSClass) obj);
							String targetname = wrapper.getInternalName((OWLNamedClass) obj);
							item.setValue(targetname);
							item.setNameValue(slotname, targetname);

						}

						else
						{
							item.setType(TreeItem.TYPE_PROPERTY);
						}

						item.setName(slotname);

						if (slotname.compareToIgnoreCase(tab.getSlotName(NCIEditTab.CODE)) == 0)
						{
							if (code == null)
							{
								item.setValue(entry);
								item.setNameValue(slotname + ": " + entry);

								code = entry;
							}
							else
							{
								item.setValue(code);
								item.setNameValue(slotname + ": " + code);
							}
						}

//111706
						else if (item.getType() == TreeItem.TYPE_PROPERTY)
						{
							// properties

							item.setValue(obj);
							item.setLanguage(getStringLanguage(obj));
							item.setNameValue(slotname, obj);

						}

						initialState.add(item);
						item_vec.add(item);

					}
					catch(Exception e){
						Log.getLogger().log(Level.WARNING, "Exception caught", e);
					}

			    }

			}
		}
	}

    protected String convertObjecttoString(Object obj, ValueType type) {
		if(type.equals(ValueType.STRING))
			return obj.toString();
		else if(type.equals(ValueType.FLOAT))
			return obj.toString();
		else if(type.equals(ValueType.INTEGER))
			return obj.toString();
		else if(type.equals(ValueType.ANY))
			return obj.toString();
		else if(type.equals(ValueType.BOOLEAN))
			return obj.toString();
		else if(type.equals(ValueType.CLS)) {
			Cls cls = (Cls) obj;
			return cls.getName();
		}
		else if(type.equals(ValueType.INSTANCE)) {
			Instance inst = (Instance) obj;
			return inst.getName();
		}
		else if(type.equals(ValueType.SYMBOL))
			return obj.toString();
		else return "Unknown";
    }


    protected ValueType getObjectValueType(Object obj) {
		if (obj instanceof Boolean)
			return ValueType.BOOLEAN;
        else if (obj instanceof Cls)
			return ValueType.CLS;
        else if (obj instanceof Float)
			return ValueType.FLOAT;
        else if (obj instanceof Instance)
			return ValueType.INSTANCE;
        else if (obj instanceof Integer)
			return ValueType.INTEGER;
        else if (obj instanceof String)
			return ValueType.STRING;
        else
			return ValueType.ANY;
    }


	public void dragEnter(DropTargetDragEvent event) {}
	public void dragOver (DropTargetDragEvent event) {}
	public void dropActionChanged ( DropTargetDragEvent event ) {}
	public void dragExit (DropTargetEvent event) {}


    public JTree getTree() {
		return edit_tree;
	}


	private void createTree(Cls cls)
	{
		selectedInstance = cls;
		String name = wrapper.getInternalName(droppedCls);

		String value = "";
		String restriction = "";
		String modifier = "";
		int cardinality = -1;

		TreeItem item = new TreeItem(TreeItem.TYPE_CONCEPT,
				name,
				value,
				restriction,
				modifier,
				cardinality);

		item.setNameValue(name);
		item.setCls((RDFSClass) cls);

		//061306
		//root_node = new TreeNode(item);
		root_node = new TreeNode(item, -1);

		edit_tree = new JTree(root_node);
		edit_tree.setEditable(true);

		model = new DefaultTreeModel(root_node);

		initialState=new Vector();
		initialState.add(item);


		//042506
		item_vec = new Vector();
		try{
			getSlots(root_node, cls);
			//getParents(root_node, (OWLNamedClass) cls);
			getRoles(root_node, (OWLNamedClass) cls);

		}
		catch(Exception e){
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
		createSortedNodes(root_node);

		initial_state = createInitialState(cls, root_node);
	}


	public void createSortedNodes(TreeNode root_node)
	{
		TreeItem[] items = vector2Array(item_vec);
		TreeItem[] b = sortTreeItems(items);
		for (int i=0; i<b.length; i++)
		{
			TreeItem item = (TreeItem) b[i];
			TreeNode childnode = new TreeNode(item, item.getType());
			root_node.add(childnode);
		}

		edit_tree = new JTree(root_node);
		edit_tree.getSelectionModel().setSelectionMode
				(TreeSelectionModel.SINGLE_TREE_SELECTION);

		TreeRenderer renderer = new TreeRenderer();
		edit_tree.setCellRenderer(renderer);

		//treeView.setViewportView(edit_tree);
		setView(edit_tree);

		setupDrop();
		addPopup(edit_tree);
	}

	private void setView(JTree edit_tree){
		tab.getScrollPane(type, subtype).setViewportView(edit_tree);
	}

    public void setCanDrop(boolean canDrop)
    {
		this.canDrop = canDrop;
	}

    public void drop(DropTargetDropEvent e) {
		if (!canDrop) return;

		if (wrapper == null)
		{
			wrapper = tab.getOWLWrapper();
		}

		String slotname_src = wrapper.getMergeSourceSlotName();
		String slotname_target = wrapper.getMergeTargetSlotName();
        boolean succeeded = false;
        DataFlavor flavor = TransferableCollection.getCollectionFlavor();

        //JTree tree = getTree(e);
        JTree tree = (JTree) e.getDropTargetContext().getComponent();

        if (e.isDataFlavorSupported(flavor)) {
            try {
                int action = e.getDropAction();
		        Collection sources = (Collection) (e.getTransferable().getTransferData(flavor));
		        Iterator i = sources.iterator();
		        while (i.hasNext()) {
		            Object source = i.next();

			        if (source instanceof Cls) {
						droppedCls = (Cls) source;

						retiredCls = (OWLNamedClass) kb.getCls(tab.getClsName(NCIEditTab.RETIRED_CONCEPTS));
						if (droppedCls.equals(retiredCls) ||
						    droppedCls.hasSuperclass(retiredCls))
						{
							String msg = "ERROR: Concept " + droppedCls.getBrowserText() + " is not editable.";
							showMessage(msg);
							return;
						}
						else if (droppedCls.equals(kb.getOWLThingClass()))
						{
							String msg = "ERROR: Concept " + droppedCls.getBrowserText() + " is not editable.";
							showMessage(msg);
							return;
						}


						String assignedName = wrapper.getInternalName(droppedCls);

						setName(assignedName);


						tab.addToListenedToClses((OWLNamedClass) droppedCls);

						if (wrapper.isNonEditable((OWLNamedClass) droppedCls))
						{
							String msg = "ERROR: Concept " + droppedCls.getBrowserText() + " is not editable.";
							showMessage(msg);
							return;
						}
						// Perform pre-condition checking

						if (type == TYPE_SPLIT)
						{
							tab.enableButton("splitButton_Split", true);
							tab.enableButton("saveButton_Split", false);
							tab.enableButton("clearButton_Split", true);
						}

						else if (type == TYPE_PREMERGE)
						{

							if (wrapper == null)
							{
								wrapper = tab.getOWLWrapper();
							}

							if (wrapper.hasAnnotationProperty((OWLNamedClass) droppedCls, slotname_src))
							{
								if (subtype == TYPE_PREMERGE_LOWER)
								{
								    showMessage("WARNING: Unable to load --  concept does not have a Merge_Target property.");
									return;
								}
								Cls referencedCls = tab.getReferencedCls(droppedCls);
								if (referencedCls != null)
								{
									int tab_id = 2;

String ref_name = wrapper.getInternalName(referencedCls);

									//tab.populatePremergePanel(referencedCls.getBrowserText());
									tab.populatePremergePanel(ref_name);
								}
								else
								{
									showMessage("WARNING: Unable to load pre-merged concepts.");
									return;
								}
							}
							else if (wrapper.hasAnnotationProperty((OWLNamedClass) droppedCls, slotname_target))
							{
								if (subtype == TYPE_PREMERGE_UPPER)
								{
								    showMessage("WARNING: Unable to load --  concept does not have a Merge_Source property.");
									return;
								}
								Cls referencedCls = tab.getReferencedCls(droppedCls);
								if (referencedCls != null)
								{
									int tab_id = 2;
String ref_name = wrapper.getInternalName(referencedCls);
									//tab.populatePremergePanel(referencedCls.getBrowserText());
									tab.populatePremergePanel(ref_name);
								}
								else
								{
									showMessage("WARNING: Unable to load pre-merged concepts.");
									return;
								}
							}


                            if (tab.lowerTreePanel_Premerge.containsCls() &&
                                tab.upperTreePanel_Premerge.containsCls())
                            {
								tab.enableButton("premergeButton_Premerge", true);
								tab.enableButton("saveButton_Premerge", false);
                            }
 							tab.enableButton("clearButton_Premerge", true);
						}

						else if (type == TYPE_MERGE)
						{

                            if (subtype == TYPE_MERGE_UPPER)
                            {

								if (!wrapper.hasAnnotationProperty((OWLNamedClass) droppedCls, slotname_src))
								{
									showMessage("WARNING: Unable to load pre-merged concepts -- Merge_Source cannot be identified.");
									return;
								}

								Cls referencedCls = tab.getReferencedCls(droppedCls);
								if (referencedCls != null)
								{
									int tab_id = 3;
String ref_name = wrapper.getInternalName(referencedCls);
									tab.populateMergePanel(ref_name);

								}
								else
								{
									showMessage("WARNING: Unable to load pre-merged concepts.");
									return;
								}
						    }
                            else if (subtype == TYPE_MERGE_LOWER)
                            {
								if (!wrapper.hasAnnotationProperty((OWLNamedClass) droppedCls, slotname_target))
								{
									showMessage("WARNING: Unable to load pre-merged concepts -- Merge_Target cannot be identified.");
									return;
								}

								Cls referencedCls = tab.getReferencedCls(droppedCls);
								if (referencedCls != null)
								{
									int tab_id = 3;

String ref_name = wrapper.getInternalName(referencedCls);
									tab.populateMergePanel(ref_name);

									//tab.populateMergePanel(referencedCls.getBrowserText());
								}
								else
								{
									showMessage("WARNING: Unable to load pre-merged concepts.");
									return;
								}
						    }


						}


						else if (type == TYPE_CLONE){
							int num = tab.getNumClses();
							if (num == 1){
								if (tab.upperTreePanel_Clone.droppedCls != null)
								{
									tab.enableButton("cloneButton_Clone", true);
							    }
								tab.enableButton("saveButton_Clone", true);
								tab.enableButton("clearButton_Clone", true);
							}else if (num == 2){
								tab.enableButton("newButton_Clone", false);
								tab.enableButton("cloneButton_Clone", false);
								tab.enableButton("saveButton_Clone", true);
								tab.enableButton("clearButton_Clone", true);
							}
						}




						else if (type == TYPE_PRERETIRE)
						{
							OWLNamedClass retireCls = (OWLNamedClass) droppedCls;

							if (wrapper == null)
							{
								wrapper = tab.getOWLWrapper();
							}

							if (isRetired(retireCls))
							{
								String text = retireCls.getBrowserText() + " has already been retired.";
								showMessage(text);
								//ModalDialog.showMessageDialog(null, text);
								return;
							}

							else if (canRetire(retireCls))
							{
								String text = retireCls.getBrowserText() + " has already been flagged for retirement.";
								showMessage(text);
								//ModalDialog.showMessageDialog(null, text);
								return;
							}


							inboundRoles = wrapper.getInverseRestrictionStrings(retireCls);
							//oldSubclasses = wrapper.getNamedSubclassNames(retireCls);

							Collection c  = wrapper.getNamedSubclasses(retireCls);
							for (Iterator it = c.iterator(); it.hasNext();) {
								Cls cls = (Cls) it.next();
								oldSubclasses.add(cls);
							}

							tab.setDroppedCls(droppedCls);

								tab.enableButton("unretireButton_Preretire", false);
								tab.enableButton("preretireButton_Preretire", true);
								tab.enableButton("saveButton_Preretire", false);
								tab.enableButton("clearButton_Preretire", true);

						}

						else if (type == TYPE_RETIRE)
						{
							OWLNamedClass retireCls = (OWLNamedClass) droppedCls;
							if (isRetired(retireCls))
							{
								String text = retireCls.getBrowserText()
								   + " has already been retired.";

                                showMessage(text);
								return;
							}

							else if (!canRetire(retireCls))
							{

								String text = retireCls.getBrowserText() + " has not been flagged for retirement.";

        JComponent c = ComponentFactory.createLabel(text);
        int result = ModalDialog.showDialog(null, c, "Message", ModalDialog.MODE_CLOSE);

								return;

							}
							tab.setDroppedCls(droppedCls);

                            tab.enableButton("unretireButton_Retire", true);
							tab.enableButton("retireButton_Retire", true);
							tab.enableButton("saveButton_Retire", false);
							tab.enableButton("clearButton_Retire", true);
						}

						else if (type == TYPE_DELETE)
						{
							OWLNamedClass retireCls = (OWLNamedClass) droppedCls;
							tab.setDroppedCls(droppedCls);
							tab.enableButton("deleteButton_Delete", false);
							tab.enableButton("clearButton_Delete", true);
						}

						createTree((Cls) droppedCls);

						// KLO 052406
						setCanDrop(false);

					}
				}
                e.acceptDrop(action);
            } catch (Exception ex) {
                Log.getLogger().warning(Log.toString(ex));
            }
        } else {
            e.rejectDrop();
            Log.getLogger().warning("unsupported flavor: " + e);
        }
        e.dropComplete(succeeded);
        clearDropSelection(tree);

        setupDrop();
		addPopup(edit_tree);

    }


    private void showMessage(String text)
    {
        JComponent c = ComponentFactory.createLabel(text);
        int result = ModalDialog.showDialog(null, c, "Message", ModalDialog.MODE_CLOSE);
	}

    private void clearDropSelection(JTree tree) {
        tree.putClientProperty(DefaultRenderer.DROP_TARGET, null);
        tree.putClientProperty(DefaultRenderer.DROP_TARGET_AREA, null);
	}

    public void setupDrop() {
        dt = new DropTarget(edit_tree, DnDConstants.ACTION_COPY_OR_MOVE, this);
    }

	public TreeNode addProperty(String name, String value, Cls cls)
	{
		TreeItem item = new TreeItem();
		item.setType(TreeItem.TYPE_PROPERTY);
		item.setName(name);
		item.setValue(value);
		item.setNameValue(name + ": " + value);

		if (name.compareTo(tab.getSlotName(tab.OLD_PARENT)) == 0 || name.compareTo(tab.getSlotName(tab.OLD_CHILD)) == 0)
		{
			if (cls == null)
			{
				System.out.println("WARNING TreePanel addProperty name: " + name);
				System.out.println("WARNING TreePanel addProperty value: " + value);
				System.out.println("WARNING TreePanel addProperty cls: null");
			}
		}


		if (cls != null)
		{
			item.setCls((RDFSClass) cls);
    	}

		if (name.compareTo("code") == 0) this.code = code;
     	if (root_node == null)
		{
			System.out.println("root is null");

		}
		return addObject(root_node, (Object) item, true);
	}


    public TreeNode addParent(Cls cls)
    {
		return addParent(cls, false);
	}

	public TreeNode addParent(Cls cls, boolean isDefining)
	{
		TreeItem item = new TreeItem();
		item.setType(TreeItem.TYPE_PARENT);
		item.setName(SUBCLASSOF);

		String value = wrapper.getInternalName(cls);
		item.setValue(value);
		item.setNameValue(SUBCLASSOF + ": " + value);
		if (isDefining)
		{
			item.setNameValue("owl:equivalentClass" + ": " + value);
		}

		item.setCls((RDFSClass) cls);
		item.setIsDefining(isDefining);

		if (root_node == null)
		{
			System.out.println("root is null");

		}

		return addObject(root_node, (Object) item, true);
	}


	public TreeNode addRestriction(RDFSClass aClass)
	{
		TreeItem item = new TreeItem();
		item.setType(TreeItem.TYPE_RESTRICTION);

		item.setCls(aClass);
		item.setNameValue(aClass.getBrowserText());

		return addObject(root_node, (Object) item, true);
	}

	public TreeNode addRestriction(RDFSClass aClass, boolean isDefining)
	{
		TreeItem item = new TreeItem();
		item.setType(TreeItem.TYPE_RESTRICTION);

		item.setCls(aClass);
		item.setNameValue(aClass.getBrowserText());

		item.setIsDefining(isDefining);

		return addObject(root_node, (Object) item, true);
	}





    private TreeItem[] vector2Array(Vector v)
    {
		TreeItem[] a = new TreeItem[v.size()];
		for (int i=0; i<a.length; i++)
		{
			TreeItem item = (TreeItem) v.elementAt(i);
			a[i] = item;
		}
		return a;
	}


    private String getTreeItemKey(TreeItem item)
    {
		int type = item.getType();
		if (item.getName().compareTo("rdfs:label") == 0 ||
		    item.getName().compareTo("code") == 0 ||
		    item.getName().compareTo("hasType") == 0)
		{
			type = 0;
		}

		String key = "" + type + item.toString();
		return key.toUpperCase();
	}


    private TreeItem[] sortTreeItems(TreeItem[] a)
    {
        boolean done = false;
        if (a == null || a.length == 0) {
            return a;
        }
        while (!done) {
            done = true;
            for (int i = 0;i < a.length-1;i++) {
			    TreeItem item1 = (TreeItem) a[i];
			    TreeItem item2 = (TreeItem) a[i+1];

				String key_1 = getTreeItemKey(item1);
				String key_2 = getTreeItemKey(item2);

                if (key_1.compareTo(key_2) <= 0) {
                } else {
                    done = false;
                    TreeItem tmp = a[i];
                    a[i] = a[i+1];
                    a[i+1] = tmp;
                }
            }
        }
        return a;
	}


    private int findNodePosition(TreeNode parent, TreeItem child)
    {
		if (parent.getChildCount() == 0)
		{
			return 0;
		}

        String key_1 = getTreeItemKey(child);

		Vector v = new Vector();
        Enumeration enumeration = parent.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			v.add(item);
		}
		//042506
		//v.add(child);
		TreeItem[] a = vector2Array(v);
		TreeItem[] b = sortTreeItems(a);

		for (int i=0; i<b.length; i++)
		{
			TreeItem item = (TreeItem) b[i];
			String key_2 = getTreeItemKey(item);

			//042506
			//if (key_2.compareTo(key_1) == 0)
			if (key_2.compareTo(key_1) > 0)
			{
				return i;
			}
		}
		return parent.getChildCount();
	}


	private TreeNode addObject(TreeNode parent,
							   Object child,
							   boolean shouldBeVisible) {


		if (parent == null)
		{
			System.out.println("WARNING addObject -- parent = null.");
		}

		//061306
		//TreeNode childNode = new TreeNode(child);
		TreeNode childNode = new TreeNode(child, ((TreeItem)child).getType());

		model.insertNodeInto(childNode,
							 parent,
							 //parent.getChildCount());
		                     findNodePosition(parent, (TreeItem) child));

		model.reload();

		if (shouldBeVisible) {
			edit_tree.scrollPathToVisible(new TreePath(childNode.getPath()));
		}
		return childNode;
	}





	private void removeObject(TreeNode node)
    {
		model.removeNodeFromParent(node);
		model.reload();
	}


    public boolean deleteProperty(String name, String value)
    {
		if (root_node == null)
		{
			System.out.println("WARNING unable to delete property " +
			name + " ( "  + value + " ) " + " -- root node is null.");
			return false;

		}
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getName().compareTo(name) == 0 &&
			    item.getValue().compareTo(value) == 0)
			{
				model.removeNodeFromParent(dmtn);
				model.reload();

				return true;
		    }
		}
		return false;
    }


    public boolean deleteProperty(String name, String value, Cls cls)
    {
		//TreeNode selectedNode = null;
		if (cls == null)
		{
			return deleteProperty(name, value);
		}

		if (root_node == null)
		{
			System.out.println("WARNING unable to delete property " +
			name + " ( "  + value + " ) " + " -- root node is null.");
			return false;

		}

		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getName().compareTo(name) == 0 &&
			    wrapper.getInternalName(item.getCls()).compareTo(wrapper.getInternalName(cls)) == 0)
			{
				model.removeNodeFromParent(dmtn);
				model.reload();

				return true;
		    }
		}

		return false;
    }




    public boolean deleteProperty(String name, Cls cls)
    {
		if (root_node == null)
		{
			System.out.println("WARNING deleteProperty unable to delete property ");
			return false;

		}

		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getName().compareTo(name) == 0 &&
			    wrapper.getInternalName(item.getCls()).compareTo(wrapper.getInternalName(cls)) == 0)
			{
				model.removeNodeFromParent(dmtn);
				model.reload();

				return true;
		    }
		}
		return false;
    }




    public boolean deleteProperties(String name)
    {
		//TreeNode selectedNode = null;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getName().compareTo(name) == 0 &&
			    item.getType() == TreeItem.TYPE_PROPERTY)
			{
				model.removeNodeFromParent(dmtn);
				model.reload();
		    }
		}
		return true;
    }




    public String getPropertyValue(String name)
    {
		if (root_node == null)
		{
			return null;
		}

		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_PROPERTY)
			{
				if (item.getName().compareTo(name) == 0)
				{
					return item.getValue();
				}
		    }
		}
		return null;
	}


    public boolean isSubclassOf(String value)
    {
		if (root_node == null)
		{
			System.out.println("WARNING: isSubclasOf root == null");
		}

		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_PARENT)
			{
				if (item.getValue().compareTo(value) == 0)
				{
					return true;
				}
		    }
		}
		return false;
	}


    public Vector getPropertyValues(String name)
    {
		if (root_node == null)
		{
			System.out.println("WARNING getPropertyValues root == null");
		}

        Vector v = new Vector();
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_PROPERTY)
			{
				if (item.getName().compareTo(name) == 0)
				{
					v.add(item.getValue());
				}
		    }
		}
		return v;
	}


    public Vector getPropertyObjectValues(String name)
    {
		if (root_node == null)
		{
			System.out.println("WARNING getPropertyValues root == null");
		}

        Vector v = new Vector();
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_PROPERTY)
			{
				if (item.getName().compareTo(name) == 0)
				{

					if (item.getCls() == null)
					{
						 if (name.compareTo(tab.getSlotName(tab.OLD_PARENT)) == 0 || name.compareTo(tab.getSlotName(tab.OLD_CHILD)) == 0)
						 {
							 item.setCls((RDFSClass) kb.getCls(item.getValue()));
						 }

                    }

 				    v.add(item.getCls());
				}
		    }
		}
		return v;
	}


    public boolean deleteProperty(String name)
    {
		//TreeNode selectedNode = null;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getName().compareTo(name) == 0)
			{
				model.removeNodeFromParent(dmtn);
				model.reload();
                return true;
		    }
		}

    	return false;
    }


    public boolean deleteParent(String value)
    {
		return deleteProperty(SUBCLASSOF, value);
	}


    public boolean deleteParent(Cls cls)
    {
		return deleteProperty(SUBCLASSOF, wrapper.getInternalName(cls), cls);
	}


    public boolean deleteRestriction(String name, String value, String modifier)
    {
		//TreeNode selectedNode = null;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_RESTRICTION)
			{
				if (item.getName().compareTo(name) == 0 &&
			        item.getValue().compareTo(value) == 0 &&
			        item.getModifier().compareTo(modifier) == 0)
				{
					model.removeNodeFromParent(dmtn);
					model.reload();
				}
		    }
		}
		return true;
    }



    public String getCode()
    {
		return code;
	}


    public String getName()
    {
		TreeNode node = getRootNode();
		if (node == null)
		{
			return null;
		}

		TreeItem item = (TreeItem) node.getUserObject();
		return item.getName();
	}

	public Vector getInboundRoles()
	{
		return inboundRoles;
	}

	public Vector getOldSubclasses()
	{
		return oldSubclasses;
	}

	class PopupTrigger extends MouseAdapter
	{
		public void mouseReleased(MouseEvent e)
		{
			if (e.isPopupTrigger())
			{
				int x = e.getX();
				int y = e.getY();
				TreePath path = edit_tree.getPathForLocation(x, y);
				if (path != null)
				{
					if (edit_tree.isExpanded(path))
					{
						m_action.putValue(Action.NAME, "Collapse");

					}
					else
					{
						m_action.putValue(Action.NAME, "Expand");

					}
					m_popup.show(edit_tree, x, y);
					m_clickedPath = path;
				}
			}
		}
	}


	public void setDroppedCls(OWLNamedClass cls)
	{
		droppedCls = cls;
	}

	public void enablePopUpWindow(boolean flag)
	{
		popUpWindowEnabled = flag;
	}


    private boolean diagnosis(Vector state_vec)
    {
		for (int i=0; i<state_vec.size(); i++)
		{
			TreeItem item = (TreeItem) state_vec.elementAt(i);
			if (item.getType() == TreeItem.TYPE_PARENT)
			{
			    if (item.getCls() == null)
			    {
					System.out.println("WARNING TreePanel diagnosis --- Parent node contain null cls. " + item.toString());
					return false;
				}
				else
				{
					System.out.println("TreePanel diagnosis  Parent: " + item.getCls().getBrowserText());
				}
			}
		}
		return true;
	}




	private boolean modifyRestriction(TreeItem item) //RDFSClass aClass, boolean defining)
	{
			OWLClass aClass_old = (OWLClass) item.getCls();//aClass;

			boolean defining = item.getIsDefining();

			if (aClass_old != null)
			{
				System.out.println("TreePanel modifyRestriction : " + aClass_old.getBrowserText());
			}

            boolean cancelBtnPressed = false;
            boolean dataEntryComplete = false;

			while (!cancelBtnPressed || !dataEntryComplete)
			{
			    final NCIRoleGroupEditorPanel rolegroupPanel = new NCIRoleGroupEditorPanel(tab, kb,
			       (OWLNamedClass) getDroppedCls(), aClass_old, defining);
                String label = "Roles (Simple Restrictions)";
				LabeledComponent lc = new LabeledComponent(label, rolegroupPanel);

				Action createRestrictionAction_1 =
						new AbstractAction("Create a Role (simple restriction)...",
								OWLIcons.getCreateIcon(OWLIcons.OWL_RESTRICTION)) {

					public void actionPerformed(ActionEvent e)
					{
						NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
							kb.getCls(OWLNames.Cls.SOME_VALUES_FROM_RESTRICTION),
							null, null, null);

						int ans = ModalDialog.showDialog(null, dlg, "Create a Role (simple restriction)", ModalDialog.MODE_OK_CANCEL);
						if (ans == ModalDialog.OPTION_OK)
						{
							OWLRestriction r = dlg.getResult();
							rolegroupPanel.getRoleGroupTableModel().addRow(r);
						}
					}
				};

				//lc.addHeaderSeparator();
				JButton hb_add_6 = lc.addHeaderButton(createRestrictionAction_1);
				//////////////////////////////////////////////////////////////////////////////////////////////////

			   final String modify_label = "Modify a Restriction";
				Action modifyRestrictionAction_1 =
						new AbstractAction("Modify a role (simple restriction)...",
								NCIOWLIcons.getImageIcon("edit")) {

					public void actionPerformed(ActionEvent e)
					{
						OWLRestriction r = null;
						boolean completed = false;


						int selIndex = rolegroupPanel.getRoleGroupTable().getSelectedRow();
						if (selIndex == -1) return;
                        r = rolegroupPanel.getRoleGroupTableModel().getRole(selIndex);

						RDFProperty p = r.getOnProperty();
						String prop_name = p.getName();

						String fillerText = r.getFillerText();
						String prop_modifier = wrapper.getRestrictionType(r);

						String label = wrapper.restrictionType2Label(prop_modifier);
						edu.stanford.smi.protege.model.Cls metaCls = wrapper.getMetaClsByName(label);

                        int group_number = rolegroupPanel.getRoleGroupTableModel().getRoleGroupNumber(selIndex);

						while (!completed)
						{
							NCICreateRolePanel dlg = new NCICreateRolePanel(rolegroupPanel, kb,
								metaCls,
								p, fillerText, null);


							int ans = ModalDialog.showDialog(null, dlg, modify_label, ModalDialog.MODE_OK_CANCEL);
							if (ans == ModalDialog.OPTION_OK)
							{
								r = dlg.getResult();
								if (r != null)
								{
									System.out.println(r.getBrowserText());
									//rolegroupPanel.getRoleGroupTableModel().addRow(r);

									rolegroupPanel.getRoleGroupTableModel().updateRestriction(r, selIndex);

									completed = true;
									break;
								}
								else
								{
									try {
										Object[] options = {"OK"};
										int ans2 = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
										JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
										null, options, options[0]);
										completed = false;
									}
									catch(Exception ex){
										Log.getLogger().log(Level.WARNING, "Exception caught", ex);
									}
								}
							}
							else
							{
								completed = true;
							}
						}
					}
				};

				lc.addHeaderSeparator();
				JButton hb_modify_6 = lc.addHeaderButton(modifyRestrictionAction_1);

//////////////////////////////////////////////////////////////////////////////////////////////////


				JButton hb_delete_6 = lc.addHeaderButton(new NCIDeleteRoleAction(rolegroupPanel, tab, rolegroupPanel.getRoleGroupTable()));

				int result = ModalDialog.showDialog(null, lc, "Edit a Restriction", ModalDialog.MODE_OK_CANCEL);

				if (result == ModalDialog.OPTION_OK)
				{
					RDFSClass restriction = rolegroupPanel.getRolegroups();
					if (restriction == null)
					{
						try {
							Object[] options = {"OK"};
							int ans = JOptionPane.showOptionDialog(tab, "Incomplete data entry.", "Confirmation",
							JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
							null, options, options[0]);
							dataEntryComplete = false;
						}
						catch(Exception ex){
							Log.getLogger().log(Level.WARNING, "Exception caught", ex);
						}
					}
					else
					{
						// Process data
						HashMap hmap = rolegroupPanel.getRoleGroupTableModel().getRolegroups();
						RDFSClass aClass = rolegroupPanel.roleGroupHash2RDFSClass(hmap);
						boolean isDefining = rolegroupPanel.getIsDefining();
						item.setCls(aClass);
						item.setNameValue(aClass.getBrowserText());
						item.setIsDefining(isDefining);

					    //model.modifyRow(selIndex, (RDFSClass) aClass, rolegroupPanel.getIsDefining());

						//enableSaveButton(true);
						return true;
					}
				}
				else
				{
					return false;
				}
			}
			return false;
	}


	private void getRoles(TreeNode dmtn, OWLNamedClass cls)
	{
		//NCIConditionsTableModel.SET_SUPERCLASS
		//NCIConditionsTableModel.SET_RESTRICTION
		int set_type = NCIConditionsTableModel.SET_SUPERCLASS;

		HashSet owlEquivClassSet = new HashSet();

        HashSet hset = new HashSet();
        Vector v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String internalName = wrapper.getInternalName(item.getCls());

			//String value = SUBCLASSOF + ": " + internalName;
			String value = "owl:equivalentClass: " + internalName;

            owlEquivClassSet.add(internalName);

			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_PARENT);

				item.setNameValue(value);
				item.setIsDefining(true);
                initialState.add(item);
			    item_vec.add(item);
			    hset.add(value);
			}
		}
        v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
 			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_RESTRICTION);

				item.setNameValue(value);
				item.setIsDefining(true);
                initialState.add(item);
			    item_vec.add(item);
			    hset.add(value);
			}
		}


        v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String internalName = wrapper.getInternalName(item.getCls());
			String value = SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());
			if (!hset.contains(value) && !owlEquivClassSet.contains(internalName))
			{
				//121406
				item.setType(TreeItem.TYPE_PARENT);

				item.setNameValue(value);
				item.setIsDefining(false);
                initialState.add(item);
			    item_vec.add(item);
			    hset.add(value);
			}
		}

        v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			TreeItem item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_RESTRICTION);

				item.setNameValue(value);
				item.setIsDefining(false);
                initialState.add(item);
			    item_vec.add(item);
			    hset.add(value);
			}
		}


	}

   public boolean deleteRestriction(RDFSClass r)
    {
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
			if (item.getType() == TreeItem.TYPE_RESTRICTION)
			{
				if (item.toString().compareTo(r.getBrowserText()) == 0)
				{
					model.removeNodeFromParent(dmtn);
					model.reload();
				}
		    }
		}
		return true;
    }


    private String[] getAllowableValues(RDFProperty property)
    {
		boolean rangeDefined = property.isRangeDefined();
		if (!rangeDefined) return null;
		boolean includingSuperproperties = false;
		Vector v = new Vector();
		Collection c = property.getRanges(includingSuperproperties);
		if (c == null) return null;
		for(Iterator iterator = c.iterator(); iterator.hasNext();){
			Object value = (Object) iterator.next();

			if (value instanceof DefaultRDFSDatatype)
			{
				return null;
			}
			else
			{
				Collection values = ((OWLDataRange) value).getOneOf().getValues();
				if (values == null) return null;
				if (values.size() > 0)
				{
					for(Iterator iterator2 = values.iterator(); iterator2.hasNext();){
						Object value2 = (Object) iterator2.next();
						v.add(value2.toString());
					}
				}
		    }
		}
		Object[] objs = v.toArray();
		String[] allowedvalues = new String[objs.length];

		for (int i=0; i<objs.length; i++)
		{
			allowedvalues[i] = (String) objs[i];
		}
		return allowedvalues;
	}


	public TreeNode addAssociation(Slot slot, Cls cls, String name, String value)
	{
		if (value.compareTo("owl:Class") == 0) return null;

		TreeItem item = new TreeItem();
		item.setType(TreeItem.TYPE_ASSOCIATION);
		item.setName(name);

		RDFProperty aProperty = (RDFProperty) slot;
		item.setProperty(aProperty);

		RDFSClass aClass = (RDFSClass) cls;
		item.setCls(aClass);

		item.setValue(value);
		item.setNameValue(name + ": " + value);

		return addObject(root_node, (Object) item, true);
	}


	private Vector createInitialState(Cls cls, TreeNode dmtn)
	{

		Vector init_vec = new Vector();
		TreeItem item = (TreeItem) dmtn.getUserObject();
		init_vec.add(item.cloneTreeItem());

		HashSet owlEquivClassSet = new HashSet();

		HashSet hset = getOWLAnnotationProperties();
		if (hset == null) return init_vec;
		Collection ownslots = cls.getOwnSlots();
		if (ownslots != null) {
			Iterator j = ownslots.iterator();
			while(j.hasNext()){
				Slot slot = (Slot)j.next();
				Collection slotColl = cls.getOwnSlotValues(slot);
				if(slotColl == null || slotColl.isEmpty())
					continue;

				String slotname = slot.getName();

				if (slotname.equals(Model.Slot.NAME)) {
					continue;
				}
				else if (slotname.equals(Model.Slot.DIRECT_SUBCLASSES))
					continue;
				else if (slotname.equals(Model.Slot.DIRECT_INSTANCES))
					continue;
				else {
					if (!hset.contains(slotname))
					{
						 if (slotname.compareTo(":DIRECT-SUPERCLASSES") != 0 &&
							 slotname.compareTo(":DIRECT-TYPE") != 0 &&
							 slotname.compareTo(":ROLE") != 0 &&
							 slotname.compareTo(SUBCLASSOF) != 0 &&
							 slotname.compareTo("owl:equivalentClass") != 0
							 )
						 {
							 if (slotColl != null)
							 {
								 Iterator i = slotColl.iterator();
								 while(i.hasNext()) {
									 Object obj = i.next();
									 item = new TreeItem();

									 if (obj instanceof OWLNamedClass)
									 {
										 OWLNamedClass owl_cls = (OWLNamedClass) obj;
										 String internalName = wrapper.getInternalName(owl_cls);

										 if (internalName.compareTo("owl:Class") != 0)
										 {
										     item.setType(TreeItem.TYPE_ASSOCIATION);
											 item.setName(slotname);
											 item.setValue(internalName);
											 item.setNameValue(slotname + ": " + internalName);

											 init_vec.add(item);
										 }
									 }
								 }
						     }
						 }
					}


					if (slotColl != null) {
						Iterator i = slotColl.iterator();
						while(i.hasNext()) {
							Object obj = i.next();
							if (hset.contains(slotname))
							{
								ValueType type = getObjectValueType(obj);

								String entry = convertObjecttoString(obj, type);

								String stringType = type.toString();

								try {
									item = new TreeItem();
									if (slotname.compareTo(SUBCLASSOF) == 0)
									{
										item.setType(TreeItem.TYPE_PARENT);
										item.setCls((RDFSClass) obj);
									}

									else if (associationNames.contains(slotname)
										|| isUserDefinedRDFProperty(slotname))
									{
										item.setType(TreeItem.TYPE_ASSOCIATION);
										item.setCls((RDFSClass) obj);
										String targetname = wrapper.getInternalName((OWLNamedClass) obj);
										item.setValue(targetname);
										item.setNameValue(slotname, targetname);
									}

									else
									{
										item.setType(TreeItem.TYPE_PROPERTY);
									}

									item.setName(slotname);

									if (slotname.compareToIgnoreCase(tab.getSlotName(NCIEditTab.CODE)) == 0)
									{
										if (code == null)
										{
											item.setValue(entry);
											item.setNameValue(slotname + ": " + entry);

											code = entry;
										}
										else
										{
											item.setValue(code);
											item.setNameValue(slotname + ": " + code);
										}
									}
									else if (item.getType() == TreeItem.TYPE_PROPERTY)
									{
										// properties
										item.setValue(obj);
										item.setLanguage(getStringLanguage(obj));
										item.setNameValue(slotname, obj);

									}

									init_vec.add(item);
									//item_vec.add(item);

								}
								catch(Exception e){
									Log.getLogger().log(Level.WARNING, "Exception caught", e);
								}

							}

						}
					}

				}
			}
		}


		int set_type = NCIConditionsTableModel.SET_SUPERCLASS;
        hset = new HashSet();
        Vector v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			item = (TreeItem) v.elementAt(i);
			//String value = SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());

            String internalName = wrapper.getInternalName(item.getCls());
			String value = "owl:equivalentClass: " + internalName;

            owlEquivClassSet.add(internalName);

			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_PARENT);

				item.setName("owl:equivalentClass");

				item.setNameValue(value);
				item.setIsDefining(true);
                init_vec.add(item);
			    //item_vec.add(item);
			    hset.add(value);
			}
		}

        v = wrapper.getDefinitionItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
 			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_RESTRICTION);

				item.setNameValue(value);
				item.setIsDefining(true);
                init_vec.add(item);
			    //item_vec.add(item);
			    hset.add(value);
			}
		}

        v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_SUPERCLASS);
        for (int i=0; i<v.size(); i++)
        {
			item = (TreeItem) v.elementAt(i);
			String internalName = wrapper.getInternalName(item.getCls());
			String value = SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());
			if (!hset.contains(value) && !owlEquivClassSet.contains(internalName))
			{
				//121406
				item.setType(TreeItem.TYPE_PARENT);

				item.setNameValue(value);
				item.setIsDefining(false);
                init_vec.add(item);
			    //item_vec.add(item);
			    hset.add(value);
			}
		}

        v = wrapper.getDirectSuperclassItems(cls, NCIConditionsTableModel.SET_RESTRICTION);
        for (int i=0; i<v.size(); i++)
        {
			item = (TreeItem) v.elementAt(i);
			String value = item.getCls().getBrowserText();
			if (!hset.contains(value))
			{
				//121406
				item.setType(TreeItem.TYPE_RESTRICTION);

				item.setNameValue(value);
				item.setIsDefining(false);
                init_vec.add(item);
			    //item_vec.add(item);
			    hset.add(value);
			}
		}

		return init_vec;

	}


    public int removeEquivalentSuperclasses()
    {
		if (root_node == null)
		{
			System.out.println("WARNING: removeEquivalentSuperclasses  root_node == null");
			root_node = getRootNode();
		}

		int n = 0;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
            if (item.getType() == TreeItem.TYPE_PARENT && item.getIsDefining())
			//if (item.getName().compareTo("owl:equivalentClass") == 0)
			{
				String value = SUBCLASSOF + ": " + wrapper.getInternalName(item.getCls());
				item.setNameValue(value);
				//model.removeNodeFromParent(dmtn);
				//model.reload();
				item.setName(SUBCLASSOF);
				item.setIsDefining(false);
				n++;
		    }
		}
		return n;
    }


    public Vector getEquivalentSuperclasses()
    {
        Vector v = new Vector();
		int n = 0;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
            if (item.getType() == TreeItem.TYPE_PARENT && item.getIsDefining())
			{
				v.add(item.getCls());
		    }
		}
		return v;
    }


    private int getSuperclassCount()
    {
		int n = 0;
		Enumeration enumeration = root_node.children();
		while (enumeration.hasMoreElements())
		{
			TreeNode dmtn = (TreeNode) enumeration.nextElement();
			TreeItem item = (TreeItem) dmtn.getUserObject();
            if (item.getType() == TreeItem.TYPE_PARENT)
			{
			    n++;
		    }
		}
		return n;
    }
}
