package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class AddAssociationDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextField tf, fillerText;
	String separator;

	String asso_name;
	String asso_value;

	JButton selButton;
	JButton fillerButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	JList kindList;
	JList assoList;

	QuickSortVecStrings sort = null;

	public boolean cancelBtnPressed;


    public AddAssociationDialog(NCIEditTab tab, KnowledgeBase kb)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add Object-Valued Annotation Property", true);
		this.kb = kb;
		this.owlModel = (OWLModel) kb;
		this.tab = tab;

	 	asso_name = "";
	 	asso_value = "";
	 	cancelBtnPressed = false;
	 	this.sort = new QuickSortVecStrings();

	}

    public String getProperty()
    {
		return asso_name;
	}

    public String getFiller()
    {
		//return asso_value;
		return fillerText.getText();
	}

    private Vector getPropertiesList() {
		Vector v = new Vector();
		try {

			if (owlModel == null)
			{
				System.out.println("WARNING: owlModel == null");
				return v;
			}

			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			Collection selectableProperties = new ArrayList();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (property.isAnnotationProperty()
				    && property.hasObjectRange()
				    && property instanceof DefaultOWLObjectProperty) {
					selectableProperties.add(property);
				    v.add(property.getBrowserText());
				}
			}

            v.add(owlModel.getOWLDifferentFromProperty().getBrowserText());
            v.add(owlModel.getOWLDisjointWithProperty().getBrowserText());
            v.add(owlModel.getOWLEquivalentPropertyProperty().getBrowserText());
            v.add(owlModel.getOWLSameAsProperty().getBrowserText());
            v.add(owlModel.getRDFSIsDefinedByProperty().getBrowserText());

            RDFProperty seeAlsoSlot = owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO);
            v.add(seeAlsoSlot.getBrowserText());

            sort.sort(v);


	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}

        return v;
    }

	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new GridBagLayout());

        assoList = new JList(getPropertiesList());
        //kindList.setCellRenderer(new RestrictionKindRenderer());
        assoList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        //kindList.setSelectedValue(metaCls, true);
        JScrollPane assoScrollPane = new JScrollPane(assoList);
        //assoScrollPane.setPreferredSize(new Dimension(160, 150));
        assoScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel assoPanel = new JPanel();
        assoPanel.setLayout(new BorderLayout());
        assoPanel.add(BorderLayout.NORTH, new LabeledComponent("Select Property", assoScrollPane));
        assoPanel.add(BorderLayout.CENTER, new JPanel());
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(assoPanel, gridbagconstraints1);

		fillerButton = new JButton("Filler");
		fillerButton.addActionListener(this);
		fillerText = new JTextField("");

		fillerText.setEditable(false);


		//fillerText.setPreferredSize(new Dimension (160, 20));
		fillerText.setPreferredSize(new Dimension (300, 20));
        JPanel middlePanel = new JPanel();
		middlePanel.add(fillerButton, BorderLayout.WEST);
		middlePanel.add(fillerText, BorderLayout.EAST);
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 2;
		contain.add(middlePanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints2 = new GridBagConstraints();
		gridbagconstraints2.gridx = 0;
		gridbagconstraints2.gridy = 3;
		contain.add(buttonPanel, gridbagconstraints2);

		pack();
		this.setVisible(true);
   	}


    private Vector getBrowserText(edu.stanford.smi.protege.model.Cls[] clses)
    {
		Vector v = new Vector();
		for (int i=0; i<clses.length; i++)
		{
            Cls cls = clses[i];
            v.add(cls.getBrowserText());
 		}
		return v;
	}



	public void actionPerformed(ActionEvent event)
	{
		asso_name = "";
		asso_value = "";
		Object action = event.getSource();
		if (action == okButton){
			asso_name = (String) assoList.getSelectedValue();
			asso_value = fillerText.getText();

			dispose();

		} else if (action == fillerButton)	{
			asso_name = (String) assoList.getSelectedValue();
			Collection clses = kb.getRootClses();
			Cls cls = DisplayUtilities.pickConcreteCls(fillerButton, kb, clses);
			if (cls == null)
			{
				System.out.println("cls == null");
			}
			else
			{

System.out.println("AddAssociationDialog : " + 	tab.getOWLWrapper().getInternalName(cls));
				//fillerText.setText(cls.getBrowserText());
				fillerText.setText(tab.getOWLWrapper().getInternalName(cls));
				asso_value = fillerText.getText();

			}

		} else if (action == cancelButton) {
			cancelBtnPressed = true;
			dispose();
		}
	}

}

/*
   public void testRange() {
        OWLObjectProperty property = owlModel.createOWLObjectProperty("property");
        assertFalse(property.hasDatatypeRange());
        assertTrue(property.hasObjectRange());
    }
    public void testDeleteRestriction() {
        OWLNamedClass cls = owlModel.createOWLNamedClass("Person");
        OWLObjectProperty children = owlModel.createOWLObjectProperty("children");
        int clsCount = owlModel.getClsCount();
        OWLRestriction restriction = owlModel.createOWLMaxCardinality(children, 7);
        cls.addSuperclass(restriction);
        children.delete();
        assertEquals(clsCount, owlModel.getClsCount());
    }
assertNull(property.getRange());

DefaultOWLObjectProperty
    public boolean hasObjectRange() {
        return true;
    }
*/

