package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class AddRoleDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextField tf, fillerText;
	String separator;

	String role_name;
	String role_value;
	String role_modifier;


	JButton selButton;
	JButton fillerButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	JList restrictionList;
	JList roleList;


    public AddRoleDialog(NCIEditTab tab, KnowledgeBase kb)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add Restriction", true);
		this.kb = kb;
		this.owlModel = (OWLModel) kb;
		this.tab = tab;

	 	role_name = "";
	 	role_value = "";
	 	role_modifier = "";

	}

    public String getRestriction()
    {
		return role_name;
	}

    public String getFiller()
    {
		return role_value;
	}

    public String getModifier()
    {
		return role_modifier;
	}


    private Vector getPropertiesList() {
		Vector v = new Vector();
		try {

			if (owlModel == null)
			{
				System.out.println("WARNING: owlModel == null");
				return v;
			}

			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			Collection selectableProperties = new ArrayList();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (!property.isAnnotationProperty()) {
					selectableProperties.add(property);
				   //v.add(property.getBrowserText());
				   v.add(property.getName());
				}
			}
	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}

        return v;
    }

	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new GridBagLayout());

        roleList = new JList(getPropertiesList());
        //restrictionList.setCellRenderer(new RestrictionKindRenderer());
        roleList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

        //restrictionList.setSelectedValue(metaCls, true);
        JScrollPane roleScrollPane = new JScrollPane(roleList);
        //roleScrollPane.setPreferredSize(new Dimension(160, 150));
        roleScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel rolePanel = new JPanel();
        rolePanel.setLayout(new BorderLayout());
        rolePanel.add(BorderLayout.NORTH, new LabeledComponent("Select Restriction", roleScrollPane));
        rolePanel.add(BorderLayout.CENTER, new JPanel());
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(rolePanel, gridbagconstraints1);

        edu.stanford.smi.protege.model.Cls[] metaClses = ProfilesManager.getSupportedRestrictionMetaClses((OWLModel) kb);
        //JList restrictionList = new JList(metaClses);

        restrictionList = new JList(getBrowserText(metaClses));

        //restrictionList.setCellRenderer(new RestrictionKindRenderer());
        restrictionList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);


        //restrictionList.setSelectedValue(metaCls, true);
        JScrollPane kindScrollPane = new JScrollPane(restrictionList);
        //kindScrollPane.setPreferredSize(new Dimension(160, 150));
        kindScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel restrictionPanel = new JPanel();
        restrictionPanel.setLayout(new BorderLayout());
        restrictionPanel.add(BorderLayout.NORTH, new LabeledComponent("Restriction", kindScrollPane));
        restrictionPanel.add(BorderLayout.CENTER, new JPanel());
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(restrictionPanel, gridbagconstraints1);

		fillerButton = new JButton("Filler");
		fillerButton.addActionListener(this);
		fillerText = new JTextField("");
		//fillerText.setPreferredSize(new Dimension (160, 20));
		fillerText.setPreferredSize(new Dimension (300, 20));
        JPanel middlePanel = new JPanel();
		middlePanel.add(fillerButton, BorderLayout.WEST);
		middlePanel.add(fillerText, BorderLayout.EAST);
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 2;
		contain.add(middlePanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints2 = new GridBagConstraints();
		gridbagconstraints2.gridx = 0;
		gridbagconstraints2.gridy = 3;
		contain.add(buttonPanel, gridbagconstraints2);


        restrictionList.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                //notifySelectionListeners();
                //updateAddAction();
                 fillerButton.setEnabled(true);
                 fillerText.setEditable(false);
                 String selected = (String) restrictionList.getSelectedValue();
                 if (selected.indexOf("Cardinality") != -1)
                 {
					 fillerText.setEditable(true);
                     fillerButton.setEnabled(false);
				 }
            }
        });

		pack();
		setLocation(350, 200);
		this.setVisible(true);
   	}


    private Vector getBrowserText(edu.stanford.smi.protege.model.Cls[] clses)
    {
		Vector v = new Vector();
		for (int i=0; i<clses.length; i++)
		{
            Cls cls = clses[i];
            //v.add(cls.getBrowserText());
            v.add(tab.getOWLWrapper().getInternalName(cls));
		}
		return v;
	}



	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			role_name = (String) roleList.getSelectedValue();
			role_modifier = (String) restrictionList.getSelectedValue();

			role_modifier = tab.getOWLWrapper().getRestrictionType(role_modifier);

			role_value = fillerText.getText();

			dispose();

		} else if (action == fillerButton)	{
			Collection clses = kb.getRootClses();
			Cls selectedCls = DisplayUtilities.pickConcreteCls(fillerButton, kb, clses);

			if (selectedCls == null)
			{
				System.out.println("cls == null");
			}
			else
			{
				//010407
				Object[] option_array = {"OK"};
				Object[] options = {"Yes", "No"};

				boolean invaldSelection = tab.getOWLWrapper().isPremerged((OWLNamedClass) selectedCls);
				if (invaldSelection)
				{
					int ans = JOptionPane.showOptionDialog(tab, "Cannot select a pre-merged concept.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, option_array, options[0]);
					return;
				}
				invaldSelection = tab.getOWLWrapper().isPreretired((OWLNamedClass) selectedCls);
				if (invaldSelection)
				{
					int ans = JOptionPane.showOptionDialog(tab, "Cannot select a pre-retired concept.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, option_array, options[0]);
					return;
				}
				invaldSelection = tab.getOWLWrapper().isRetired((OWLNamedClass) selectedCls);
				if (invaldSelection)
				{
					int ans = JOptionPane.showOptionDialog(tab, "Cannot select a retired concept.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, option_array, options[0]);
					return;
				}
				fillerText.setText(tab.getOWLWrapper().getInternalName(selectedCls));
			}

		} else if (action == cancelButton)
			dispose();
	}

}



