package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.icons.*;

import edu.stanford.smi.protegex.owl.ui.components.triples.AddResourceAction;

import edu.stanford.smi.protegex.owl.ui.components.triples.*;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;

import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.*;

import edu.stanford.smi.protege.util.ModalDialog;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class CreateObjPropertyDialog extends JDialog //implements ActionListener
{
	JButton okButton, cancelButton;
	JTextField tf, fillerText;
	String separator;
	Cls selectedCls = null;

	String property_name;
	String property_value;

	JButton selButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	public boolean cancelBtnPressed;

	Slot selected_slot;

	JTextField name_field;
	JTextField value_field;

    public CreateObjPropertyDialog(NCIEditTab tab, String title, String name, String value)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add an Object-Valued Property", true);
		this.property_name = name;
		this.property_value = value;

        if (name == null)
        {
			this.property_name = "";
		}
        if (value == null)
        {
			this.property_value = "";
		}
		this.tab = tab;
		this.kb = tab.getOWLModel();
		this.owlModel = (OWLModel) kb;

	 	cancelBtnPressed = false;

	 	JPanel panel = createPanel();
		int r = ProtegeUI.getModalDialogFactory().showDialog(tab, panel, title, ModalDialogFactory.MODE_OK_CANCEL);

		if (r == ModalDialogFactory.OPTION_OK) {
			property_name = name_field.getText();
			property_value = value_field.getText();

			property_name.trim();
			property_value.trim();

			if (property_name.compareTo("") == 0 ||
				property_value.compareTo("") == 0)
			{
				try {
					Object[] options = {"OK"};

					int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					cancelBtnPressed = true;
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}
			else
			{
				property_name = name_field.getText();
				property_value = value_field.getText();
			}
		}
		else
		{
			cancelBtnPressed = true;
		}
	}


    public CreateObjPropertyDialog(NCIEditTab tab)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Add a Object-Valued Property", true);
		this.tab = tab;
		this.kb = tab.getOWLModel();
		this.owlModel = (OWLModel) kb;

	 	cancelBtnPressed = false;

	 	JPanel panel = createPanel();
		String title = "Add a Object-Valued Property";
		int r = ProtegeUI.getModalDialogFactory().showDialog(tab, panel, title, ModalDialogFactory.MODE_OK_CANCEL);

		if (r == ModalDialogFactory.OPTION_OK) {
			property_name = name_field.getText();
			property_value = value_field.getText();

			property_name.trim();
			property_value.trim();

			if (property_name.compareTo("") == 0 ||
				property_value.compareTo("") == 0)
			{
				try {
					Object[] options = {"OK"};

					int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					cancelBtnPressed = true;
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}
			else
			{
				property_name = name_field.getText();
				property_value = value_field.getText();
			}
		}
		else
		{
			cancelBtnPressed = true;
		}
	}


    public String getPropertyName()
    {
		return property_name;
	}

    public String getPropertyValue()
    {
		return property_value;
	}

    public boolean isCancelled()
    {
		return cancelBtnPressed;
	}

    private Collection getExcludedProperties() {
		Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
		Collection properties = new ArrayList();
		for (Iterator it = allProperties.iterator(); it.hasNext();) {
			RDFProperty property = (RDFProperty) it.next();
			if (!property.isAnnotationProperty()) {
				properties.add(property);
			}
		}
		return properties;
    }

    private Collection getSelectableResources() {
        Collection properties = new ArrayList();
        Collection allowedProperties = owlModel.getRDFProperties();
        Collection disallowedProperties = getExcludedProperties();
        for (Iterator it = allowedProperties.iterator(); it.hasNext();) {
            RDFProperty property = (RDFProperty) it.next();
            if (property.isVisible() && property.hasObjectRange() && !property.isSystem()
                && !disallowedProperties.contains(property)) {
                properties.add(property);
            }
        }
        properties.add(owlModel.getOWLDisjointWithProperty());
        properties.add(owlModel.getOWLDifferentFromProperty());
        properties.add(owlModel.getOWLEquivalentPropertyProperty());
        properties.add(owlModel.getOWLSameAsProperty());
        properties.add(owlModel.getRDFProperty(RDFSNames.Slot.IS_DEFINED_BY));
        properties.add(owlModel.getRDFProperty(RDFSNames.Slot.SEE_ALSO));
        return properties;
    }


	public JPanel createPanel()
	{
		JPanel panel = new JPanel();
		panel.setLocation(450,300);
		panel.setLayout(new GridLayout(2, 1));

        LabeledComponent lc = null;

		name_field = new JTextField(property_name);
		name_field.setText(property_name);
		name_field.setEditable(false);
		name_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Select a property", name_field);

		Action SelectPropertyAction =
			new AbstractAction("Select a property ...", OWLIcons.getCreatePropertyIcon(OWLIcons.OWL_OBJECT_ANNOTATION_PROPERTY)) {

				public void actionPerformed(ActionEvent e)
				{
					java.awt.TextField textfield = new TextField();
					String label = "Select a property.";

					Collection allowedSlots = getSelectableResources();
					Slot slot = DisplayUtilities.pickSlot(textfield, allowedSlots, "Select a property");

					if (slot == null)
					{
						System.out.println("slot is null");
					}
					else
					{
						//name_field.setText(slot.getBrowserText());
						name_field.setText(slot.getName());
						selected_slot = slot;
					}

				}

			};


	    lc.addHeaderButton(SelectPropertyAction);
		panel.add(lc);


		value_field = new JTextField(property_value);
		value_field.setText(property_value);
		value_field.setEditable(false);
		value_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Select a property value", value_field);

		Action SelectPropertyValueAction =
			new AbstractAction("Select a property value...", OWLIcons.getAddIcon("PrimitiveClass")) {

				public void actionPerformed(ActionEvent e)
				{
					java.awt.TextField textfield = new TextField();
					String label = "Select a property value";

					Collection clses = kb.getRootClses();
					/*
					Cls cls = DisplayUtilities.pickConcreteCls(textfield, kb, clses);
					if (cls == null)
					{
						System.out.println("cls is null");
					}
					else
					{
						selectedCls = cls;
						String cls_name = tab.getOWLWrapper().getInternalName(cls);
						//if (cls.getBrowserText() == null)
						if (cls_name == null)
						{
							 ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Invalid selection -- property value is missing.");
							 return;
						}
						//value_field.setText(cls.getBrowserText());
						value_field.setText(cls_name);
					}
					*/


					final NCISelectClsesPanel p = new NCISelectClsesPanel((OWLModel) kb, clses);
					int result = ModalDialog.showDialog(textfield, p, label, ModalDialog.MODE_OK_CANCEL);
					if (result == ModalDialogFactory.OPTION_OK)
					{
						Collection c = p.getSelection();
						if (c != null && c.size() > 0)
						{
							Iterator it = c.iterator();
							Object obj = it.next();
							selectedCls = (Cls) obj;
							String cls_name = tab.getOWLWrapper().getInternalName(selectedCls);
							//if (cls.getBrowserText() == null)
							if (cls_name == null)
							{
								 ProtegeUI.getModalDialogFactory().showErrorMessageDialog(tab, "Invalid selection -- property value is missing.");
								 return;
							}
							//value_field.setText(cls.getBrowserText());
							value_field.setText(cls_name);
						}
					}

				}

			};

	    lc.addHeaderButton(SelectPropertyValueAction);
		panel.add(lc);
		return panel;
   	}

   	public Slot getSelectedSlot()
   	{
		return selected_slot;
	}

   	public Cls getSelectedCls()
   	{
		return selectedCls;
	}
}

