package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.icons.*;

import edu.stanford.smi.protegex.owl.ui.components.triples.AddResourceAction;

import edu.stanford.smi.protegex.owl.ui.components.triples.*;
import edu.stanford.smi.protege.util.ComponentFactory;
import edu.stanford.smi.protegex.owl.model.impl.DefaultRDFSDatatype;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


public class CreatePropertyDialog extends JDialog //implements ActionListener
{
	JButton okButton, cancelButton;
	//JTextField tf, fillerText;
	String separator;

	String property_name;
	String property_value;

	JButton selButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	public boolean cancelBtnPressed;

	JTextField name_field;
	JTextArea value_field;

    public CreatePropertyDialog(NCIEditTab tab, String propertyname, String propertyvalue)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Create a Property", true);
		this.tab = tab;
		this.kb = tab.getOWLModel();
		this.owlModel = (OWLModel) kb;

	 	//this.property_name = "";
	 	//this.property_value = "";

	 	this.property_name = propertyname;
	 	this.property_value = propertyvalue;



	 	cancelBtnPressed = false;

	 	JPanel panel = createPanel(propertyname, propertyvalue);

	 	String title = "Create a Property";
	 	if (propertyname.compareTo("") != 0)
	 	{
			title = "Modify a Property";
	    }
		int r = ProtegeUI.getModalDialogFactory().showDialog(tab, panel, title, ModalDialogFactory.MODE_OK_CANCEL);

		if (r == ModalDialogFactory.OPTION_OK) {
			property_name = name_field.getText();
			property_value = value_field.getText();

			property_name.trim();
			property_value.trim();

			if (property_name.compareTo("") == 0 ||
				property_value.compareTo("") == 0)
			{
				try {
					Object[] options = {"OK"};

					int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					cancelBtnPressed = true;
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);
				}
			}
			else
			{

				if (tab.isReadOnlyProperty(property_name))
				{
					Component warning_label = new JLabel(property_name + " is a read-only property.");
					LabeledComponent lc2 = new LabeledComponent("", warning_label);
					int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);

					return;
				}

				property_name = name_field.getText();
				property_value = value_field.getText();
			}
		}
		else
		{
			cancelBtnPressed = true;
		}
	}

    public String getPropertyName()
    {
		return property_name;
	}

    public String getPropertyValue()
    {
		return property_value;
	}

    public boolean isCancelled()
    {
		return cancelBtnPressed;
	}


    private Collection getExcludedProperties() {
		Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
		Collection properties = new ArrayList();
		for (Iterator it = allProperties.iterator(); it.hasNext();) {
			RDFProperty property = (RDFProperty) it.next();
			if (!property.isAnnotationProperty()) {
				properties.add(property);
			}
		}
		return properties;
    }

    private Collection getSelectableResources() {
        Collection properties = owlModel.getRDFProperties();
        return properties;
    }


	public JPanel createPanel()
	{
		return createPanel("", "");
	}



	public JPanel createPanel(String name, String value)
	{
		JPanel panel = new JPanel();
		panel.setLocation(450,300);
		//panel.setLayout(new GridLayout(2, 1));
		panel.setLayout(new BorderLayout());

        LabeledComponent lc = null;

		name_field = new JTextField(name);
		name_field.setEditable(false);
		name_field.setPreferredSize(new Dimension (300, 20));

		lc = new LabeledComponent("Select a property", name_field);

		value_field = new JTextArea(value);
		value_field.setEditable(true);
		value_field.setLineWrap(true);
		value_field.setWrapStyleWord(true);
		value_field.setEnabled(false);



		//final JButton propertyValueBtn = null;

		Action SelectPropertyAction =
			new AbstractAction("Select a property ...", OWLIcons.getCreatePropertyIcon(OWLIcons.OWL_OBJECT_ANNOTATION_PROPERTY)) {

				public void actionPerformed(ActionEvent e)
				{
					java.awt.TextField textfield = new TextField();
					String label = "Select a property.";

					Collection allowedSlots = getSelectableResources();
					Slot slot = DisplayUtilities.pickSlot(textfield, allowedSlots, "Select a property");
					if (slot == null)
					{
						System.out.println("slot is null");
					}
					else
					{
						value_field.setEnabled(true);
						//String selected_prop_name = slot.getBrowserText();
						String selected_prop_name = slot.getName();
						name_field.setText(selected_prop_name);
						value_field.setText("");

						if (selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.DEFINITION)) == 0 ||
							selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) == 0 ||
							selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.ALT_DEFINITION)) == 0 ||
							selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) == 0 ||
							selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) == 0 ||
							selected_prop_name.compareTo(tab.getSlotName(NCIEditTab.FULL_SYN)) == 0)
						{
							//propertyValueBtn.setEnabled(true);
							value_field.setEditable(false);
						}
						else
						{
							Slot selectedslot = owlModel.getSlot(selected_prop_name);
							RDFProperty property = (RDFProperty) selectedslot;
							String[] allowedvalues = getAllowableValues(property);
							if (allowedvalues != null)
							{
								//propertyValueBtn.setEnabled(true);
                                value_field.setEditable(false);
							}
							else
							{
								//propertyValueBtn.setEnabled(false);
								value_field.setEditable(true);
							}
						}
					}
				}

			};


	    lc.addHeaderButton(SelectPropertyAction);
		panel.add(lc, BorderLayout.NORTH);


		JScrollPane comp = new JScrollPane(value_field);

		LabeledComponent lc2 = new LabeledComponent("Enter a property value", comp);
		lc2.setPreferredSize(new Dimension(400, 120));

		Action SelectPropertyValueAction =
			new AbstractAction("Specify a property value...", OWLIcons.getCreateIcon(OWLIcons.ANNOTATION)) {

				public void actionPerformed(ActionEvent e)
				{
					String prop_name = name_field.getText();

					if (tab.isReadOnlyProperty(prop_name))
					{
						Component warning_label = new JLabel(prop_name + " is a read-only property.");
						LabeledComponent lc2 = new LabeledComponent("", warning_label);
						int k = ProtegeUI.getModalDialogFactory().showDialog(tab, lc2, "WARNING", ModalDialogFactory.MODE_CLOSE);
						name_field.setText("");
						value_field.setText("");
						value_field.setEnabled(false);
						return;
					}

                    value_field.setEnabled(true);
					Slot slot = owlModel.getSlot(prop_name);
					RDFProperty property = (RDFProperty) slot;
					String[] allowedvalues = getAllowableValues(property);
					if (allowedvalues != null)
					{
						value_field.setEditable(false);
						JList valueList;
						valueList = ComponentFactory.createList(null);
						valueList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						Arrays.sort(allowedvalues);
						java.util.List list = Arrays.asList(allowedvalues);
						valueList.setListData(list.toArray());
						valueList.setSelectedIndex(0);
						JScrollPane comp = new JScrollPane(valueList);

						String label = property.getBrowserText();
						LabeledComponent lc = new LabeledComponent(label, comp);

						lc.setPreferredSize(new Dimension(400, 120));
						int r = ProtegeUI.getModalDialogFactory().showDialog(tab, lc, "Add Annotation", ModalDialogFactory.MODE_OK_CANCEL);
						if (r == ModalDialogFactory.OPTION_OK) {

							String prop_value = (String) valueList.getSelectedValue();
							value_field.setText(prop_value);
						}
					}

					else
					{


						if (
							prop_name.equals(tab.getSlotName(NCIEditTab.DEFINITION)) ||
							prop_name.equals(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) ||
							prop_name.equals(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) ||
							prop_name.equals(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) ||
							prop_name.equals(tab.getSlotName(NCIEditTab.ALT_DEFINITION))) {

							CustomizedAnnotationDialog dialog
								= new CustomizedAnnotationDialog(tab.getEditPanel(), prop_name, "", -1, new NCIAnnotationsTableModel(owlModel));


							if (!dialog.cancelBtnPressed)
							{
								value_field.setText(dialog.getValue());
							}
						}

						else if (prop_name.equals(tab.getSlotName(NCIEditTab.FULL_SYN)))
						{

						//if (prop_name.equals(tab.getSlotName(NCIEditTab.FULL_SYN)) || prop_name.equals(tab.getSlotName(NCIEditTab.DEFINITION))){

							CustomizedAnnotationDialog dialog =
								new CustomizedAnnotationDialog(tab.getEditPanel(), prop_name, "", -1, new NCIFULLSYNTableModel(tab.getEditPanel(), owlModel));

							if (!dialog.cancelBtnPressed)
							{
								value_field.setText(dialog.getValue());
							}


						}
				/* 121906

						if (prop_name.compareTo(tab.getSlotName(NCIEditTab.DEFINITION)) == 0 ||
							prop_name.compareTo(tab.getSlotName(NCIEditTab.GO_ANNOTATION)) == 0 ||
							prop_name.compareTo(tab.getSlotName(NCIEditTab.ALT_DEFINITION)) == 0 ||
							prop_name.compareTo(tab.getSlotName(NCIEditTab.LONG_DEFINITION)) == 0 ||
							prop_name.compareTo(tab.getSlotName(NCIEditTab.ALT_LONG_DEFINITION)) == 0 ||
							prop_name.compareTo(tab.getSlotName(NCIEditTab.FULL_SYN)) == 0) {

							value_field.setEditable(false);
							CustomizedAnnotationDialog dialog =
								new CustomizedAnnotationDialog(tab.getEditPanel(), prop_name, "", -1, new NCIAnnotationsTableModel(owlModel));

							if (!dialog.cancelBtnPressed)
							{
								value_field.setText(dialog.getValue());
							}

						}
			    */
						    else {

							value_field.setEditable(true);
                            JTextArea textArea = new JTextArea("");

							textArea.setLineWrap(true);
							textArea.setWrapStyleWord(true);

							Component comp = new JScrollPane(textArea);
							LabeledComponent lc3 = new LabeledComponent(prop_name, comp);

							lc3.setPreferredSize(new Dimension(400, 120));
							int r = ProtegeUI.getModalDialogFactory().showDialog(tab.getEditPanel(), lc3, "Edit Annotation", ModalDialogFactory.MODE_OK_CANCEL);
							if (r == ModalDialogFactory.OPTION_OK) {
								String newValue = textArea.getText();

								if (newValue.compareTo("") == 0)
								{
									Component warning_label = new JLabel("Property value is mandatory.");
									LabeledComponent lc4 = new LabeledComponent("", warning_label);
									int k = ProtegeUI.getModalDialogFactory().showDialog(tab.getEditPanel(), lc4, "WARNING", ModalDialogFactory.MODE_CLOSE);
								}
								else
								{
									value_field.setText(newValue);
								}
							}
						}
				    }
				}
			};


		lc2.addHeaderButton(SelectPropertyValueAction);
		panel.add(lc2, BorderLayout.CENTER);

		return panel;
   	}

    private String[] getAllowableValues(RDFProperty property)
    {
		if (property == null) return null;
		boolean rangeDefined = property.isRangeDefined();
		if (!rangeDefined) return null;
		boolean includingSuperproperties = false;
		Vector v = new Vector();
		Collection c = property.getRanges(includingSuperproperties);
		if (c == null) return null;
		for(Iterator iterator = c.iterator(); iterator.hasNext();){
			Object value = (Object) iterator.next();

			if (value instanceof DefaultRDFSDatatype)
			{
				return null;
			}
			else
			{
				Collection values = ((OWLDataRange) value).getOneOf().getValues();
				if (values == null) return null;
				if (values.size() > 0)
				{
					for(Iterator iterator2 = values.iterator(); iterator2.hasNext();){
						Object value2 = (Object) iterator2.next();
						v.add(value2.toString());
					}
				}
		    }
		}
		Object[] objs = v.toArray();
		String[] allowedvalues = new String[objs.length];

		for (int i=0; i<objs.length; i++)
		{
			allowedvalues[i] = (String) objs[i];
		}
		return allowedvalues;
	}
}

