package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.icons.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.ModalDialog;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class CreateSubclassDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JTextField tf, fillerText;
	String separator;

	String concept_name;
	String preferred_name;
	String superconcept_name;
	String definition;

	JButton selButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	public boolean cancelBtnPressed;
	boolean incomplete_data_entry;

	JTextField name_field;
	JTextField pt_field;
	JTextArea def_area;
	JTextField superconcept_field;

	Cls selected_superclass = null;

	boolean hasName = true;


    public CreateSubclassDialog(NCIEditTab tab)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Create Subclass", true);
		this.tab = tab;
		this.kb = tab.getOWLModel();
		this.owlModel = (OWLModel) kb;

	 	this.concept_name = "";
	 	this.preferred_name = "";
	 	this.superconcept_name = "";
	 	this.definition = "";
	 	this.selected_superclass = null;

	 	JPanel panel = null;//createPanel();
		String title = "Create Subclass";

        Object[] options = {"OK"};

		incomplete_data_entry = true;
		cancelBtnPressed = false;

		if (NCIEditTab.owl_format == NCIEditTab.BY_CODE)
		{
			hasName = false;
		}

        while (incomplete_data_entry && !cancelBtnPressed)
        {
			panel = createPanel();
			int r = ProtegeUI.getModalDialogFactory().showDialog(tab, panel, title, ModalDialogFactory.MODE_OK_CANCEL);

			if (r == ModalDialogFactory.OPTION_OK )
			{
				if (hasName)
				{
					concept_name = name_field.getText();
			    }
				preferred_name = pt_field.getText();
				definition = def_area.getText();
				superconcept_name = superconcept_field.getText();
				boolean passed = true;

				concept_name.trim();
				preferred_name.trim();
				superconcept_name.trim();
				definition.trim();

				if (hasName) name_field.setText(concept_name);
				pt_field.setText(preferred_name);
				def_area.setText(definition);
				superconcept_field.setText(superconcept_name);

				//Slot codeslot = owlModel.getSlot(tab.getSlotName(NCIEditTab.CODE));
				//if (codeslot != null)
				if (hasName)
				{
					//if (concept_name.indexOf(' ') != -1)
					if (concept_name.compareTo("") == 0)
					{
						try {
							int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry -- class name is mandatory.", "Confirmation",
							JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
							null, options, options[0]);
						}
						catch(Exception ex){
							Log.getLogger().log(Level.WARNING, "Exception caught", ex);
						}
						passed = false;
					}
					else if (!NCIEditFilter.checkXMLNCNameCompliance(concept_name))
					{
						try {
							int ans = JOptionPane.showOptionDialog(this, "Class name format is incorrect.", "Confirmation",
							JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
							null, options, options[0]);
						}
						catch(Exception ex){
							Log.getLogger().log(Level.WARNING, "Exception caught", ex);
						}
						passed = false;
					}
				}

				if (passed && (superconcept_name.compareTo("") == 0 || superconcept_name.compareTo("owl:Thing") == 0))
				{
					try {
						int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry -- superclass is mandatory.", "Confirmation",
						JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
						null, options, options[0]);
					}
					catch(Exception ex){
						Log.getLogger().log(Level.WARNING, "Exception caught", ex);
					}
					passed = false;
				}

				if (passed && preferred_name.compareTo("") == 0)
				{
					try {
					    int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry -- preferred name is mandatory.", "Confirmation",
						JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
						null, options, options[0]);
					}
					catch(Exception ex){
						Log.getLogger().log(Level.WARNING, "Exception caught", ex);
					}
					passed = false;
				}


				if (passed && definition.compareTo("") == 0)
				{
					try {
						int ans = JOptionPane.showOptionDialog(this, "Reminder -- definition has not been provided.", "Confirmation",
						JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
						null, options, options[0]);
					}
					catch(Exception ex){
						Log.getLogger().log(Level.WARNING, "Exception caught", ex);
					}
					//passed = true;
				}

				if (passed)
				{
					concept_name = name_field.getText();
					if (owlModel.getCls(concept_name) != null)
					{
						showConceptExistError(concept_name);
					}
					else
					{
						preferred_name = pt_field.getText();
						definition = def_area.getText();
						superconcept_name = superconcept_field.getText();

						Cls cls = tab.getWrapper().createCls(concept_name, preferred_name, selected_superclass, definition);
						if (cls == null)
						{
							try {
								int ans = JOptionPane.showOptionDialog(this, "Unable to create class.", "Confirmation",
								JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
								null, options, options[0]);
							}
							catch(Exception ex){
								Log.getLogger().log(Level.WARNING, "Exception caught", ex);
							}
							System.out.println("WARNING: Unable to create class " + concept_name);
							break;
						}
						else
						{
							tab.getClassPanel().setSelectedCls(cls);
							incomplete_data_entry = false;
					    }
				    }

					//String code = tab.getWrapper().getCode(cls);
					//String code = tab.getWrapper().getAnnotationPropertyValue(cls, tab.getSlotName(tab.CODE));
					/*
					if (tab.getEditHistory() != null)
					{
						if (code != null && code.compareTo("0") != 0)
						{
							tab.getEditHistory().logEditEvent("Create",
											   concept_name,
											   code,
											   null,
											   null,
											   null);

						}
						else
						{
							tab.getEditHistory().logEditEvent("Create",
											   concept_name,
											   tab.getWrapper().getInternalName(cls),
											   null,
											   null,
											   null);
						}
					}
					*/
				}
			}

			else
			{
				cancelBtnPressed = true;
			}

	    }

	}

    public String getConceptName()
    {
		return concept_name;
	}

    public String getPreferredName()
    {
		return preferred_name;
	}

    public String getSuperconceptName()
    {
		return superconcept_name;
	}

    public Cls getSuperconcept()
    {
		return selected_superclass;
	}


	public JPanel createPanel()
	{

        LabeledComponent lc = null;
		JPanel panel = new JPanel();
		panel.setLocation(450,300);
		panel.setLayout(new BorderLayout());

		superconcept_field = new JTextField(this.superconcept_name);
		superconcept_field.setEditable(false);
		superconcept_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Click the icon on the right to select a superclass", superconcept_field);

		Action createAction =
			new AbstractAction("Select Superclass",
					OWLIcons.getImageIcon(OWLIcons.RDFS_NAMED_CLASS)) {

				public void actionPerformed(ActionEvent e) {
					Collection clses = kb.getRootClses();
					String label = "Select a superclass";
					/*
					Cls cls = DisplayUtilities.pickConcreteCls(selButton, kb, clses);
					if (cls == null)
					{
						System.out.println("cls == null");
					}
					else if (cls.getBrowserText().compareTo("owl:Thing") != 0)
					{
						superconcept_field.setText(cls.getBrowserText());
						selected_superclass = cls;
					}
					*/
					final NCISelectClsesPanel p = new NCISelectClsesPanel((OWLModel) kb, clses);
					int result = ModalDialog.showDialog(superconcept_field, p, label, ModalDialog.MODE_OK_CANCEL);
					if (result == ModalDialogFactory.OPTION_OK)
					{
						Collection c = p.getSelection();
						if (c != null && c.size() > 0)
						{
							Iterator it = c.iterator();
							Object obj = it.next();
							Cls cls = (Cls) obj;
							superconcept_field.setText(cls.getBrowserText());
							selected_superclass = cls;
						}
					}

				}
			};




	    lc.addHeaderButton(createAction);
		panel.add(lc, BorderLayout.NORTH);

        JPanel middle_panel = new JPanel();
        middle_panel.setLayout(new BorderLayout());

        name_field = new JTextField(this.concept_name);

/*
		name_field = new JTextField(this.concept_name);
		name_field.setEditable(true);
		name_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Enter class name", name_field);
		middle_panel.add(lc, BorderLayout.NORTH);

		if (!hasName)
		{
			name_field.setText("");
			name_field.setEnabled(false);
		}
*/

        if (hasName)
        {
			name_field = new JTextField(this.concept_name);
			name_field.setEditable(true);
			name_field.setPreferredSize(new Dimension (300, 20));
			lc = new LabeledComponent("Enter class_name", name_field);
			middle_panel.add(lc, BorderLayout.NORTH);
		}

		pt_field = new JTextField(this.preferred_name);
		pt_field.setEditable(true);
		pt_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Enter preferred name", pt_field);
		middle_panel.add(lc, BorderLayout.CENTER);

		//panel.add(lc, BorderLayout.CENTER);
		panel.add(middle_panel, BorderLayout.CENTER);

		def_area = new JTextArea(this.definition);
		def_area.setEditable(true);
		boolean wrap = true;
		def_area.setLineWrap(wrap);
		def_area.setWrapStyleWord(wrap);

		Component comp = new JScrollPane(def_area);
		comp.setPreferredSize(new Dimension(400, 120));
		lc = new LabeledComponent("Enter definition", comp);

		panel.add(lc, BorderLayout.SOUTH);

		return panel;
   	}


	public void actionPerformed(ActionEvent event)
	{
	 	concept_name = "";
	 	preferred_name = "";
	 	superconcept_name = "";

	 	Object action = event.getSource();
	 	if (action == selButton){
			Collection clses = kb.getRootClses();
			Cls cls = DisplayUtilities.pickConcreteCls(selButton, kb, clses);
			if (cls == null)
			{
				System.out.println("cls == null");
			}
			else
			{
				superconcept_field.setText(cls.getBrowserText());
				selected_superclass = cls;
			}
		}
	}

	public void showConceptExistError(String name)
	{
		Object[] option_array = {"OK"};
		String errorMessage = "Concept " + name + " already exists.";

		int ans = JOptionPane.showOptionDialog(this, errorMessage, "Confirmation",
		JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
		null, option_array, option_array[0]);
	}
}

