package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;

import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;


/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class ModifyRoleDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextField tf, fillerText;
	String separator;

	String role_name;
	String role_value;
	String role_modifier;
	String role_modifier_label;

	int selectedIndex = -1;


	JButton selButton;
	JButton fillerButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	JList kindList;
	JList roleList;

	private DefaultMutableTreeNode dmtn;

	public boolean okButtonPressed = false;


    public ModifyRoleDialog(NCIEditTab tab, KnowledgeBase kb,
                            DefaultMutableTreeNode dmtn)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Modify Restriction", true);
		okButtonPressed = false;
		this.kb = kb;
		this.owlModel = (OWLModel) kb;
		this.tab = tab;
		this.dmtn = dmtn;
		selectedIndex = -1;

        if (dmtn != null)
        {
			TreeItem item = (TreeItem) dmtn.getUserObject();
	 		this.role_name = item.getName();
	 		this.role_value = item.getValue();
	 		this.role_modifier = item.getModifier();

	 		this.role_modifier_label = tab.getOWLWrapper().restrictionType2Label(role_modifier);

	    }
	}

    public String getRestriction()
    {
		return role_name;
	}

    public String getFiller()
    {
		return role_value;
	}

    public String getModifier()
    {
		return role_modifier;
	}


    private Vector getPropertiesList() {
		Vector v = new Vector();
		try {
			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			Collection selectableProperties = new ArrayList();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty property = (RDFProperty) it.next();
				if (!property.isAnnotationProperty()) {
					selectableProperties.add(property);
				    v.add(property.getName());
				}
			}
	    } catch (Exception e) {
			OWLUI.handleError(owlModel, e);
		}

        return v;
    }




	public void init()
	{
		Container contain = this.getContentPane();
		this.setLocation(360,300);
		contain.setLayout(new GridBagLayout());

        edu.stanford.smi.protege.model.Cls[] metaClses = ProfilesManager.getSupportedRestrictionMetaClses((OWLModel) kb);

        kindList = new JList(getBrowserText(metaClses));
		kindList.setSelectedValue(role_modifier_label, true);


        //kindList.setCellRenderer(new RestrictionKindRenderer());
        kindList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        //kindList.setSelectedValue(metaCls, true);
        JScrollPane kindScrollPane = new JScrollPane(kindList);
        //kindScrollPane.setPreferredSize(new Dimension(160, 150));
        kindScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel kindPanel = new JPanel();
        kindPanel.setLayout(new BorderLayout());
        kindPanel.add(BorderLayout.NORTH, new LabeledComponent("Restriction", kindScrollPane));
        kindPanel.add(BorderLayout.CENTER, new JPanel());
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 0;
		contain.add(kindPanel, gridbagconstraints1);

		fillerButton = new JButton("Filler");
		fillerButton.addActionListener(this);
		fillerText = new JTextField(role_value);

		fillerText.setEditable(false);

		fillerText.setPreferredSize(new Dimension (300, 20));
        JPanel middlePanel = new JPanel();
		middlePanel.add(fillerButton, BorderLayout.WEST);
		middlePanel.add(fillerText, BorderLayout.EAST);
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(middlePanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints2 = new GridBagConstraints();
		gridbagconstraints2.gridx = 0;
		gridbagconstraints2.gridy = 2;
		contain.add(buttonPanel, gridbagconstraints2);

        kindList.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                 fillerButton.setEnabled(true);
                 fillerText.setEditable(false);
                 String selected = (String) kindList.getSelectedValue();
                 if (selected.indexOf("Cardinality") != -1)
                 {
					 fillerText.setEditable(true);
                     fillerButton.setEnabled(false);
				 }
            }
        });

		pack();
		this.setVisible(true);
   	}


    private Vector getBrowserText(edu.stanford.smi.protege.model.Cls[] clses)
    {
		Vector v = new Vector();
		for (int i=0; i<clses.length; i++)
		{
            Cls cls = clses[i];
            //v.add(cls.getBrowserText());
            tab.getOWLWrapper().getInternalName((cls));
		}
		return v;
	}


	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton){
			role_modifier = (String) kindList.getSelectedValue();

			role_modifier = tab.getOWLWrapper().getRestrictionType(role_modifier);
			role_value = fillerText.getText();
/*
			TreeItem item = (TreeItem) dmtn.getUserObject();
			item.setName(role_name);
			item.setValue(role_value);
			item.setModifier(role_modifier);
			item.setNameValue(role_name + ": " + role_modifier + " " + role_value);

System.out.println(" ModifyRoleDialog  " + role_name + ": " + role_modifier + " " + role_value);


			dmtn.setUserObject((Object) item);
*/
			okButtonPressed = true;
			dispose();

		} else if (action == fillerButton)	{
			Collection clses = kb.getRootClses();
			Cls cls = DisplayUtilities.pickConcreteCls(fillerButton, kb, clses);
			if (cls == null)
			{
				System.out.println("cls == null");
			}
			else
			{
				fillerText.setText(cls.getBrowserText());
			}

		} else if (action == cancelButton)
			dispose();
	}

}


/*
edu.stanford.smi.protegex.owl.ui.restrictions;
RestrictionEditorPanel

    public static Collection pickSlots(Component component, Collection slots, String label) {
        return pickInstancesFromCollection(component, slots, label);
    }


        edu.stanford.smi.protege.model.Cls[] metaClses = ProfilesManager.getSupportedRestrictionMetaClses(owlModel);
        kindList = new JList(metaClses);
        kindList.setCellRenderer(new RestrictionKindRenderer());
        kindList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        kindList.setSelectedValue(metaCls, true);
        JScrollPane kindScrollPane = new JScrollPane(kindList);
        kindScrollPane.setPreferredSize(new Dimension(160, 150));


    private void updatePropertiesList() {
        Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
        Collection selectableProperties = new ArrayList();
        for (Iterator it = allProperties.iterator(); it.hasNext();) {
            RDFProperty property = (RDFProperty) it.next();
            if (!property.isAnnotationProperty()) {
                selectableProperties.add(property);
            }
        }
        RDFSNamedClass dbrClass = owlModel.getRDFSNamedClass(Model.Cls.DIRECTED_BINARY_RELATION);
        if (targetClass != null && ((Cls) targetClass).hasSuperclass(dbrClass)) {
            RDFProperty fromProperty = owlModel.getRDFProperty(Model.Slot.FROM);
            if (fromProperty.isVisible()) {
                selectableProperties.add(fromProperty);
            }
            RDFProperty toProperty = owlModel.getRDFProperty(Model.Slot.TO);
            if (toProperty.isVisible()) {
                selectableProperties.add(toProperty);
            }
        }
        Object[] propertiesArray = selectableProperties.toArray();
        Arrays.sort(propertiesArray, new FrameComparator());
        java.util.List propertiesList = Arrays.asList(propertiesArray);


        propertyList.setListData(propertiesList.toArray());
    }
*/
