package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.icons.*;

import edu.stanford.smi.protegex.owl.ui.components.triples.AddResourceAction;

import edu.stanford.smi.protegex.owl.ui.components.triples.*;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;



/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class ModifySuperclassDialog extends JDialog
{
	JButton okButton, cancelButton;
	JTextField tf, fillerText;
	String separator;

	JButton selButton;

	OWLModel owlModel;

	NCIEditTab tab;

	public boolean cancelBtnPressed;

	JTextField value_field;
    JCheckBox definingCheckBox;

    boolean defining = false;

    boolean defining_prev = false;

    String name = "";

    private Cls selectedCls = null;
    boolean definingEditable = true;

    boolean modified = false;

    RDFSClass aClass = null;

    boolean isDefinition = false;


    public ModifySuperclassDialog(NCIEditTab tab, String name, RDFSClass aClass, boolean defining, boolean definingEditable)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Modify Named Superclass", true);
		this.tab = tab;
		this.owlModel = tab.getOWLModel();
		this.defining = defining;
		this.defining_prev = defining;

		this.aClass = aClass;


		this.name = name;
		this.definingEditable = definingEditable;
/*

		if (name != null && name.compareTo("") != 0)
		{
			selectedCls = owlModel.getCls(name);
	    }
*/

        selectedCls = null;
        if (aClass != null)
        {
			selectedCls = (Cls) aClass;
		}



		String title = "Modify Named Superclass";
	 	cancelBtnPressed = false;
	 	JPanel panel = createPanel();

		int r = ProtegeUI.getModalDialogFactory().showDialog(tab, panel, title, ModalDialogFactory.MODE_OK_CANCEL);

		if (r == ModalDialogFactory.OPTION_OK) {
			if (selectedCls == null)
			{
				try {
					Object[] options = {"OK"};

					int ans = JOptionPane.showOptionDialog(this, "Incomplete data entry.", "Confirmation",
					JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[0]);
					cancelBtnPressed = true;
					return;
				}
				catch(Exception ex){
					Log.getLogger().log(Level.WARNING, "Exception caught", ex);;
				}
			}
			else
			{
				if (name == null)
				{
					modified = true;
				}
				else
				{
					String selectedClsName = tab.getOWLWrapper().getInternalName(selectedCls);
					if (selectedClsName.compareTo(name) != 0)
					{
						modified = true;
					}
				}

				defining = definingCheckBox.isSelected();

				if (!defining_prev && definingCheckBox.isSelected()) modified = true;
				if (defining_prev && !definingCheckBox.isSelected()) modified = true;
				if (!modified)
				{
					cancelBtnPressed = true;
				}


                isDefinition = defining;
			}
		}
		else
		{
			cancelBtnPressed = true;
		}
	}


    public boolean isCancelled()
    {
		return cancelBtnPressed;
	}


	public JPanel createPanel()
	{
		JPanel panel = new JPanel();
		panel.setLocation(450,300);
		panel.setLayout(new GridLayout(2, 1));

        LabeledComponent lc = null;
        JPanel definingPanel = new JPanel();
        definingPanel.setLayout(new BorderLayout());
        JLabel definingLabel = new JLabel("  Defining");
        definingCheckBox = new JCheckBox();
        definingCheckBox.setSelected(defining);
        definingCheckBox.setEnabled(definingEditable);

        definingPanel.add(definingCheckBox, BorderLayout.WEST);
        definingPanel.add(definingLabel, BorderLayout.CENTER);

		panel.add(definingPanel);

		value_field = new JTextField("");
		value_field.setEditable(false);

		value_field.setText(name);

		value_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Select a superclass", value_field);

		Action SelectPropertyValueAction =
			new AbstractAction("Select a superclass...", OWLIcons.getAddIcon("PrimitiveClass")) {

				public void actionPerformed(ActionEvent e)
				{
					java.awt.TextField textfield = new TextField();
					String label = "Select a property value";

					Collection clses = owlModel.getRootClses();
					Cls cls = DisplayUtilities.pickConcreteCls(textfield, owlModel, clses);
					if (cls == null)
					{
						System.out.println("cls is null");
					}
					else
					{
						//value_field.setText(cls.getBrowserText());
						name = tab.getOWLWrapper().getInternalName(cls);
						value_field.setText(name);
						selectedCls = cls;

					}

				}

			};

	    lc.addHeaderButton(SelectPropertyValueAction);
		panel.add(lc);

		return panel;
   	}

    public boolean getIsDefining()
    {
		return isDefinition;//defining;
	}

    public String getName()
    {
		return name;
	}

    public Cls getCls()
    {
		return selectedCls;
	}
}

