package gov.nih.nci.protegex.edit;
import edu.stanford.smi.protegex.owl.ui.restrictions.*;

import edu.stanford.smi.protege.model.Cls;
import edu.stanford.smi.protege.model.KnowledgeBase;
import edu.stanford.smi.protege.model.Model;
import edu.stanford.smi.protege.ui.FrameComparator;
import edu.stanford.smi.protege.ui.FrameRenderer;
import edu.stanford.smi.protege.util.CollectionUtilities;
import edu.stanford.smi.protege.util.ComponentFactory;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protege.widget.ClsWidget;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.model.impl.OWLUtil;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.code.OWLSymbolPanel;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.ui.search.ResourceListFinder;
import edu.stanford.smi.protegex.owl.ui.owltable.*;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;


import edu.stanford.smi.protege.widget.*;
import edu.stanford.smi.protege.resource.*;
import edu.stanford.smi.protege.ui.*;


import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.InstanceDisplay;
import edu.stanford.smi.protege.util.*;
import edu.stanford.smi.protege.widget.ClsWidget;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protegex.owl.ui.cls.*;
import edu.stanford.smi.protegex.owl.ui.clsdesc.DisjointClassesWidget;
import edu.stanford.smi.protegex.owl.ui.conditions.ConditionsWidget;
import edu.stanford.smi.protegex.owl.ui.icons.OWLIcons;
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.ResourceDisplay;
import edu.stanford.smi.protegex.owl.ui.subsumption.InferredSubsumptionTreePanel;
import edu.stanford.smi.protegex.owl.ui.widget.WidgetUtilities;

import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;
import edu.stanford.smi.protege.resource.*;

import java.io.*;
import java.sql.Connection;
import java.util.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import edu.stanford.smi.protegex.owl.model.RDFSClass;

import edu.stanford.smi.protegex.owl.model.OWLProperty;

////////
import edu.stanford.smi.protegex.owl.ui.resourcedisplay.*;
import edu.stanford.smi.protegex.owl.ui.components.annotations.*;
import edu.stanford.smi.protegex.owl.ui.conditions.*;
import edu.stanford.smi.protegex.owl.ui.icons.*;
import edu.stanford.smi.protegex.owl.ui.owltable.*;
import edu.stanford.smi.protegex.owl.ui.restrictions.*;
import edu.stanford.smi.protegex.owl.ui.widget.OWLUI;


import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.ui.components.triples.*;
import javax.swing.border.*;


import javax.swing.table.DefaultTableModel;
import edu.stanford.smi.protegex.owl.ui.actions.*;

import edu.stanford.smi.protegex.owl.ui.actions.DeletePropertyAction;

import edu.stanford.smi.protegex.owl.ui.actions.ResourceAction;
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;

//053006
import edu.stanford.smi.protegex.owl.ui.ProtegeUI;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditorManager;
import edu.stanford.smi.protegex.owl.ui.dialogs.ModalDialogFactory;
import edu.stanford.smi.protegex.owl.ui.metadata.AnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.editors.PropertyValueEditor;

import edu.stanford.smi.protegex.owl.ui.metadata.DateAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.DateTimeAnnotationsWidgetPlugin;
import edu.stanford.smi.protegex.owl.ui.metadata.TimeAnnotationsWidgetPlugin;



/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class NCIRoleGroupEditorPanel extends JComponent { //implements Validatable {

    private OWLModel owlModel;

    private RDFSClass targetClass = null;

    private Action viewAction;

	RDFProperty property;
	edu.stanford.smi.protege.model.Cls metaCls;

	boolean definingEditable = true;

    NCIEditTab tab;

    OWLWrapper wrapper = null;

    public boolean cancelBtnPressed = false;

    JCheckBox definingCheckBox;
    private boolean defining = false;

    //RDFSClass aClass;
	OWLClass r0;

	Slot slot;

	JButton okButton, cancelButton, hb_add_6, hb_edit_6, hb_delete_6;
    RDFResource subject;

	NCIRoleGroupTableModel	rolegroup_model;
	NCIRoleGroupTable	rolegroup_table;
	NCIConditionsTableModel model;
	OWLNamedClass focusedCls;

	int selIndex = -1;


	//TreePanel treepanel;
    public NCIRoleGroupEditorPanel(NCIEditTab tab, OWLModel owlModel)
    {
        this.metaCls = null;
        this.owlModel = owlModel;
        this.targetClass = targetClass;
        this.tab = tab;
        this.model = null;
        this.selIndex = -1;

        this.rolegroup_table = null;

		this.r0 = null;

		initialize();
	}

    public NCIRoleGroupEditorPanel(NCIEditTab tab, OWLModel owlModel, OWLNamedClass focusedCls, OWLClass r0, boolean defining)
    {
        this.metaCls = null;
        this.owlModel = owlModel;
        this.targetClass = null;
        this.tab = tab;
        this.model = null;
        this.focusedCls = focusedCls;
        this.selIndex = -1;

		this.r0 = r0;
		this.defining = defining;

		initialize();
	}


    public NCIRoleGroupEditorPanel(NCIEditTab tab, OWLModel owlModel, NCIConditionsTableModel model, int selIndex, OWLClass r0)

    {
        this.metaCls = null;
        this.owlModel = owlModel;
        this.targetClass = targetClass;
        this.tab = tab;
        this.model = model;
        this.selIndex = selIndex;

		this.r0 = r0;

		initialize();
	}

    public NCIRoleGroupEditorPanel(NCIEditTab tab, OWLModel owlModel, NCIConditionsTableModel model,
                                   OWLNamedClass focusedCls, int selIndex, OWLClass r0, boolean defining)
    		//RDFSClass aClass, TreePanel treepanel), bo
    {
        this.metaCls = null;
        this.owlModel = owlModel;
        this.targetClass = targetClass;
        this.tab = tab;
        this.model = model;
        this.focusedCls = focusedCls;
        this.selIndex = selIndex;
        this.defining = defining;


		this.r0 = r0;

		initialize();
	}


    public NCIRoleGroupTable getRoleGroupTable()
    {
		return rolegroup_table;
	}

    public NCIRoleGroupTableModel getRoleGroupTableModel()
    {
		return rolegroup_model;
	}

    private void initialize()
    {
		setLocation(260,200);
		setPreferredSize(new Dimension(500, 300));

		setLayout(new BorderLayout());

        subject = focusedCls;

        JPanel panel = new JPanel();
        panel.setLayout(new BorderLayout());

        JPanel definingPanel = new JPanel();
        definingPanel.setLayout(new BorderLayout());

        JLabel definingLabel = new JLabel("  Defining");
        definingCheckBox = new JCheckBox();
        definingCheckBox.setEnabled(definingEditable);

        definingCheckBox.setSelected(defining);
        definingPanel.add(definingCheckBox, BorderLayout.WEST);
        definingPanel.add(definingLabel, BorderLayout.CENTER);

		rolegroup_model = new NCIRoleGroupTableModel(owlModel, (OWLNamedClass) subject, r0);


		rolegroup_table = new NCIRoleGroupTable(owlModel, rolegroup_model);
		rolegroup_model.setTable(rolegroup_table);

		JScrollPane scrollPane = new JScrollPane(rolegroup_table);


		//panel.add(BorderLayout.CENTER, scrollPane);

		panel.add(BorderLayout.CENTER, scrollPane);
		panel.add(BorderLayout.SOUTH, definingPanel);


		//add(scrollPane, BorderLayout.CENTER);

		add(panel, BorderLayout.CENTER);

    }



	public void addRolegroup(OWLRestriction r){

		//OWLRestriction r = rolepanel.getResult();
		if (r == null)
		{
			System.out.println("wrapper.createRestriction returns null. ");
			return;
		}
		rolegroup_model.addRow(r);
	}


	private boolean isSimpleRestriction(HashMap rolegroup_hmap)
	{
		if (rolegroup_hmap.keySet().size() != 1)
		{
			return false;
		}
		Iterator keys = rolegroup_hmap.keySet().iterator();
		while (keys.hasNext()){
			Object key = keys.next();
			Vector v = (Vector) rolegroup_hmap.get(key);
			if (v.size() != 1) return false;
		}
		return true;
	}

	private OWLRestriction getSimpleRestriction(HashMap rolegroup_hmap)
	{
		Iterator keys = rolegroup_hmap.keySet().iterator();
		while (keys.hasNext()){
			Object key = keys.next();
			Vector v = (Vector) rolegroup_hmap.get(key);
			return (OWLRestriction) v.elementAt(0);
		}
		return null;
	}

	//091806
	private boolean containsSimpleRestriction(HashMap rolegroup_hmap)
	{
		Integer zero = new Integer(0);
		//if (rolegroup_hmap.containsKey(zero)) return true;

		Vector v = (Vector) rolegroup_hmap.get(zero);
		if (rolegroup_hmap.containsKey(zero) && v.size()>0)
			return true;


		return false;
	}

	public RDFSClass roleGroupHash2RDFSClass(HashMap rolegroup_hmap)
	{
		if (rolegroup_hmap == null) return null;
		Iterator keys = null;

		Vector key_vec = new Vector();

		keys = rolegroup_hmap.keySet().iterator();
		while (keys.hasNext()){
			Object key = keys.next();
			Vector v = (Vector) rolegroup_hmap.get(key);
			if (v.size() == 0)
			{
				key_vec.add((Integer) key);
			}
		}

		for (int i=0; i<key_vec.size(); i++)
		{
			Integer key_int = (Integer) key_vec.elementAt(i);
			Object obj = rolegroup_hmap.remove((Object) key_int);
		}


		if (isSimpleRestriction(rolegroup_hmap))
		{
			OWLRestriction r = getSimpleRestriction(rolegroup_hmap);
			return (RDFSClass) r;
		}

		try {

			owlModel.beginTransaction("Created local role group", targetClass == null ? null : targetClass.getName());

			int n = rolegroup_hmap.keySet().size();
			// one role group --> intersection class
			if (n == 1)
			{
				OWLIntersectionClass intersectionClass = owlModel.createOWLIntersectionClass();
				keys = rolegroup_hmap.keySet().iterator();
				while (keys.hasNext()){
					Object key = keys.next();
					Vector v = (Vector) rolegroup_hmap.get(key);
					for (int i=0; i<v.size(); i++){
						OWLRestriction r = (OWLRestriction) v.elementAt(i);
						intersectionClass.addOperand(r);
					}
					
					owlModel.commitTransaction();
					return intersectionClass;
				}
			}

			if (!containsSimpleRestriction(rolegroup_hmap))
			{
				OWLUnionClass unionClass = owlModel.createOWLUnionClass();
				keys = rolegroup_hmap.keySet().iterator();
				while (keys.hasNext()) {
					Object key = keys.next();
					Integer groupNo = (Integer) key;
					if (groupNo.intValue() != 0)
					{
						OWLIntersectionClass intersectionClass = owlModel.createOWLIntersectionClass();
						Vector v = (Vector) rolegroup_hmap.get(key);
						for (int i=0; i<v.size(); i++){
							OWLRestriction r = (OWLRestriction) v.elementAt(i);
							intersectionClass.addOperand(r);
						}
						unionClass.addOperand(intersectionClass);
					}
				}
				
				owlModel.commitTransaction();
				return unionClass;
			}


			OWLIntersectionClass intersectionClass = owlModel.createOWLIntersectionClass();

			// simple restrictions:
			keys = rolegroup_hmap.keySet().iterator();
			while (keys.hasNext()) {
				Object key = keys.next();
				Integer groupNo = (Integer) key;
				if (groupNo.intValue() == 0)
				{
					Vector v = (Vector) rolegroup_hmap.get(key);
					for (int i=0; i<v.size(); i++){
						OWLRestriction r = (OWLRestriction) v.elementAt(i);
						intersectionClass.addOperand(r);
					}
				}
				else
				{
					Vector v = (Vector) rolegroup_hmap.get(key);
					if (v.size() == 1)
					{
						OWLRestriction r = (OWLRestriction) v.elementAt(0);
						intersectionClass.addOperand(r);
					}
				}
			}

			// count the number of true role groups
			int m = 0;
			keys = rolegroup_hmap.keySet().iterator();
			while (keys.hasNext()) {
				Object key = keys.next();
				Integer groupNo = (Integer) key;
				if (groupNo.intValue() != 0)
				{
					Vector v = (Vector) rolegroup_hmap.get(key);
					if (v.size() > 1)
					{
						m++;
					}
				}
			}

			if (m == 0)
			{
				owlModel.commitTransaction();
				return (RDFSClass) intersectionClass;
			}

			if (m == 1)
			{
				keys = rolegroup_hmap.keySet().iterator();
				while (keys.hasNext()) {
					Object key = keys.next();
					Integer groupNo = (Integer) key;
					if (groupNo.intValue() != 0)
					{
						Vector v = (Vector) rolegroup_hmap.get(key);
						if (v.size() > 1)
						{
							for (int i=0; i<v.size(); i++){
								OWLRestriction r = (OWLRestriction) v.elementAt(i);
								intersectionClass.addOperand(r);
							}
							
							owlModel.commitTransaction();
							return (RDFSClass) intersectionClass;
						}
					}
				}
			}

			// multiple role groups, need a union class
			OWLUnionClass unionClass = owlModel.createOWLUnionClass();
			keys = rolegroup_hmap.keySet().iterator();
			while (keys.hasNext()) {
				Object key = keys.next();
				Integer groupNo = (Integer) key;
				if (groupNo.intValue() != 0)
				{
					Vector v = (Vector) rolegroup_hmap.get(key);
					if (v.size() > 1)
					{
						OWLIntersectionClass intersectionCls = owlModel.createOWLIntersectionClass();
						for (int i=0; i<v.size(); i++){
							OWLRestriction r = (OWLRestriction) v.elementAt(i);
							intersectionCls.addOperand(r);
						}
						unionClass.addOperand(intersectionCls);
					}
				}
			}
			intersectionClass.addOperand(unionClass);
			
			owlModel.commitTransaction();
			return (RDFSClass) intersectionClass;
		} catch (Exception e) {
			owlModel.rollbackTransaction();
			OWLUI.handleError(owlModel, e);
		}

		return null;
        
	}


	public RDFSClass getRolegroups(){

		HashMap rolegroup_hmap = rolegroup_model.getRolegroups();
		if (rolegroup_hmap.keySet().size() == 0) return null;
		//rolegroup_model.dumpRoleGroup(rolegroup_hmap);
		return roleGroupHash2RDFSClass(rolegroup_hmap);
	}

	public boolean getIsDefining()
	{
		return definingCheckBox.isSelected();
	}

	public NCIEditTab getNCIEditTab()
	{
		return tab;
	}
}
