package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;


import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;

public class NewClsDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JTextField name_field;
	JTextField pt_field;
	NCIEditTab tab;
	private String label;
	private String pt;

	public boolean cancelButtonPressed = false;

    public NewClsDialog(NCIEditTab tab)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Enter Class Identifiers", true);
		this.name_field = new JTextField("");
		this.name_field.setPreferredSize(new Dimension (300, 20));

		this.pt_field = new JTextField("");
		this.pt_field.setPreferredSize(new Dimension (300, 20));

		this.tab = tab;
		this.label = "";
	}

	public String getLabel()
	{
		return label;
	}


	public String getPT()
	{
		return pt;
	}


	public void setTab(NCIEditTab tab)
	{
		this.tab = tab;
	}

	public void init()
	{
		init("", "");
	}

	public void init(String init_name, String init_pt)
	{
		Container contain = this.getContentPane();
		this.setLocation(480,360);
		//this.setLocation(300,200);

	    LabeledComponent lc = null;
		contain.setLayout(new BorderLayout());

		name_field = new JTextField(init_name);

		if (NCIEditTab.owl_format == NCIEditTab.BY_NAME)
		{
			name_field.setEditable(true);
			name_field.setPreferredSize(new Dimension (300, 20));
			lc = new LabeledComponent("Enter class name", name_field);
			contain.add(lc, BorderLayout.NORTH);
	    }

		pt_field = new JTextField(init_pt);
		pt_field.setEditable(true);
		pt_field.setPreferredSize(new Dimension (300, 20));
		lc = new LabeledComponent("Enter preferred name", pt_field);
		contain.add(lc, BorderLayout.CENTER);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints3 = new GridBagConstraints();
		gridbagconstraints3.gridx = 0;
		gridbagconstraints3.gridy = 2;
		contain.add(buttonPanel, BorderLayout.SOUTH);

		pack();
		this.setVisible(true);
   	}

	public void actionPerformed(ActionEvent event)
	{
		cancelButtonPressed = false;
		Object action = event.getSource();
		if (action == okButton){

			pt = pt_field.getText();
			pt = pt.trim();
			pt_field.setText(pt);

			if (NCIEditTab.owl_format == NCIEditTab.BY_NAME)
			{
				label = name_field.getText();
				label = label.trim();
				name_field.setText(label);
	    	}
	    	else
	    	{
				label = pt;
			}

			dispose();

		} else if (action == cancelButton)
		{
			label = "";
			pt = "";
			cancelButtonPressed = true;
			dispose();
		}
	}

}


