package gov.nih.nci.protegex.edit;

import java.awt.* ;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.filechooser.FileFilter;

import javax.swing.tree.*;

import edu.stanford.smi.protege.model.*;
import edu.stanford.smi.protege.ui.*;

import edu.stanford.smi.protegex.owl.ui.profiles.ProfilesManager;
import edu.stanford.smi.protegex.owl.model.*;
import edu.stanford.smi.protege.util.LabeledComponent;
import edu.stanford.smi.protegex.owl.model.impl.DefaultOWLObjectProperty;

import edu.stanford.smi.protege.util.Log;
import java.util.logging.Level;

/**
 *@Author: NGIT, Kim Ong; Iris Guo
 */

public class SelectRoleDialog extends JDialog implements ActionListener
{
	JButton okButton, cancelButton;
	JButton loadButton;
	JTextField tf;
	String separator;

	String role_name;
	String role_value;
	String role_modifier;
	String role_modifier_label;

	int selectedIndex = -1;


	JButton selButton;
	JButton clsButton;
	KnowledgeBase kb;

	OWLModel owlModel;

	NCIEditTab tab;

	JList kindList;
	JList roleList;
	PartonomyPanel partonomyPanel;

	private DefaultMutableTreeNode dmtn;


    public SelectRoleDialog(NCIEditTab tab, KnowledgeBase kb)
    {
		super((JFrame)tab.getTopLevelAncestor(), "Select Transitive Properties", true);
		this.kb = kb;
		this.owlModel = (OWLModel) kb;
		this.tab = tab;
		partonomyPanel = tab.getPartonomyPanel();
		selectedIndex = -1;
		init();

	}

    public String getRestriction()
    {
		return role_name;
	}

    public String getFiller()
    {
		return role_value;
	}

    public String getModifier()
    {
		return role_modifier;
	}


    private Vector getPropertiesList()
    {
		Vector v = new Vector();
		try {
			//for (Iterator it = owlModel.listRDFProperties(); it.hasNext();) {
			Collection allProperties = owlModel.getVisibleUserDefinedRDFProperties();
			for (Iterator it = allProperties.iterator(); it.hasNext();) {
				RDFProperty rdfproperty = (RDFProperty)it.next();

				if (!rdfproperty.isAnnotationProperty()){
					if (rdfproperty instanceof OWLObjectProperty){
						OWLObjectProperty property = (OWLObjectProperty) rdfproperty;
						if (property.isTransitive())
							//v.add(property.getBrowserText());
							v.add(property.getName());
					}
				}
			}
			if (v.size() == 0)
				System.out.println("WARNING: No applicable part of relationship available.");
	    } catch (Exception e) {
			Log.getLogger().log(Level.WARNING, "Exception caught", e);
		}
        return v;
    }

/*
	public void init()
	{
		Container contain = this.getContentPane();

		this.setLocation(360,300);
		//this.setLocationRelativeTo(null);

		contain.setLayout(new GridBagLayout());

		clsButton = new JButton("Root");
		clsButton.addActionListener(this);
		tf = new JTextField();
		if (tab.getSelectedInstance() != null)
		{
			//String sel_cls_name = tab.getSelectedInstance().getBrowserText();
			Cls cls = (Cls) tab.getSelectedInstance();
			String sel_cls_name = tab.getOWLWrapper().getInternalName(cls);

			if (sel_cls_name.compareTo("owl:Thing") != 0)
			{
				//tf.setText(tab.getSelectedInstance().getBrowserText());
				tf.setText(sel_cls_name);
		    }
		}
		tf.setEditable(false);

		tf.setPreferredSize(new Dimension (240, 20));
        JPanel clsPanel = new JPanel();
		clsPanel.add(tf);
		clsPanel.add(clsButton);
		GridBagConstraints gridbagconstraints0 = new GridBagConstraints();
		gridbagconstraints0.gridx = 0;
		gridbagconstraints0.gridy = 0;
		contain.add(clsPanel, gridbagconstraints0);

        roleList = new JList(getPropertiesList());
        //roleList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);



        JScrollPane roleScrollPane = new JScrollPane(roleList);
        roleScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel rolePanel = new JPanel();
        rolePanel.setLayout(new BorderLayout());
        rolePanel.add(BorderLayout.NORTH, new LabeledComponent("Restrictions (Press Ctrl to make multiple selection.)", roleScrollPane));
        rolePanel.add(BorderLayout.CENTER, new JPanel());
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(rolePanel, gridbagconstraints1);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");

        if (getPropertiesList().size() > 0)
        {
			roleList.setSelectedIndex(0);
		}
		else
		{
			okButton.setEnabled(false);
		}

		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		GridBagConstraints gridbagconstraints3 = new GridBagConstraints();
		gridbagconstraints3.gridx = 0;
		gridbagconstraints3.gridy = 2;
		contain.add(buttonPanel, gridbagconstraints3);

		pack();
		this.setVisible(true);
   	}
*/
	public void init()
	{
		Container contain = this.getContentPane();

		this.setLocation(360,300);
		//this.setLocationRelativeTo(null);

		//contain.setLayout(new GridLayout(3, 1));
		contain.setLayout(new BorderLayout());


        JPanel clsPanel = new JPanel();
        clsPanel.setLayout(new BorderLayout());


		clsButton = new JButton("Root");
		clsButton.addActionListener(this);
		tf = new JTextField();
		if (tab.getSelectedInstance() != null)
		{
			//String sel_cls_name = tab.getSelectedInstance().getBrowserText();
			Cls cls = (Cls) tab.getSelectedInstance();
			String sel_cls_name = tab.getOWLWrapper().getInternalName(cls);

			if (sel_cls_name.compareTo("owl:Thing") != 0)
			{
				//tf.setText(tab.getSelectedInstance().getBrowserText());
				tf.setText(sel_cls_name);
		    }
		}
		tf.setEditable(false);

		tf.setPreferredSize(new Dimension (240, 20));

		clsPanel.add(tf, BorderLayout.CENTER);
		clsPanel.add(clsButton, BorderLayout.EAST);

		/*
		GridBagConstraints gridbagconstraints0 = new GridBagConstraints();
		gridbagconstraints0.gridx = 0;
		gridbagconstraints0.gridy = 0;
		*/

		//contain.add(clsPanel, gridbagconstraints0);
		contain.add(clsPanel, BorderLayout.NORTH);

        roleList = new JList(getPropertiesList());
        //roleList.getSelectionModel().setSelectionMode(ListSelectionModel.SINGLE_SELECTION);


        JScrollPane roleScrollPane = new JScrollPane(roleList);
        roleScrollPane.setPreferredSize(new Dimension(300, 150));
        JPanel rolePanel = new JPanel();
        rolePanel.setLayout(new BorderLayout());
        rolePanel.add(BorderLayout.NORTH, new LabeledComponent("Restrictions (Press Ctrl to make multiple selection.)", roleScrollPane));
        rolePanel.add(BorderLayout.CENTER, new JPanel());
        /*
		GridBagConstraints gridbagconstraints1 = new GridBagConstraints();
		gridbagconstraints1.gridx = 0;
		gridbagconstraints1.gridy = 1;
		contain.add(rolePanel, gridbagconstraints1);
		*/

		contain.add(rolePanel, BorderLayout.CENTER);

		JPanel buttonPanel = new JPanel();
		okButton = new JButton("OK");

        if (getPropertiesList().size() > 0)
        {
			roleList.setSelectedIndex(0);
		}
		else
		{
			okButton.setEnabled(false);
		}

		okButton.addActionListener(this);
		cancelButton = new JButton("Cancel");
		cancelButton.addActionListener(this);
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);

		/*
		GridBagConstraints gridbagconstraints3 = new GridBagConstraints();
		gridbagconstraints3.gridx = 0;
		gridbagconstraints3.gridy = 2;
		contain.add(buttonPanel, gridbagconstraints3);
		*/
		contain.add(buttonPanel, BorderLayout.SOUTH);

		pack();
		this.setVisible(true);
   	}


	public void actionPerformed(ActionEvent event)
	{
		Object action = event.getSource();
		if (action == okButton)
		{
            String cls_name = tf.getText();
			Cls cls = tab.getWrapper().getOWLNamedClass(cls_name);
			if (cls == null)
			{
				Object[] options = {"Yes", "No"};
				Object[] option_array = {"OK"};
				int ans = JOptionPane.showOptionDialog(this, "Concept " + cls_name
				+ " not found.", "Confirmation",
				JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
				null, option_array, options[0]);

				return;
			}


			partonomyPanel.draw(tf.getText(), roleList.getSelectedValues());
			dispose();
		}else if (action == cancelButton){
			dispose();
		}else if (action == clsButton)	{
			Collection clses = kb.getRootClses();
			Cls cls = DisplayUtilities.pickConcreteCls(clsButton, kb, clses);
			if (cls == null)
				System.out.println("cls == null");
			else
				//tf.setText(cls.getBrowserText());
				tf.setText(tab.getOWLWrapper().getInternalName(cls));//cls.getBrowserText());
		}
	}

}